#ifndef __USER_PROFILE_H__
#define __USER_PROFILE_H__

#define USER_BUFFER_SIZE	(0x00400000)  // 4 Mbyte
#define MAX_TABLES			(1024)

#if defined(MEI_PLATFORM_WINNT)

#if !defined(USER_PROFILEModuleId)		
#	define	 USER_PROFILEModuleId		(MEIModuleIdLAST)
#endif

typedef enum {
	USER_PROFILEMessageFIRST = mpiMessageID(USER_PROFILEModuleId, 0), /* required */

	USER_PROFILEMessageBUFFER_ALREADY_ALLOCATED,		
	USER_PROFILEMessageBUFFER_NOT_ALLOCATED,		
	USER_PROFILEMessageTABLE_SIZE,		
	USER_PROFILEMessagePROFILE_NOT_LOADED,		
	USER_PROFILEMessagePROFILE_NOT_FOUND,		
	USER_PROFILEMessagePROFILE_TABLE,		
	USER_PROFILEMessageMODIFY_ERROR,		
	USER_PROFILEMessageTOO_LATE,		
	USER_PROFILEMessageOUT_OF_MEMORY,		
	USER_PROFILEMessageLAST										/* required */
} USER_PROFILEMessage;

#endif

typedef struct MoveTime {
	double		Ta;			//Acceleration Time
	double		Td;			//Deceleration Time
} MoveTime;

typedef	struct MPIMotionUSER1Params {
	long		Type;		//Table number
	double		*Distance;	//Relative Distance
	double		*Vmax;		//Maximum Velocity
	MoveTime	*Time;		//Move Times;
} MPIMotionUSER1Params;

typedef struct PVA {
	double p;
	double v;
	double a;
} PVA;

typedef struct MotionTable {
	long	AccelPoints;	//Number of points in Accel profile	
	long	DecelPoints;	//Number of points in Decel profile 	
	PVA		*pva;
} MotionTable;

typedef struct MotionTableFW {
	long	AccelPoints;	//Number of points in Accel profile	
	long	DecelPoints;	//Number of points in Decel profile 	
	PVA		pva[1];
} MotionTableFW;

typedef struct TableEntry {
	MotionTable		*Ptr;
	long			Size;
} TableEntry;

typedef struct TableMemory {
	char		*FreeSpace;
	TableEntry	Table[MAX_TABLES];
} TableMemory;

#if defined(MEI_PLATFORM_WINNT)

void InitUserProfileMessages(void);
long AllocateBuffer(MPIControl control, long BufferSize, MPI_BOOL initialize);
long DownLoadTable(MPIControl control, long TableNumber, MotionTable *Table);
long UpLoadTable(MPIControl control, long TableNumber, MotionTable *Table); // future?
long DeleteTable(MPIControl control, long TableNumber); // future?
long UserMotionExecute(MPIMotion motion, MPIMotionType type, MPIMotionParams *params, MEIXmpAction action);
long ParseFile(const char* FileName, long* FileTableNumber, MotionTable* Table); 

#endif
#endif

