/* adc.h */

/* Copyright(c) 1991-2006 by Motion Engineering, Inc.  All rights reserved.
 *
 * This software  contains proprietary and  confidential information  of
 * Motion Engineering Inc., and its suppliers.  Except as may be set forth
 * in the license agreement under which  this software is supplied, use,
 * disclosure, or  reproduction is prohibited without the prior express
 * written consent of Motion Engineering, Inc.
 */

/*
 *	RCSHeader
 */

#if !defined(_ADC_H)
#define	_ADC_H

/* Adc handle */
#if defined(__cplusplus)
extern "C" {
#endif
typedef struct _MPIAdc *MPIAdc;
#if defined(__cplusplus)
}
#endif

#include "mpidef.h"
#include "control.h"

#if defined(__cplusplus)
extern "C" {
#endif

typedef struct MPIAdcConfig {
	double	range;	/* +/- voltage */
} MPIAdcConfig;

typedef enum {
	MPIAdcMessageFIRST = mpiMessageID(MPIModuleIdADC, 0),

	MPIAdcMessageADC_INVALID,

	MPIAdcMessageLAST
} MPIAdcMessage;

/* Create/Delete/Validate */
MPI_DECL1 MPIAdc MPI_DECL2
	mpiAdcCreate(MPIControl	control,
				 long		number);

MPI_DECL1 long MPI_DECL2
	mpiAdcDelete(MPIAdc adc);

MPI_DECL1 long MPI_DECL2
	mpiAdcValidate(MPIAdc adc);

/* Adc */
MPI_DECL1 long MPI_DECL2
	mpiAdcConfigGet(MPIAdc			adc,
					MPIAdcConfig	*config,
					void			*external);

MPI_DECL1 long MPI_DECL2
	mpiAdcConfigSet(MPIAdc			adc,
					MPIAdcConfig	*config,
					void			*external);

MPI_DECL1 MPIControl MPI_DECL2
	mpiAdcControl(MPIAdc adc);

MPI_DECL1 long MPI_DECL2
	mpiAdcFlashConfigGet(MPIAdc			adc,
						 void			*flash,
						 MPIAdcConfig	*config,
						 void			*external);

MPI_DECL1 long MPI_DECL2
	mpiAdcFlashConfigSet(MPIAdc			adc,
						 void			*flash,
						 MPIAdcConfig	*config,
						 void			*external);

MPI_DECL1 long MPI_DECL2
	mpiAdcInput(MPIAdc			adc,
				unsigned long	*input);

MPI_DECL1 long MPI_DECL2
	mpiAdcMemory(MPIAdc	adc,
				 void	**memory);

MPI_DECL1 long MPI_DECL2
	mpiAdcMemoryGet(MPIAdc	   adc,
					void	   *dst,
					const void *src,
					long	   count);

MPI_DECL1 long MPI_DECL2
	mpiAdcMemorySet(MPIAdc	   adc,
					void	   *dst,
					const void *src,
					long	   count);

MPI_DECL1 long MPI_DECL2
	mpiAdcMotorMapGet(MPIAdc		adc,
					  MPIObjectMap	*motorMap);

MPI_DECL1 long MPI_DECL2
	mpiAdcNumber(MPIAdc	adc,
				 long	*number);

#if defined(__cplusplus)
}
#endif

#endif
