/* client.h */

/* Copyright(c) 1991-2006 by Motion Engineering, Inc.  All rights reserved.
 *
 * This software  contains proprietary and  confidential information  of
 * Motion Engineering Inc., and its suppliers.  Except as may be set forth
 * in the license agreement under which  this software is supplied, use,
 * disclosure, or  reproduction is prohibited without the prior express
 * written consent of Motion Engineering, Inc.
 */

/*
 *	RCSHeader
 */

#if !defined(_CLIENT_H)
#define	_CLIENT_H

#if defined(__cplusplus)
extern "C" {
#endif
typedef struct _MEIClient *MEIClient;
#if defined(__cplusplus)
}
#endif

#include "meidef.h"
#include "control.h"
#include "packet.h"
#include "remote.h"

#if defined(__cplusplus)
extern "C" {
#endif

typedef enum {
	MEIClientMessageFIRST = mpiMessageID(MEIModuleIdCLIENT, 0),

	MEIClientMessageCLIENT_INVALID,
	MEIClientMessageMETHOD_INVALID,
	MEIClientMessageHEADER_INVALID,
	MEIClientMessageMPI_INCOMPATIBLE,
	MEIClientMessageSERVER_INCOMPATIBLE,

	MEIClientMessageLAST
} MEIClientMessage;

typedef enum {
	MEIClientTraceFIRST = MEITraceLAST << 1,

	MEIClientTraceLAST  = MEIClientTraceFIRST << 1
} MEIClientTrace;

/* Create/Delete/Validate */
MPI_DECL1 MEIClient MPI_DECL2
	meiClientCreate(MPIControl control);

MPI_DECL1 long MPI_DECL2
	meiClientDelete(MEIClient client);

MPI_DECL1 long MPI_DECL2
	meiClientValidate(MEIClient client);

/* Client */
MPI_DECL1 MPIControl MPI_DECL2
	meiClientControl(MEIClient	client);

MPI_DECL1 long MPI_DECL2
	meiClientError(MEIClient client,
				   long *error);

MPI_DECL1 long MPI_DECL2
	meiClientMethod(MEIClient client,
					MEIRemoteMethod method,
					MEIRemoteMethodArgs *args);

MPI_DECL1 MEIPacket MPI_DECL2
	meiClientPacket(MEIClient client);

#if defined(__cplusplus)
}
#endif

#endif
