/* firmware.h */

/* Copyright(c) 1991-2006 by Motion Engineering, Inc.  All rights reserved.
 *
 * This software  contains proprietary and  confidential information  of
 * Motion Engineering Inc., and its suppliers.  Except as may be set forth
 * in the license agreement under which  this software is supplied, use,
 * disclosure, or  reproduction is prohibited without the prior express
 * written consent of Motion Engineering, Inc.
 */

/*
 *	RCSHeader
 */

#if !defined(_FIRMWARE_H)
#define _FIRMWARE_H

/*
 *	This file declares the generic interface between the
 *	MEI library and the firmware.
 *
 *	This file is included by meidef.h, which is in turn
 *	included by all MEI header and source files.
 */

/*
 *	This file is firmware-specific
 */

#include "meidef.h"
#include "command.h"
#include "event.h"

#include "xmp.h"
#include "xmpcan.h"
#include "xmpcanbl.h"

#if defined(__cplusplus)
extern "C" {
#endif

MPI_DECL1 MEIXmpAction MPI_DECL2
	meiXmpActionFromMPIAction(MPIAction action);

MPI_DECL1 MPIAction MPI_DECL2
	meiXmpActionToMPIAction(MEIXmpAction action);

MPI_DECL1 MEIXmpCommandCode MPI_DECL2
	meiXmpCommandCodeFromMPICommandOperator(MPICommandOperator oper,
											MPICommandType type);

MPI_DECL1 MEIXmpEvent MPI_DECL2
	meiXmpEventFromMPIEventType(MPIEventType event);

MPI_DECL1 MPIEventType MPI_DECL2
	meiXmpBlockEventToMPIEventType(MEIXmpBlockEvent event);

MPI_DECL1 MPIEventType MPI_DECL2
	meiXmpEventToMPIEventType(MEIXmpEvent event);

MPI_DECL1 MEIXmpLimit MPI_DECL2
	meiXmpLimitFromMPIEventType(MPIEventType event);

MPI_DECL1 MPIEventType MPI_DECL2
	meiXmpLimitToMPIEventType(MEIXmpLimit limit);

MPI_DECL1 MEIXmpMotorType MPI_DECL2
	meiXmpMotorTypeFromMPIMotorType(MPIMotorType type);

MPI_DECL1 MPIMotorType MPI_DECL2
	meiXmpMotorTypeToMPIMotorType(MEIXmpMotorType type);

MPI_DECL1 MPIModuleId MPI_DECL2
	meiXmpSignalIDToMPIModuleId(MEIXmpSignalID signalID);

#define meiXmpSignalIDToMEIXmpEvent(signalID) \
			((MEIXmpEvent)((signalID) & MEIXmpSignalID_STATUS))

#define meiXmpSignalIDToNUMBER(signalID) \
			(((signalID) & MEIXmpSignalID_INDEX) >> 16)

MPI_DECL1 MEIXmpStatus MPI_DECL2
	meiXmpStatusFromMPIAction(MPIAction action,
							MPIModuleId	moduleId);

MPI_DECL1 MEIXmpStatus MPI_DECL2
	meiXmpStatusFromMPIEventMask(MPIEventMask eventMask,
								MPIModuleId	moduleId);

MPI_DECL1 MPIAction MPI_DECL2
	meiXmpStatusToMPIAction(MEIXmpStatus status,
							MPIModuleId	moduleId);

MPI_DECL1 void MPI_DECL2
	meiXmpStatusToMPIEventMask(MEIXmpStatus status,
								MPIEventMask *eventMask,
								MPIModuleId	moduleId);

MPI_DECL1 void MPI_DECL2
	meiXmpStatusToMPIStatus(MEIXmpStatus status,
							MPIModuleId	moduleId,
							MPIStatus *statusMPI);

MPI_DECL1 MPIEventType MPI_DECL2
	meiXmpSynqNetEventToMPIEventType(MEIXmpSynqNetEvent event);

MPI_DECL1 MPIEventType MPI_DECL2
	meiXmpSystemEventToMPIEventType(MEIXmpSystemEvent event);

MPI_DECL1 long MPI_DECL2
	_xmpSynqNetInternalStateToMEISynqNetMessage(MEIXmpSynqNetInternalState internalState);



#if defined(__cplusplus)
}
#endif

#endif
