/* list.h */

/* Copyright(c) 1991-2006 by Motion Engineering, Inc.  All rights reserved.
 *
 * This software  contains proprietary and  confidential information  of
 * Motion Engineering Inc., and its suppliers.  Except as may be set forth
 * in the license agreement under which  this software is supplied, use,
 * disclosure, or  reproduction is prohibited without the prior express
 * written consent of Motion Engineering, Inc.
 */

/*
 *	RCSHeader
 */

#if !defined(_LIST_H)
#define	_LIST_H

/* List handle */
#if defined(__cplusplus)
extern "C" {
#endif
typedef struct _MEIList *MEIList;
#if defined(__cplusplus)
}
#endif

#include "meidef.h"
#include "element.h"

#if defined(__cplusplus)
extern "C" {
#endif

typedef enum {
	MEIListMessageFIRST = mpiMessageID(MEIModuleIdLIST, 0),

	MEIListMessageLIST_INVALID,
	MEIListMessageELEMENT_NOT_FOUND,
	MEIListMessageELEMENT_INVALID,

	MEIListMessageLAST
} MEIListMessage;

typedef enum {
	MEIListTraceFIRST = MEITraceLAST << 1,

	MEIListTraceLAST  = MEIListTraceFIRST << 1
} MEIListTrace;

/* Create/Delete/Validate */
MPI_DECL1 MEIList MPI_DECL2
	meiListCreate(MEIElement element);

MPI_DECL1 long MPI_DECL2
	meiListDelete(MEIList list);

MPI_DECL1 long MPI_DECL2
	meiListValidate(MEIList list);

/* List */
MPI_DECL1 long MPI_DECL2
	meiListAppend(MEIList list,
				  MEIElement element);

MPI_DECL1 long MPI_DECL2
	meiListCount(MEIList list);

MPI_DECL1 MEIElement MPI_DECL2
	meiListElement(MEIList list,
				   long index);

MPI_DECL1 MEIElement MPI_DECL2
	meiListFind(MEIList list,
				void *object);

MPI_DECL1 MEIElement MPI_DECL2
	meiListFirst(MEIList list);

MPI_DECL1 long MPI_DECL2
	meiListIndex(MEIList list,
				 MEIElement element);

MPI_DECL1 long MPI_DECL2
	meiListInsert(MEIList list,
				  MEIElement element,
				  MEIElement insert);

MPI_DECL1 MEIElement MPI_DECL2
	meiListLast(MEIList list);

MPI_DECL1 MEIElement MPI_DECL2
	meiListPop(MEIList list);

MPI_DECL1 long MPI_DECL2
	meiListPush(MEIList list,
				MEIElement element);

MPI_DECL1 long MPI_DECL2
	meiListRemove(MEIList list,
				  MEIElement element);

#if defined(__cplusplus)
}
#endif

#endif
