/* meiDeprecated.h */

/* Copyright(c) 1991-2006 by Motion Engineering, Inc.  All rights reserved.
 *
 * This software  contains proprietary and  confidential information  of
 * Motion Engineering Inc., and its suppliers.  Except as may be set forth
 * in the license agreement under which  this software is supplied, use,
 * disclosure, or  reproduction is prohibited without the prior express
 * written consent of Motion Engineering, Inc.
 */

/*
 *	RCSHeader
 */

#if !defined(_MEIDEPRECATED_H)
#define	_MEIDEPRECATED_H

#include "stdmei.h"

#if defined(__cplusplus)
extern "C" {
#endif

/*
 *	All methods in this header file have been marked as deprecated. 
 *
 *	The MPI has been restructured and modified, with new methods that 
 *  provide similar functionality. Whenever possible, you should modify 
 *	your application to remove references to deprecated methods, and 
 *  use the new alternatives offered as part of the MPI.  
 */

/* can */

typedef struct MEICanDigitalIO {
    unsigned long data[2];
} MEICanDigitalIO;

/* these methods renamed for interface consistency */
MPI_DECL1 long MPI_DECL2
    meiCanFlashNodeConfigGet(MEICan            can,
                             void*             flash,
                             long              node,
                             MEICanNodeConfig* nodeConfig);

MPI_DECL1 long MPI_DECL2
    meiCanFlashNodeConfigSet(MEICan            can,
                             void*             flash,
                             long              node,
                             MEICanNodeConfig* nodeConfig);
MPI_DECL1 long MPI_DECL2
    meiCanNodeDigitalInputGet(MEICan can,
                              long   node,
                              long   bit,
                              long*  data);

MPI_DECL1 long MPI_DECL2
    meiCanNodeDigitalInputsGet(MEICan           can,
                               long             node,
                               MEICanDigitalIO* data);

MPI_DECL1 long MPI_DECL2
    meiCanNodeDigitalOutputGet(MEICan can,
                               long   node,
                               long   bit,
                               long*  data);

MPI_DECL1 long MPI_DECL2
    meiCanNodeDigitalOutputSet(MEICan can,
                               long   node,
                               long   bit,
                               long   data);

MPI_DECL1 long MPI_DECL2
    meiCanNodeDigitalOutputsGet(MEICan           can,
                                long             node,
                                MEICanDigitalIO* data);

MPI_DECL1 long MPI_DECL2
    meiCanNodeDigitalOutputsSet(MEICan           can,
                                long             node,
                                MEICanDigitalIO* data);

MPI_DECL1 long MPI_DECL2
    meiCanNodeAnalogInputGet(MEICan  can,
                             long    node,
                             long    index,
                             double* data);

MPI_DECL1 long MPI_DECL2
    meiCanNodeAnalogOutputGet(MEICan  can,
                              long    node,
                              long    index,
                              double* data);

MPI_DECL1 long MPI_DECL2
    meiCanNodeAnalogOutputSet(MEICan can,
                              long   node,
                              long   index,
                              double data);

/* control */
/* for backwards compatability only (always returns zero) */
MPI_DECL1 long MPI_DECL2
	meiControlEnabledLmbGet(MPIControl	control,
							long		*count);
/* for backwards compatability only (does nothing) */
MPI_DECL1 long MPI_DECL2
	meiControlEnabledLmbSet(MPIControl	control,
							long		*count);

#define MPIControlIoWords       (1)

typedef struct MPIControlIo {
	unsigned long   input[MPIControlIoWords];
	unsigned long   output[MPIControlIoWords];
} MPIControlIo;

MPI_DECL1 long MPI_DECL2
	mpiControlIoGet(MPIControl   control,
					MPIControlIo *io);

MPI_DECL1 long MPI_DECL2
	mpiControlIoSet(MPIControl   control,
					MPIControlIo *io);

MPI_DECL1 long MPI_DECL2
	meiControlIoBitGet(MPIControl			control,
					   MEIControlIoBit		bit, 
					   MPI_BOOL				*value);

MPI_DECL1 long MPI_DECL2
	meiControlIoBitSet(MPIControl			control,
					   MEIControlIoBit		bit,	
					   MPI_BOOL				*value);

/* motor */
typedef enum {
	MEIMotorDedicatedInAMP_FAULT		   =	 MEIXmpMotorDedicatedFlagsMaskAMP_FAULT,		/* bit 0	*/
	MEIMotorDedicatedInBRAKE_APPLIED	   =	 MEIXmpMotorDedicatedFlagsMaskBRAKE_ON,			/* bit 1	*/
	MEIMotorDedicatedInHOME				   =	 MEIXmpMotorDedicatedFlagsMaskHOME,				/* bit 2	*/
	MEIMotorDedicatedInLIMIT_HW_POS		   =	 MEIXmpMotorDedicatedFlagsMaskPOS_LIMIT,		/* bit 3	*/
	MEIMotorDedicatedInLIMIT_HW_NEG		   =	 MEIXmpMotorDedicatedFlagsMaskNEG_LIMIT,		/* bit 4	*/
	MEIMotorDedicatedInINDEX_PRIMARY	   =	 MEIXmpMotorDedicatedFlagsMaskENC_INDEX0,		/* bit 5	*/
	MEIMotorDedicatedInFEEDBACK_FAULT	   =	 MEIXmpMotorDedicatedFlagsMaskENC_FAULT,		/* bit 6	*/
	MEIMotorDedicatedInCAPTURED			   =	 MEIXmpMotorDedicatedFlagsMaskCAPTURED,			/* bit 7	*/
	MEIMotorDedicatedInHALL_A			   =	 MEIXmpMotorDedicatedFlagsMaskHALL_A,			/* bit 8	*/
	MEIMotorDedicatedInHALL_B			   =	 MEIXmpMotorDedicatedFlagsMaskHALL_B,			/* bit 9	*/
	MEIMotorDedicatedInHALL_C			   =	 MEIXmpMotorDedicatedFlagsMaskHALL_C,			/* bit 10	*/
	MEIMotorDedicatedInAMP_ACTIVE		   =	 MEIXmpMotorDedicatedFlagsMaskAMP_ACTIVE,		/* bit 11	*/
	MEIMotorDedicatedInINDEX_SECONDARY	   =	 MEIXmpMotorDedicatedFlagsMaskENC_INDEX1,		/* bit 12	*/
	MEIMotorDedicatedInWARNING			   =	 MEIXmpMotorDedicatedFlagsMaskWARNING,			/* bit 13	*/
	MEIMotorDedicatedInDRIVE_STATUS_9	   =	 MEIXmpMotorDedicatedFlagsMaskDRIVE_STATUS9,	/* bit 14	*/
	MEIMotorDedicatedInDRIVE_STATUS_10	   =	 MEIXmpMotorDedicatedFlagsMaskDRIVE_STATUS10	/* bit 15	*/
} MEIMotorDedicatedIn;

typedef enum {
	MEIMotorInputOVERTRAVEL_POS	= MEIMotorDedicatedInLIMIT_HW_POS,
	MEIMotorInputOVERTRAVEL_NEG	= MEIMotorDedicatedInLIMIT_HW_NEG,
	MEIMotorInputHOME			= MEIMotorDedicatedInHOME,
	MEIMotorInputAMP_FAULT		= MEIMotorDedicatedInAMP_FAULT,
	MEIMotorInputINDEX			= MEIMotorDedicatedInINDEX_PRIMARY
} MEIMotorInput;

typedef enum {
	MEIMotorDedicatedOutAMP_ENABLE		 = MEIXmpMotorDedicatedFlagsMaskAMP_ENABLE,	   /* bit 0 */
	MEIMotorDedicatedOutBRAKE_RELEASE	 = MEIXmpMotorDedicatedFlagsMaskBRAKE_RELEASE  /* bit 1 */
} MEIMotorDedicatedOut;

#define MEIMotorDedicatedInOVERTRAVEL_POS	MEIMotorDedicatedInLIMIT_HW_POS
#define MEIMotorDedicatedInOVERTRAVEL_NEG	MEIMotorDedicatedInLIMIT_HW_NEG
#define	MEIMotorDedicatedInINDEX			MEIMotorDedicatedInINDEX_PRIMARY

typedef enum MEIMotorGeneralIo {
	MEIMotorGeneralIoINVALID = -1,

	MEIMotorGeneralIo0,
	MEIMotorGeneralIo1,
	MEIMotorGeneralIo2,
	MEIMotorGeneralIo3,
	MEIMotorGeneralIo4,
	MEIMotorGeneralIo5,
	MEIMotorGeneralIo6,
	MEIMotorGeneralIo7,
	MEIMotorGeneralIo8,
	MEIMotorGeneralIo9,
	MEIMotorGeneralIo10,
	MEIMotorGeneralIo11,
	MEIMotorGeneralIo12,
	MEIMotorGeneralIo13,
	MEIMotorGeneralIo14,
	MEIMotorGeneralIo15,

	MEIMotorGeneralIoLAST,
	MEIMotorGeneralIoFIRST = MEIMotorGeneralIoINVALID + 1
} MEIMotorGeneralIo;

typedef enum {
	MEIMotorIoMask0		 =	0x00010000,	/* bit 16 */
	MEIMotorIoMask1  	 =	0x00020000, /* bit 17 */
	MEIMotorIoMask2  	 =	0x00040000, /* bit 18 */
	MEIMotorIoMask3  	 =	0x00080000, /* bit 19 */
	MEIMotorIoMask4  	 =	0x00100000, /* bit 20 */
	MEIMotorIoMask5		 =	0x00200000, /* bit 21 */
	MEIMotorIoMask6 	 =	0x00400000, /* bit 22 */
	MEIMotorIoMask7  	 =	0x00800000, /* bit 23 */
	MEIMotorIoMask8  	 =	0x01000000, /* bit 24 */
	MEIMotorIoMask9  	 =	0x02000000, /* bit 25 */
	MEIMotorIoMask10 	 =	0x04000000, /* bit 26 */
	MEIMotorIoMask11 	 =	0x08000000, /* bit 27 */
	MEIMotorIoMask12 	 =	0x10000000, /* bit 28 */
	MEIMotorIoMask13 	 =	0x20000000, /* bit 29 */
	MEIMotorIoMask14 	 =	0x40000000, /* bit 30 */
	MEIMotorIoMask15 	 =	0x80000000  /* bit 31 */
} MEIMotorIoMask;

typedef struct MPIMotorIo {
	unsigned long	input;
	unsigned long	output;
} MPIMotorIo;

MPI_DECL1 long MPI_DECL2
	mpiMotorIoGet(MPIMotor		motor,
				  MPIMotorIo	*io);

MPI_DECL1 long MPI_DECL2
	mpiMotorIoSet(MPIMotor		motor,
				  MPIMotorIo	*io);
	
MPI_DECL1 long MPI_DECL2
	mpiMotorFeedbackGet(MPIMotor	motor,		/* use mpiMotorFeedback(...) */
						double		*feedback);


/* path */

/*
 *	PathConfig deprecated in favor of PathParams.
 */
#define	MPIPathConfig		MPIPathParams
#define	mpiPathConfigGet	mpiPathParamsGet
#define	mpiPathConfigSet	mpiPathParamsSet


/* platform.h */
MPI_DECL1 MEIPlatform MPI_DECL2
	meiPlatformCreate(MPIControl control);

MPI_DECL1 long MPI_DECL2
	meiPlatformDelete(MEIPlatform platform);


/* stdmei.h */

/*
 * MEIFilterDataType changed to simply MEIDataType
 * so that other MPI methods can use the data type enum
 */
#define	MEIFilterDataTypeINVALID	(MEIDataTypeINVALID)
#define	MEIFilterDataTypeCHAR		(MEIDataTypeCHAR)
#define	MEIFilterDataTypeSHORT		(MEIDataTypeSHORT)
#define	MEIFilterDataTypeUSHORT		(MEIDataTypeUSHORT)
#define	MEIFilterDataTypeLONG		(MEIDataTypeLONG)
#define	MEIFilterDataTypeULONG		(MEIDataTypeULONG)
#define	MEIFilterDataTypeFLOAT		(MEIDataTypeFLOAT)
#define	MEIFilterDataTypeDOUBLE		(MEIDataTypeDOUBLE)
#define	MEIFilterDataTypeLAST		(MEIDataTypeLAST)
#define	MEIFilterDataTypeFIRST		(MEIDataTypeFIRST)

/* replaced by MEIControlInfo */
typedef struct MEIControlVersion {
	struct {	/* control.c */
		char	*version;	/* MEIControlVersionMPI (YYYYMMDD) */

		struct {	/* xmp.h */
			long	version;	/* MEIXmpVERSION */
			long	option;		/* MEIXmpOPTION */
		} firmware;
	} mpi;

	struct {
		long	version;	/* hardware version */

		struct {	/* MEIXmpData.SystemData{} */
			long	version;		/* MEIXmpVERSION_EXTRACT(SoftwareID) */
			char	revision;		/* ('A' - 1) + MEIXmpREVISION_EXTRACT(SoftwareID) */
			long	subRevision;	/* MEIXmpSUB_REV_EXTRACT(Option) */
			long	developmentId;	/* MEIXmpDEVELOPMENT_ID_EXTRACT(Option) */
			long	option;			/* MEIXmpOPTION_EXTRACT(Option) */
			long	userVersion;
			long    branchId;
		} firmware;

		struct {
			struct	{
				long	version;
				long	option;
			} PLD;
			struct {
				char number[10];
				char rev[5];
			} model;
			struct	{
				long	version;
			} FPGA;
		} board;
	} xmp;

	struct {
		char version[10];
	} driver;

} MEIControlVersion;

MPI_DECL1 long MPI_DECL2
	meiControlVersionGet(MPIControl			control,
						 MEIControlVersion	*version);

MPI_DECL1 long MPI_DECL2
	meiControlVersionSet(MPIControl			control,
						 MEIControlVersion	*version);


/* synqnet.h */
#define	MEISynqNetMessageNODE_UNAVAILABLE	(MEISqNodeMessageNODE_INVALID)
#define	MEISynqNetMessageRESPONSE_TIMEOUT	(MEISqNodeMessageRESPONSE_TIMEOUT)
#define MEISynqNetMessageREADY_TIMEOUT		(MEISqNodeMessageREADY_TIMEOUT)
#define	MEISynqNetMessageSRVC_ERROR			(MEISqNodeMessageSRVC_ERROR)
#define	MEISynqNetMessageSRVC_UNSUPPORTED	(MEISqNodeMessageSRVC_UNSUPPORTED)

#define MEISynqNetMaxMotorENCODER_COUNT		(MEISynqNetMaxMotorFEEDBACK_COUNT)		/*  2 */

/* sqNode.h */
MPI_DECL1 long MPI_DECL2
	meiSqNodeAnalogInput(MEISqNode	node,
					  long		channel,
					  double	*state);

/* sqNodeLib Files */

/* amc_digiflex.h */
#define DIGIFLEXMotorIoCOUNT (16)

typedef enum {
	DIGIFLEXMotorIoTypeINPUT	= MEIMotorIoTypeINPUT,	
	DIGIFLEXMotorIoTypeOUTPUT	= MEIMotorIoTypeOUTPUT
} DIGIFLEXMotorIoType;

typedef	enum {
	DIGIFLEXMotorIoMaskUSER_OUT0		= MEIMotorIoMask0,
	DIGIFLEXMotorIoMaskUSER_OUT1		= MEIMotorIoMask1,
	DIGIFLEXMotorIoMaskUSER_OUT2		= MEIMotorIoMask2,
	DIGIFLEXMotorIoMaskUSER_OUT3		= MEIMotorIoMask3,
	DIGIFLEXMotorIoMaskUSER_IN0			= MEIMotorIoMask4,
	DIGIFLEXMotorIoMaskUSER_IN1			= MEIMotorIoMask5,
	DIGIFLEXMotorIoMaskUSER_IN2			= MEIMotorIoMask6,
	DIGIFLEXMotorIoMaskUSER_IN3			= MEIMotorIoMask7,
										
	DIGIFLEXMotorIoMaskVIRTUAL_OUT0		= MEIMotorIoMask8,
	DIGIFLEXMotorIoMaskVIRTUAL_OUT1		= MEIMotorIoMask9,
	DIGIFLEXMotorIoMaskVIRTUAL_OUT2		= MEIMotorIoMask10,
	DIGIFLEXMotorIoMaskVIRTUAL_OUT3		= MEIMotorIoMask11,
	DIGIFLEXMotorIoMaskVIRTUAL_IN0		= MEIMotorIoMask12,
	DIGIFLEXMotorIoMaskVIRTUAL_IN1		= MEIMotorIoMask13,
	DIGIFLEXMotorIoMaskVIRTUAL_IN2		= MEIMotorIoMask14,
	DIGIFLEXMotorIoMaskVIRTUAL_IN3		= MEIMotorIoMask15
} DIGIFLEXMotorIoMask;					 			 

/* glentek_omega.h */
#define GLENTEKMotorIoCOUNT (9)

typedef enum {
	GLENTEKMotorIoTypeINPUT		= MEIMotorIoTypeINPUT,	
	GLENTEKMotorIoTypeOUTPUT	= MEIMotorIoTypeOUTPUT
} GLENTEKMotorIoType;

typedef	enum {
	GLENTEKMotorIoMaskTX0		= MEIMotorIoMask0,
	GLENTEKMotorIoMaskTX1		= MEIMotorIoMask1,
	GLENTEKMotorIoMaskOUT0		= MEIMotorIoMask2,
	GLENTEKMotorIoMaskRX0		= MEIMotorIoMask3,
	GLENTEKMotorIoMaskRX1	  	= MEIMotorIoMask4,
	GLENTEKMotorIoMaskNONE		= MEIMotorIoMask5,
	GLENTEKMotorIoMaskIN0	  	= MEIMotorIoMask6,
	GLENTEKMotorIoMaskOUT1  	= MEIMotorIoMask7,
	GLENTEKMotorIoMaskIN1	  	= MEIMotorIoMask8
} GLENTEKMotorIoMask;

/* kollmorgen_cd.h */
#define CDMotorIoCOUNT (16)

typedef enum {
	CDMotorIoTypeOUTPUT			= MEIMotorIoTypeOUTPUT,
	CDMotorIoTypePULSE_A		= MEIMotorIoTypeSOURCE1,
	CDMotorIoTypePULSE_B		= MEIMotorIoTypeSOURCE2,
	CDMotorIoTypeINPUT			= MEIMotorIoTypeINPUT
} CDMotorIoType;

typedef	enum {
	CDMotorIoMaskDIFF_I_O1	= MEIMotorIoMask0,
	CDMotorIoMaskDIFF_I_O2  = MEIMotorIoMask1,
	CDMotorIoMaskFPGA_DBN	= MEIMotorIoMask2,
	CDMotorIoMaskIN_04 	   	= MEIMotorIoMask3,
	CDMotorIoMaskIN_05 	    = MEIMotorIoMask4,
	CDMotorIoMaskIN_06		= MEIMotorIoMask5,
	CDMotorIoMaskIN_07 	    = MEIMotorIoMask6,
	CDMotorIoMaskIN_08	  	= MEIMotorIoMask7,
	CDMotorIoMaskIN_09 	    = MEIMotorIoMask8,
	CDMotorIoMaskIN_10 	   	= MEIMotorIoMask9,
	CDMotorIoMaskIN_11 	   	= MEIMotorIoMask10,
	CDMotorIoMaskDOUT1 		= MEIMotorIoMask11,
	CDMotorIoMaskDOUT2 	   	= MEIMotorIoMask12,
	CDMotorIoMaskDOUT3 	    = MEIMotorIoMask13,
	CDMotorIoMaskDOUT4 		= MEIMotorIoMask14,
	CDMotorIoMaskDOUT5 	    = MEIMotorIoMask15
} CDMotorIoMask;					 			 

/* kollmorgen_dasa.h */
#define DASAMotorIoCOUNT (16)

typedef enum {
	DASAMotorIoTypeINPUT		= MEIMotorIoTypeINPUT,	
	DASAMotorIoTypeOUTPUT		= MEIMotorIoTypeOUTPUT
} DASAMotorIoType;

typedef	enum {
	DASAMotorIoMaskIO_0    	= MEIMotorIoMask0,
	DASAMotorIoMaskIO_1    	= MEIMotorIoMask1,
	DASAMotorIoMaskIO_2 	= MEIMotorIoMask2,
	DASAMotorIoMaskIO_3   	= MEIMotorIoMask3,
	DASAMotorIoMaskIO_4     = MEIMotorIoMask4,
	DASAMotorIoMaskIO_5		= MEIMotorIoMask5,
	DASAMotorIoMaskIO_6     = MEIMotorIoMask6,
	DASAMotorIoMaskIO_7  	= MEIMotorIoMask7,
	DASAMotorIoMaskIO_8     = MEIMotorIoMask8,
	DASAMotorIoMaskIO_9   	= MEIMotorIoMask9,
	DASAMotorIoMaskIO_10   	= MEIMotorIoMask10,
	DASAMotorIoMaskIO_11	= MEIMotorIoMask11,
	DASAMotorIoMaskIO_12   	= MEIMotorIoMask12,
	DASAMotorIoMaskIO_13    = MEIMotorIoMask13,
	DASAMotorIoMaskIO_14	= MEIMotorIoMask14,
	DASAMotorIoMaskIO_15    = MEIMotorIoMask15
} DASAMotorIoMask;

/* kollmorgen_picodad.h */
#define PICODADMotorIoCOUNT (12)

typedef enum {
	PICODADMotorIoTypeINPUT			= MEIMotorIoTypeINPUT,	
	PICODADMotorIoTypeOUTPUT		= MEIMotorIoTypeOUTPUT
} PICODADMotorIoType;

typedef	enum {
	PICODADMotorIoMaskIO_0  = MEIMotorIoMask0,
	PICODADMotorIoMaskIO_1  = MEIMotorIoMask1,
	PICODADMotorIoMaskIO_2 	= MEIMotorIoMask2,
	PICODADMotorIoMaskIO_3  = MEIMotorIoMask3,
	PICODADMotorIoMaskIO_4	= MEIMotorIoMask4,
	PICODADMotorIoMaskIO_5	= MEIMotorIoMask5,
	PICODADMotorIoMaskIO_6	= MEIMotorIoMask6,
	PICODADMotorIoMaskIO_7  = MEIMotorIoMask7,
	PICODADMotorIoMaskIO_8	= MEIMotorIoMask8,
	PICODADMotorIoMaskIO_9  = MEIMotorIoMask9,
	PICODADMotorIoMaskIO_10 = MEIMotorIoMask10,
	PICODADMotorIoMaskIO_11	= MEIMotorIoMask11,
	PICODADMotorIoMaskIO_12 = MEIMotorIoMask12,
	PICODADMotorIoMaskIO_13	= MEIMotorIoMask13,
	PICODADMotorIoMaskIO_14	= MEIMotorIoMask14,
	PICODADMotorIoMaskIO_15	= MEIMotorIoMask15
} PICODADMotorIoMask;

/* mei_rmb.h */
#define RMBMotorIoCOUNT		 (8)
#define RMB_SGDGMotorIoCOUNT (12)

typedef enum {
	RMBMotorIoTypeINVALID	= -1,

	RMBMotorIoTypeOUTPUT,
	RMBMotorIoTypePULSE_A,
	RMBMotorIoTypePULSE_B,
	RMBMotorIoTypeCOMPARE_0,
	RMBMotorIoTypeCOMPARE_1,
	RMBMotorIoTypeSOURCE_5,
	RMBMotorIoTypeBRAKE,
	RMBMotorIoTypeSSI_CLOCK0,
	RMBMotorIoTypeSSI_CLOCK1,
	
	RMBMotorIoTypeINPUT	=	0x10
} RMBMotorIoType;	

typedef	enum {
	RMBMotorIoMaskXCVR_A		= MEIMotorIoMask0,
	RMBMotorIoMaskXCVR_B		= MEIMotorIoMask1,
	RMBMotorIoMaskXCVR_C		= MEIMotorIoMask2,
	RMBMotorIoMaskOPTO_0_IN		= MEIMotorIoMask6,
	RMBMotorIoMaskOPTO_0_OUT	= MEIMotorIoMask7,						 
	RMBMotorIoMaskOPTO_1_IN		= MEIMotorIoMask8,
	RMBMotorIoMaskOPTO_1_OUT	= MEIMotorIoMask9,	
	RMBMotorIoMaskOPTO_2_IN		= MEIMotorIoMask10,
	RMBMotorIoMaskOPTO_2_OUT	= MEIMotorIoMask11
} RMBMotorIoMask;					 			 

/* soonhan_io2k.h */
#define IO2KMotorIoCOUNT		 (16)

typedef enum {
	IO2KMotorIoTypeINPUT			= MEIMotorIoTypeINPUT,	
	IO2KMotorIoTypeOUTPUT			= MEIMotorIoTypeOUTPUT
} IO2KMotorIoType;

typedef	enum {
	IO2KMotorIoMaskTX_0          	= MEIMotorIoMask0,
	IO2KMotorIoMaskTX_1          	= MEIMotorIoMask1,
	IO2KMotorIoMaskGP_OPTO_OUT_0 	= MEIMotorIoMask2,
	IO2KMotorIoMaskGP_OPTO_OUT_1 	= MEIMotorIoMask3,
	IO2KMotorIoMaskGP_OPTO_IN_0  	= MEIMotorIoMask4,
	IO2KMotorIoMaskGP_OPTO_IN_1  	= MEIMotorIoMask5,								 
	IO2KMotorIoMaskGP_OPTO_IN_2 	= MEIMotorIoMask6,
	IO2KMotorIoMaskGP_OPTO_IN_3  	= MEIMotorIoMask7,						 
	IO2KMotorIoMaskAMPRST          	= MEIMotorIoMask8,
	IO2KMotorIoMaskGP_OPTO_OUT_2 	= MEIMotorIoMask9,	
	IO2KMotorIoMaskGP_OPTO_OUT_3  	= MEIMotorIoMask10,
	IO2KMotorIoMaskGP_OPTO_IN_4  	= MEIMotorIoMask11,	  
	IO2KMotorIoMaskGP_OPTO_IN_5  	= MEIMotorIoMask12,
	IO2KMotorIoMaskGP_OPTO_IN_6  	= MEIMotorIoMask13,
	IO2KMotorIoMaskGP_OPTO_IN_7  	= MEIMotorIoMask14,
	IO2KMotorIoMaskGP_OPTO_IN_8  	= MEIMotorIoMask15
} IO2KMotorIoMask;					 			 

/* trust_ta800.h */
#define TA800MotorIoCOUNT		 (16)

typedef enum {
	TA800MotorIoTypeOUTPUT			= MEIMotorIoTypeOUTPUT,
	TA800MotorIoTypePULSE_A			= MEIMotorIoTypeSOURCE1,
	TA800MotorIoTypePULSE_B			= MEIMotorIoTypeSOURCE2,
	TA800MotorIoTypeINPUT			= MEIMotorIoTypeINPUT
} TA800MotorIoType;

typedef	enum {
	/* These following defines are applicable to the TA801 and TA802 series */
	TA800MotorIoMaskXCVR_A		= MEIMotorIoMask0,
	TA800MotorIoMaskXCVR_B		= MEIMotorIoMask1,
	TA800MotorIoMaskXCVR_C		= MEIMotorIoMask2,
	TA800MotorIoMaskXCVR_D		= MEIMotorIoMask3,
	TA800MotorIoMaskHSCAP		= MEIMotorIoMask4,
	TA800MotorIoMaskHALL_A		= MEIMotorIoMask5,
	TA800MotorIoMaskHALL_B  	= MEIMotorIoMask6,
	TA800MotorIoMaskHALL_C		= MEIMotorIoMask7,
	TA800MotorIoMaskDTS_0	  	= MEIMotorIoMask8,
	TA800MotorIoMaskDTS_1		= MEIMotorIoMask9,
	TA800MotorIoMaskUSER_OUT  	= MEIMotorIoMask10,
	TA800MotorIoMaskTEMP_LO		= MEIMotorIoMask11,
	TA800MotorIoMaskTEMP_HI		= MEIMotorIoMask12,

	/* The following defines are applicable to the TA805, TA806, and TA807 series */
	TA800MotorIoMaskIO0			= MEIMotorIoMask0,
	TA800MotorIoMaskIO1			= MEIMotorIoMask1,
	TA800MotorIoMaskIO2			= MEIMotorIoMask2,
	TA800MotorIoMaskIO3			= MEIMotorIoMask3,
	TA800MotorIoMaskIO4			= MEIMotorIoMask4,
	TA800MotorIoMaskIO5			= MEIMotorIoMask5,
	TA800MotorIoMaskIO6			= MEIMotorIoMask6,
	TA800MotorIoMaskIO7			= MEIMotorIoMask7,
	TA800MotorIoMaskIO8  		= MEIMotorIoMask8,
	TA800MotorIoMaskIO9			= MEIMotorIoMask9,
	TA800MotorIoMaskIO10  		= MEIMotorIoMask10,
	TA800MotorIoMaskIO11		= MEIMotorIoMask11,
	TA800MotorIoMaskIO12		= MEIMotorIoMask12,
	TA800MotorIoMaskIO13		= MEIMotorIoMask13,
	TA800MotorIoMaskIO14		= MEIMotorIoMask14,
	TA800MotorIoMaskIO15		= MEIMotorIoMask15
} TA800MotorIoMask;

/* yaskawa_sgds.h */
#define SGDSMotorIoCOUNT (3)

typedef	enum {
	SGDSMotorIoMaskOPTOA_IN		= MEIMotorIoMask6,
	SGDSMotorIoMaskOPTOA_OUT	= MEIMotorIoMask7,
	SGDSMotorIoMaskOPTOB_IN		= MEIMotorIoMask8
} SGDSMotorIoMask;

typedef enum {
	SGDSMotorIoTypeINPUT		= MEIMotorIoTypeINPUT,	
	SGDSotorIoTypeOUTPUT		= MEIMotorIoTypeOUTPUT
} SGDSMotorIoType;

/* yaskawa_sgdz_md.h */
#define SGDZMDMotorIoCOUNT (6)

typedef enum {
	SGDZMDMotorIoTypeINPUT			= MEIMotorIoTypeINPUT,	
	SGDZMDMotorIoTypeOUTPUT		= MEIMotorIoTypeOUTPUT
} SGDZMDMotorIoType;

typedef	enum {
	SGDZMDMotorIoMaskOPTOA_IN		= MEIMotorIoMask0,
	SGDZMDMotorIoMaskOPTOA_OUT		= MEIMotorIoMask1,
	SGDZMDMotorIoMaskOPTOB_IN		= MEIMotorIoMask2,
	SGDZMDMotorIoMaskOPTOB_OUT		= MEIMotorIoMask3,
	SGDZMDMotorIoMaskOPTOC_IN		= MEIMotorIoMask4,
	SGDZMDMotorIoMaskOPTOC_OUT		= MEIMotorIoMask5								 
} SGDZMDMotorIoMask;					 			 					    

#if defined(__cplusplus)
}
#endif

#endif
