/* message.h */

/* Copyright(c) 1991-2006 by Motion Engineering, Inc.  All rights reserved.
 *
 * This software  contains proprietary and  confidential information  of
 * Motion Engineering Inc., and its suppliers.  Except as may be set forth
 * in the license agreement under which  this software is supplied, use,
 * disclosure, or  reproduction is prohibited without the prior express
 * written consent of Motion Engineering, Inc.
 */

/*
 *	RCSHeader
 */

#if !defined(_MESSAGE_H)
#define	_MESSAGE_H

#include "mpidef.h"

#if defined(__cplusplus)
extern "C" {
#endif

/* General messages */
typedef enum {
	MPIMessageINVALID = -1,

	MPIMessageOK,

	MPIMessageARG_INVALID,
	MPIMessagePARAM_INVALID,
	MPIMessageHANDLE_INVALID,

	MPIMessageNO_MEMORY,

	MPIMessageOBJECT_FREED,
	MPIMessageOBJECT_NOT_ENABLED,
	MPIMessageOBJECT_NOT_FOUND,
	MPIMessageOBJECT_ON_LIST,
	MPIMessageOBJECT_IN_USE,

	MPIMessageTIMEOUT,

	MPIMessageUNSUPPORTED,
	MPIMessageFATAL_ERROR,

	MPIMessageFILE_CLOSE_ERROR,
	MPIMessageFILE_OPEN_ERROR,
	MPIMessageFILE_READ_ERROR,
	MPIMessageFILE_WRITE_ERROR,
	MPIMessageFILE_MISMATCH,


	MPIMessageLAST,
	MPIMessageFIRST = MPIMessageINVALID + 1
} MPIMessage;

#define MPIMessageTextMAX_CHARS (512)

/* Pointer to function returning const char * */
typedef const char *(*MPIMessageFunction)(long);

#define	mpiMessageID(module,number)	\
			((long)((((module) & MPIModuleIdMAX) << 8) | \
				    ((number) & 0xFF)))

#define	mpiMessageMODULE(messageId)	\
			(((messageId) & (MPIModuleIdMAX << 8)) >> 8)

#define	mpiMessageNUMBER(messageId)	((messageId) & 0xFF)

MPI_DECL1 const char * MPI_DECL2
	mpiMessage(long	messageId,
			   char	*messageText);

MPI_DECL1 long MPI_DECL2
	mpiMessageFunction(MPIModuleId			moduleId,
					   MPIMessageFunction	function);

#if defined(__cplusplus)
}
#endif

#endif
