/* notify.h */

/* Copyright(c) 1991-2006 by Motion Engineering, Inc.  All rights reserved.
 *
 * This software  contains proprietary and  confidential information  of
 * Motion Engineering Inc., and its suppliers.  Except as may be set forth
 * in the license agreement under which  this software is supplied, use,
 * disclosure, or  reproduction is prohibited without the prior express
 * written consent of Motion Engineering, Inc.
 */

/*
 *	RCSHeader
 */

#if !defined(_NOTIFY_H)
#define	_NOTIFY_H

/* Notify source */
#if defined(__cplusplus)
extern "C" {
#endif
typedef struct _MPINotify *MPINotify;
#if defined(__cplusplus)
}
#endif

#include "mpidef.h"
#include "event.h"

#if defined(__cplusplus)
extern "C" {
#endif

typedef enum {
	MPINotifyMessageFIRST = mpiMessageID(MPIModuleIdNOTIFY, 0),

	MPINotifyMessageNOTIFY_INVALID,
	MPINotifyMessageWAIT_IN_PROGRESS,

	MPINotifyMessageLAST
} MPINotifyMessage;

/* Create/Delete/Validate */
MPI_DECL1 MPINotify MPI_DECL2
	mpiNotifyCreate(MPIEventMask	mask,
					void			*source);

MPI_DECL1 long MPI_DECL2
	mpiNotifyDelete(MPINotify notify);

MPI_DECL1 long MPI_DECL2
	mpiNotifyValidate(MPINotify notify);

/* Notify */
MPI_DECL1 long MPI_DECL2
	mpiNotifyEvent(MPINotify		notify,
				   MPIEventStatus	*status);

MPI_DECL1 long MPI_DECL2
	mpiNotifyEventFlush(MPINotify notify);

MPI_DECL1 long MPI_DECL2
	mpiNotifyEventMaskGet(MPINotify		notify,
						  MPIEventMask	*mask);

MPI_DECL1 long MPI_DECL2
	mpiNotifyEventMaskSet(MPINotify		notify,
						  MPIEventMask	mask);

MPI_DECL1 long MPI_DECL2
	mpiNotifyEventWait(MPINotify		notify,
					   MPIEventStatus	*status,
					   MPIWait			timeout);

MPI_DECL1 long MPI_DECL2
	mpiNotifyEventWake(MPINotify		notify,
					   MPIEventStatus	*status);

/* List */
MPI_DECL1 void * MPI_DECL2
	mpiNotifySource(MPINotify	notify,
					long		index);

MPI_DECL1 long MPI_DECL2
	mpiNotifySourceAppend(MPINotify notify,
						  void		*source);

MPI_DECL1 long MPI_DECL2
	mpiNotifySourceCount(MPINotify notify);

MPI_DECL1 void * MPI_DECL2
	mpiNotifySourceFirst(MPINotify notify);

MPI_DECL1 long MPI_DECL2
	mpiNotifySourceIndex(MPINotify notify,
						 void *source);

MPI_DECL1 long MPI_DECL2
	mpiNotifySourceInsert(MPINotify notify,
						  void		*source,
						  void		*insert);

MPI_DECL1 void * MPI_DECL2
	mpiNotifySourceLast(MPINotify notify);

MPI_DECL1 long MPI_DECL2
	mpiNotifySourceListGet(MPINotify	notify,
						   long			*sourceCount,
						   void			**sourceList);

MPI_DECL1 long MPI_DECL2
	mpiNotifySourceListSet(MPINotify	notify,
						   long			sourceCount,
						   void			**sourceList);

MPI_DECL1 void * MPI_DECL2
	mpiNotifySourceNext(MPINotify	notify,
						void		*source);

MPI_DECL1 void * MPI_DECL2
	mpiNotifySourcePrevious(MPINotify	notify,
							void		*source);

MPI_DECL1 long MPI_DECL2
	mpiNotifySourceRemove(MPINotify notify,
						  void		*source);

#if defined(__cplusplus)
}
#endif

#endif
