/* packet.h */

/* Copyright(c) 1991-2006 by Motion Engineering, Inc.  All rights reserved.
 *
 * This software  contains proprietary and  confidential information  of
 * Motion Engineering Inc., and its suppliers.  Except as may be set forth
 * in the license agreement under which  this software is supplied, use,
 * disclosure, or  reproduction is prohibited without the prior express
 * written consent of Motion Engineering, Inc.
 */

/*
 *	RCSHeader
 */

#if !defined(_PACKET_H)
#define	_PACKET_H

#if defined(__cplusplus)
extern "C" {
#endif
typedef struct _MEIPacket *MEIPacket;
#if defined(__cplusplus)
}
#endif

#include "meidef.h"

#if defined(__cplusplus)
extern "C" {
#endif

typedef enum {
	MEIPacketMessageFIRST = mpiMessageID(MEIModuleIdPACKET, 0),

	MEIPacketMessagePACKET_INVALID,
	MEIPacketMessageADDRESS_INVALID,
	MEIPacketMessageCOMM_ERROR,
	MEIPacketMessageCONNECTION_CLOSED,
	MEIPacketMessageRECV_ERROR,
	MEIPacketMessageSEND_ERROR,

	MEIPacketMessageLAST
} MEIPacketMessage;

typedef enum {
	MEIPacketTraceFIRST = MEITraceLAST << 1,

	MEIPacketTraceCLIENT = MEIPacketTraceFIRST << 0,
	MEIPacketTraceSERVER = MEIPacketTraceFIRST << 1,
	MEIPacketTraceRECV	 = MEIPacketTraceFIRST << 2,
	MEIPacketTraceSEND	 = MEIPacketTraceFIRST << 3,

	MEIPacketTraceLAST  = MEIPacketTraceFIRST << 4
} MEIPacketTrace;

/* Create/Delete/Validate */
MPI_DECL1 MEIPacket MPI_DECL2
	meiPacketCreate(void);

MPI_DECL1 long MPI_DECL2
	meiPacketDelete(MEIPacket packet);

MPI_DECL1 long MPI_DECL2
	meiPacketValidate(MEIPacket packet);

/* Packet */
MPI_DECL1 long MPI_DECL2
	meiPacketClient(MEIPacket  packet,
					const char *server,
					long       port);

MPI_DECL1 long MPI_DECL2
	meiPacketClose(MEIPacket packet);

MPI_DECL1 long MPI_DECL2
	meiPacketError(MEIPacket packet,
				   long *error);

MPI_DEF1 long MPI_DEF2
	meiPacketReconnect(MEIPacket packet);

MPI_DECL1 long MPI_DECL2
	meiPacketRecv(MEIPacket packet,
				  char      *buffer,
				  long      byteCount,
				  long      *bytesRead,
				  MPI_BOOL  swapBytes);

MPI_DECL1 long MPI_DECL2
	meiPacketSend(MEIPacket  packet,
				  const char *buffer,
				  long       byteCount,
				  MPI_BOOL   swapBytes);

MPI_DECL1 long MPI_DECL2
	meiPacketServer(MEIPacket packet,
					long port,
					MEIPacket client);

MPI_DECL1 long MPI_DECL2
	meiPacketTransportGet(MEIPacket packet,
						  long		*transport);

MPI_DECL1 long MPI_DECL2
	meiPacketTransportSet(MEIPacket packet,
						  long		transport);

#if defined(__cplusplus)
}
#endif

#endif
