/* xmp.h */

/* Copyright(c) 1991-2006 by Motion Engineering, Inc.  All rights reserved.
 *
 * This software  contains proprietary and  confidential information  of
 * Motion Engineering Inc., and its suppliers.  Except as may be set forth
 * in the license agreement under which  this software is supplied, use,
 * disclosure, or  reproduction is prohibited without the prior express
 * written consent of Motion Engineering, Inc.
 */

/*
 *	RCSHeader
 */

#if !defined (__MEI_XMP__)
#define __MEI_XMP__

#if defined(__cplusplus)
extern "C" {
#endif


/* #defines and enums */

#define MEIXmpVERSION				642		/* version, 200 = 2.00 */
#define MEIXmpOPTION				0

/* Macro's for extracting Version, Option, Dev. ID, Rev. and Sub-rev. from
SystemData.SoftwareID and SystemData.Option */

/* Version = MEIXmpVERSION_EXTRACT(Xmp.SystemData.SoftwareID); */
#define MEIXmpVERSION_EXTRACT(x)			((x) >> 4)
/* Option = MEIXmpOPTION_EXTRACT(Xmp.SystemData.Option); */
#define MEIXmpOPTION_EXTRACT(x)				((x) & 0xFFF)
/* DevID = MEIXmpDEVELOPMENT_ID_EXTRACT(Xmp.SystemData.Option); */
#define MEIXmpDEVELOPMENT_ID_EXTRACT(x)		(((x) & 0x8000) >> 15)
/* Revision = MEIXmpREVISION_EXTRACT(Xmp.SystemData.SoftwareID); */
#define MEIXmpREVISION_EXTRACT(x)			((x) & 0x0F)
/* Option = MEIXmpSUB_REV_EXTRACT(Xmp.SystemData.Option); */
#define MEIXmpSUB_REV_EXTRACT(x) 			(((x) & 0x7000) >> 12)

#define MEIXmpMWVERSION_MAJOR_EXTRACT(x)			(((x) >> 24) & 0xFF)
#define MEIXmpMWVERSION_MINOR_EXTRACT(x)			(((x) >> 16) & 0xFF)
#define MEIXmpMWVERSION_MINOR_SUBREV_EXTRACT(x)	((x) & 0xFFFF)

#define	MEIXmpPROCESSOR_PERIOD		(25.0E-9) /* 40 MHz */
#define MEIXmpPROCESSOR_CLKS_PER_SEC	(40000000)

/* XMP Memory definitions (Internal, External, Flash, PLD, Rincon  */
#define	MEIXmpPageBASE				(0x00028000)
#define	MEIXmpAuxPageBASE  			(0x00023000)
#define	MEIXmpAuxPageSIZE  			(0x1000)	/* 32 bit words */
#define	MEIXmpExtMemBASE			(0x00400000)
#define MEIXmpExtMemSIZE			(64*1024)	/* 32-bit words */
#define	MEIXmpExtMemSynqNetBASE		(0x0041C000)
#define MEIXmpPldMemBASE			(0x00500000)
#define MEIXmpPldMemSIZE			(0x00040000)
#define MEIXmpRinconRegBASE			(0x00550000)
#define MEIXmpRinconUpstreamFaultThreasholdBASE		(0x00550100)
#define MEIXmpRinconUpstreamFailThreasholdBASE		(0x00550200)
#define MEIXmpRinconUpstreamErrorCounterBASE		(0x00550300)
#define MEIXmpRinconUpstreamErrorRateCounterBASE	(0x00550400)
#define	MEIXmpFlashBASE				(0x00600000)
#define MEIXmpRinconControlIO		(0x00550006)
	/* warning: use "4", not sizeof(long) in the following #defines, since sizeof(long) = 1 for
	ADSP compilers */
#define MEIXmpFlashPages			(16)								/* Maximum flash size */
#define MEIXmpFlashPageSIZE			(16*1024)							/* 32-bit words */

#define MEIXmpCodeBoot0INIT_SIZE	(0x4000/sizeof(long))				/* 32-bit words */
#define	MEIXmpFlashCodeBoot0BASE	(MEIXmpFlashBASE)					/* bytes */

#define MEIXmpCodeBootINIT_SIZE		(2 * MEIXmpFlashPageSIZE)			/* 32-bit words */
#define	MEIXmpFlashCodeBootBASE		(MEIXmpFlashBASE)					/* bytes */

#define MEIXmpCodeMainINIT_SIZE		(2 * MEIXmpFlashPageSIZE)
#define MEIXmpFlashCodeMainBASE		(MEIXmpFlashCodeBootBASE + 4*MEIXmpCodeBootINIT_SIZE)

#define MEIXmpIntMemINIT_SIZE 		(1 * MEIXmpFlashPageSIZE)			/* 32-bit words */
#define	MEIXmpFlashIntMemBASE		(MEIXmpFlashCodeMainBASE + 4*MEIXmpCodeMainINIT_SIZE)	/* bytes */

#define MEIXmpExtMemINIT_SIZE		(6 * MEIXmpFlashPageSIZE)			/* 32-bit words */
#define	MEIXmpFlashExtMemBASE		(MEIXmpFlashIntMemBASE + 4*MEIXmpIntMemINIT_SIZE)	/* bytes */

#define MEIXmpExtMemSynqNetINIT_SIZE	(1 * MEIXmpFlashPageSIZE)		/* 32-bit words */
#define MEIXmpFlashExtMemSynqNetBASE	(MEIXmpFlashExtMemBASE + 4*MEIXmpExtMemINIT_SIZE)	/* bytes */

#define MEIXmpMiscINIT_SIZE			(1 * MEIXmpFlashPageSIZE)		/* 32-bit words */
#define MEIXmpFlashMiscBASE			(MEIXmpFlashExtMemSynqNetBASE + 4*MEIXmpExtMemSynqNetINIT_SIZE)	/* bytes */

#define MEIXmpFPGA_SIZE				(3 * MEIXmpFlashPageSIZE)			/* 32-bit words */
#define	MEIXmpFlashFPGA0_BASE		(MEIXmpFlashMiscBASE + 4*MEIXmpMiscINIT_SIZE)	/* bytes */

/* ZMP Memory definitions (Internal, External, Flash, PLD, Rincon  */
#define	MEIZmpPageBASE				(0x000A0000)
#define	MEIZmpAuxPageBASE  			(0x000C0000)
#define	MEIZmpAuxPageSIZE  			(0x4000)		/* 32 bit words */
#define	MEIZmpExtMemBASE			(0x000D0000)
#define MEIZmpExtMemSIZE			(64*1024)		/* 32-bit words */
#define MEIZmpPldMemBASE			(0x7BFC0000)
#define MEIZmpPldMemSIZE			(0x00040000)	/* double check this */
#define MEIZmpRinconRegBASE			(0x7C000000)
#define MEIZmpRinconUpstreamFaultThreasholdBASE		(0x7C000400)
#define MEIZmpRinconUpstreamFailThreasholdBASE		(0x7C000800)
#define MEIZmpRinconUpstreamErrorCounterBASE		(0x7C000C00)
#define MEIZmpRinconUpstreamErrorRateCounterBASE	(0x7C001000)
#define	MEIZmpFlashBASE				(0xFFF00000)
#define MEIZmpRinconControlIO		(0x7C000018)	/* double check this */
#define MEIZmpRinconMemBASE			(0x01000000)

/* Main XMP #defines */
#define	MEIXmpPciVENDOR_ID			(0xC0FE)
#define	MEIXmpPciDEVICE_ID			(0xBABE)
#define MEIXmpSIGNATURE				(0xC0FFEE)
#define MEIXmpFW_DISABLE			(0xCAFEBABE)
#define MEIXmpSIM4_FLASH_LOAD		(0xF00D)
#define	MEIXmpMAXControlIOWords		(1)
#define MEIXmpMaxMotionBlocks		(32)
#define MEIXmpMaxSynqNetBlocks		(32)
#define MEIXmpMaxSynqNets			(1)
#define	MEIXmpMAX_Axes				(32)
#define MEIXmpMAX_Domains			(MEIXmpMAX_Axes + 1)
#define MEIXmpMAX_MSs				(34)
#define MEIXmpMAX_Motors			(32)
#define MEIXmpMAX_Recorders			(32)
#define MEIXmpMAX_Probes			(32)
#define MEIXmpMaxSports				(2)
#define MEIXmpMaxMotionBlocksPerSport		(MEIXmpMaxMotionBlocks/MEIXmpMaxSports)
#define MEIXmpMAX_Filters			(32)
#define MEIXmpMAX_PSs				(16)
#define MEIXmpMAX_Demands			(MEIXmpMAX_Motors)
#define MEIXmpMAX_Demands_Per_Motor	(4)
#define	MEIXmpDefaultEnabled_Motors	(8)
#define	MEIXmpDefaultEnabled_Axes	(8)
#define MEIXmpDefaultEnabled_MSs 	(8)
#define MEIXmpDefaultEnabled_Filters (8)
#define MEIXmpDefaultEnabled_PSs 	(0)
#define MEIXmpDefaultEnabled_Pre 	(0)
#define MEIXmpDefaultEnabled_Comp 	(0)
#define MEIXmpDefaultEnabled_Recorders	(1)
#define MEIXmpDefaultEnabled_Records	(16384)
#define MEIXmpDefaultTRIGGERED_MODIFY_ESTOP_Decel	(10000)		/* Counts/(Sample*Sample) */
#define MEIXmpMAX_PreFilters		(8)
#define MEIXmpMAX_PreCoeffs			(16)
#define MEIXmpMAX_PreBuffSize		(128)
#define MEIXmpMAX_PostFilterSize	(32)
#define MEIXmpMAX_Compensators		(12)
#define MEIXmpMAXCompDimensions		(2)
#define	MEIXmpMAX_COORD_AXES		(32)
#define	MEIXmpMAX_COORD_AXES_Obsolete		(16)
#define MEIXmpMAX_MESSAGES			(128)
#define MEIXmpMaxCapturesPerMotor	(2)
#define MEIXmpMaxComparesPerMotor	(2)
#define MEIXmpMaxCaptures			(32)
#define MEIXmpMaxCompares			(16)
#define MEIXmpCommandSize			(10)
#define MEIXmpCmdBuffSize			(256)
#define MEIXmpLimitConditions	   	(2)
#define MEIXmpMotorMAX_MODES		(2)
#define MEIXmpFrameBufferSize		(128)
#define MEIXmpMotorFilterInputs	 	(2)
#define	MEIXmpMotorEncoders			(2)
#define	MEIXmpMotorADCInputs		(2)
#define	MEIXmpMotorStatusOutputs	(3)
#define MEIXmpCommDACs				(2)
#define MEIXmpAxisPosInputs 		(2)
#define MEIXmpFilterAxisInputs 	 	(2)
#define MEIXmpFilterCoeffSize	 	(20)
#define MEIXmpSignalInfoWords		(3)
#define MEIXmpSignalUserData		(10)
#define MEIXmpFRACTIONAL_UNITY 		(0x40000000)
#define MEIXmpFILTER_SCALE			(1 << 24)
#define MEIXmpMaxRecSize			(32)
#define MEIXmpDFilterSize			(8)
#define MEIXmpMaxGainTables			(5)
#define MEIXmpMotorsPerBlock		(8)
#define MEIXmpLookupCmds			(4)
#define	MEIXmpMaxGates				(32)
#define	MEIXmpLimitLookupSize		(32)
#define MEIXmpLimitBufferMax		(64)
#define MEIXmpFeatureMaskSize		(2)
#define MEIXmpMaxRecorderTriggers	(2)
#define MEIXmpMaxProbesPerMotor		(8)
/* FPGA Resource MAX defines */
#define MEIXmpFPGA_MAXPinBlocks		(32)
#define MEIXmpFPGA_MAXADCs			(8)
#define MEIXmpStepCommandCountMAX	(4)

#define MEIXmpUserDataSize			(1024)
#define MEIXmpDACGain				(3.05185E-4)	/* (10.0/32767.0) volts/count */
#define MEIXmpVolatileBufferSize	(256)
#define MEIXmpMaxDelay				(256)
#define MEIXmpMaxUserModifies		(3)

/* Host transfer control bit definitions */
#define MEIXmpTRANSFER_COUNT		0x003F
#define MEIXmpWRITE_REQUEST			0x2000

/* Service Control structs and enums */
typedef enum {
	MEIXmpSynqNetServiceStateDISABLED = 0,
	MEIXmpSynqNetServiceStateIDLE = 1,
	MEIXmpSynqNetServiceStateDONE_PENDING = 2,
	MEIXmpSynqNetServiceStateCLEAR_PENDING = 3
} MEIXmpSynqNetServiceState;

typedef struct
{	long Response;
	long Error;
} MEIXmpServiceStatus;

typedef struct
{	long Address;
	long Data;					/* if SubCount is > 1, then there will be subsequent pieces of data following this word */
} MEIXmpServiceCommand;

#define MEIXmpServiceCommandGeneralFlagsSubCountMASK			(0x07FF)
#define MEIXmpServiceCommandGeneralFlagsAddressIncrementMASK	(0xF800)
#define MEIXmpServiceCommandGeneralFlagsFlagsMASK				(0xFFFF0000)
#define MEIXmpServiceCommandGeneralFlagsAddressIncrementSHIFT	(11)
typedef struct
{	long Flags;					/* 0x7FF bits are the SubCount, 0xF800 bits are the AddressIncrement */
	MEIXmpServiceCommand Command;
} MEIXmpServiceCommandGeneral;

typedef struct
{	long Count;		/* Initialized to 0 */
	long SubCount;	/* Initialized to 0 */
	MEIXmpSynqNetServiceState State;	/* Initialized to MEIXmpSynqNetServiceStateIDLE */
	long Timeout;	/* -1 disables, when counter gets to 0, TIMEOUT in current status and Count and SubCount go to 0 */
	long TimeoutCount;
	void *Command;	/* Points to MEIXmpServiceCommandGeneral or MEIXmpServiceCommandXXXXX */
	void *Status;	/* Points to MEIXmpServiceStatus */
} MEIXmpSynqNetServiceControl;

typedef enum {
	MEIXmpFilterFormINVALID				= -1,

	MEIXmpFilterFormNONE,
	MEIXmpFilterFormBOXCAR,
	MEIXmpFilterFormSHAPING,
	MEIXmpFilterFormIIR,
	MEIXmpFilterFormBIQ,
	MEIXmpFilterFormSS_BIQ,
	MEIXmpFilterFormINT_BIQ,
	MEIXmpFilterFormINT_SS_BIQ,
	MEIXmpFilterFormINT_BIQ_D,
	MEIXmpFilterFormINT_SS_BIQ_D,
	MEIXmpFilterFormLAST,
	MEIXmpFilterFormFIRST				= MEIXmpFilterFormINVALID + 1
} MEIXmpFilterForm;

/* User label */
#define MEIXmpUserlabelWords	(4)
typedef struct {
	long	Word[MEIXmpUserlabelWords];
} MEIXmpUserlabel;

/* Status */
typedef enum {
	MEIXmpEventINVALID					= -1,	/* for MPI */
	MEIXmpEventIN_COARSE_POSITION		= 0,
	MEIXmpEventAT_TARGET,				 /* 1 */
	MEIXmpEventAT_VELOCITY,				 /* 2 */
	MEIXmpEventIN_FINE_POSITION,		 /* 3 */
	MEIXmpEventDONE,					 /* 4 */
	MEIXmpEventMOTION_START,			 /* 5 */
	MEIXmpEventPPI,						 /* 6 */
	MEIXmpEventPS_FAULT,				 /* 7 */
	MEIXmpEventMS_FAULT,				 /* 8 */
	MEIXmpEventOUT_OF_FRAMES,			 /* 9 */
	MEIXmpEventFRAME,					 /* 10 */
	MEIXmpEventRESET,					 /* 11 */
	MEIXmpEventRESUME,					 /* 12 */
	MEIXmpEventPAUSE,					 /* 13 */
	MEIXmpEventSTOP,					 /* 14 */
	MEIXmpEventESTOP,					 /* 15 */
	MEIXmpEventESTOP_ABORT,				 /* 16 */
	MEIXmpEventESTOP_CMD_EQ_ACT,		 /* 17 */		
	MEIXmpEventTRIGGERED_MODIFY_ESTOP,	 /* 18 */		
	MEIXmpEventTRIGGERED_MODIFY,		 /* 19 */		
	MEIXmpEventABORT,					 /* 20 */
	MEIXmpEventDISABLED,				 /* 21 */
	MEIXmpEventHOST,					 /* 22 */
	MEIXmpEventREC_IDLE,				 /* 23 */
	MEIXmpEventREC_HIGH,				 /* 24 */
	MEIXmpEventREC_FULL,				 /* 25 */
	MEIXmpEventREC_RUNNING,				 /* 26 */
	MEIXmpEventCAM						= 28,
	MEIXmpEventEXTERNAL					= 29,	/* used by program sequencer to generate events (interrupts), must be >= 16 */
	MEIXmpEventBLOCK					= 30,
	MEIXmpEventLIMIT					= 31
} MEIXmpEvent;

/* Status */
typedef enum {
	MEIXmpStatusIN_COARSE_POSITION		= (int)(1 << MEIXmpEventIN_COARSE_POSITION),	/* 0x00000001 */
	MEIXmpStatusAT_TARGET	  			= (int)(1 << MEIXmpEventAT_TARGET),				/* 0x00000002 */
	MEIXmpStatusAT_VELOCITY				= (int)(1 << MEIXmpEventAT_VELOCITY),			/* 0x00000004 */
	MEIXmpStatusIN_FINE_POSITION		= (int)(1 << MEIXmpEventIN_FINE_POSITION),		/* 0x00000008 */
																				                
	MEIXmpStatusSETTLED     			= MEIXmpStatusIN_FINE_POSITION,		  			/* 0x00000008 */
	MEIXmpStatusDONE_MASK     			= (int)(MEIXmpStatusSETTLED |	 				/* 0x0000000A */
										   MEIXmpStatusAT_TARGET),				                
																				                
	MEIXmpStatusDONE					= (int)(1 << MEIXmpEventDONE),					/* 0x00000010 */
	MEIXmpStatusIN_FINE_POSITION_LATCHED = MEIXmpStatusDONE,		  					/* 0x00000010 */
	MEIXmpStatusMOTION_START			= (int)(1 << MEIXmpEventMOTION_START),			/* 0x00000020 */

	MEIXmpStatusPPI						= (int)(1 << MEIXmpEventPPI),					/* 0x00000040 */
	MEIXmpStatusPS_FAULT				= (int)(1 << MEIXmpEventPS_FAULT),				/* 0x00000080 */
	MEIXmpStatusMS_FAULT				= (int)(1 << MEIXmpEventMS_FAULT),				/* 0x00000100 */
	MEIXmpStatusOUT_OF_FRAMES			= (int)(1 << MEIXmpEventOUT_OF_FRAMES),			/* 0x00000200 */
	MEIXmpStatusFRAME					= (int)(1 << MEIXmpEventFRAME),					/* 0x00000400 */
	MEIXmpStatusRESET					= (int)(1 << MEIXmpEventRESET),					/* 0x00000800 */
	MEIXmpStatusRESUME					= (int)(1 << MEIXmpEventRESUME),				/* 0x00001000 */
																				                
	MEIXmpStatusPAUSE		   			= (int)(1 << MEIXmpEventPAUSE),					/* 0x00002000 */
	MEIXmpStatusSTOP					= (int)(1 << MEIXmpEventSTOP),					/* 0x00004000 */
	MEIXmpStatusESTOP		   			= (int)(1 << MEIXmpEventESTOP),			 		/* 0x00008000 */
	MEIXmpStatusESTOP_ABORT	   			= (int)(1 << MEIXmpEventESTOP_ABORT),	 		/* 0x00010000 */
	MEIXmpStatusESTOP_CMD_EQ_ACT		= (int)(1 << MEIXmpEventESTOP_CMD_EQ_ACT), 		/* 0x00020000 */
	MEIXmpStatusTRIGGERED_MODIFY_ESTOP	= (int)(1 << MEIXmpEventTRIGGERED_MODIFY_ESTOP),/* 0x00040000 */
	MEIXmpStatusTRIGGERED_MODIFY		= (int)(1 << MEIXmpEventTRIGGERED_MODIFY),		/* 0x00080000 */
	MEIXmpStatusABORT		   			= (int)(1 << MEIXmpEventABORT),					/* 0x00100000 */
	MEIXmpStatusDISABLED	   			= (int)(1 << MEIXmpEventDISABLED),				/* 0x00200000 */
																				                
	MEIXmpStatusERROR_MASK     			= (int)(MEIXmpStatusESTOP |						/* 0x00178000 */
										   MEIXmpStatusESTOP_ABORT |
										   MEIXmpStatusESTOP_CMD_EQ_ACT |
										   MEIXmpStatusTRIGGERED_MODIFY_ESTOP |
										   MEIXmpStatusABORT),
																				                
	MEIXmpStatusHOST					= (int)(1 << MEIXmpEventHOST),					/* 0x00400000 */
	MEIXmpStatusREC_IDLE				= (int)(1 << MEIXmpEventREC_IDLE),				/* 0x00800000 */
	MEIXmpStatusREC_HIGH   				= (int)(1 << MEIXmpEventREC_HIGH),				/* 0x01000000 */
	MEIXmpStatusREC_FULL   				= (int)(1 << MEIXmpEventREC_FULL),				/* 0x02000000 */
	MEIXmpStatusREC_RUNNING				= (int)(1 << MEIXmpEventREC_RUNNING),			/* 0x04000000 */

	MEIXmpStatusCAM						= (int)(1 << MEIXmpEventCAM),					/* 0x10000000 */
	MEIXmpStatusEXTERNAL				= (int)(1 << MEIXmpEventEXTERNAL),				/* 0x20000000 */
	MEIXmpStatusBLOCK					= (int)((long)((unsigned long)1 << MEIXmpEventBLOCK)), /* 0x40000000 */
	MEIXmpStatusLIMIT					= (int)((long)((unsigned long)1 << MEIXmpEventLIMIT)), /* 0x80000000 */

	/* for backward compatibility */
	MEIXmpStatusID_USER0				= MEIXmpStatusLIMIT,							/* 0x80000000 */
	MEIXmpStatusID_USER1				= MEIXmpStatusLIMIT,							/* 0x80000000 */
	MEIXmpStatusID_USER2				= MEIXmpStatusLIMIT,							/* 0x80000000 */
	MEIXmpStatusID_USER3				= MEIXmpStatusLIMIT,							/* 0x80000000 */
	MEIXmpStatusID_USER4				= MEIXmpStatusLIMIT,							/* 0x80000000 */
	MEIXmpStatusID_USER5				= MEIXmpStatusLIMIT,							/* 0x80000000 */
	MEIXmpStatusID_USER6				= MEIXmpStatusLIMIT,							/* 0x80000000 */
	MEIXmpStatusID_USER7				= MEIXmpStatusLIMIT,							/* 0x80000000 */
	MEIXmpStatusID_USER8				= MEIXmpStatusLIMIT,							/* 0x80000000 */
	MEIXmpStatusID_USER9				= MEIXmpStatusLIMIT,							/* 0x80000000 */
	MEIXmpStatusID_USER10				= MEIXmpStatusLIMIT,							/* 0x80000000 */
	MEIXmpStatusID_USER11				= MEIXmpStatusLIMIT,							/* 0x80000000 */
	MEIXmpStatusID_USER12				= MEIXmpStatusLIMIT,							/* 0x80000000 */
	MEIXmpStatusID_USER13				= MEIXmpStatusLIMIT,							/* 0x80000000 */
	MEIXmpStatusID_USER14				= MEIXmpStatusLIMIT,							/* 0x80000000 */
	MEIXmpStatusID_USER15				= MEIXmpStatusLIMIT,							/* 0x80000000 */

	MEIXmpAxisSTATUS_LATCH	 			= (int)(MEIXmpStatusERROR_MASK |				/* 0xC05FC232 */
										   MEIXmpStatusTRIGGERED_MODIFY |
										   MEIXmpStatusBLOCK |
										   MEIXmpStatusLIMIT |
										   MEIXmpStatusHOST |
										   MEIXmpStatusSTOP |
										   MEIXmpStatusAT_TARGET |
										   MEIXmpStatusMOTION_START |
										   MEIXmpStatusDONE |
										   MEIXmpStatusOUT_OF_FRAMES),

	MEIXmpStatusMOTION 					= (int)(MEIXmpStatusDONE_MASK |					/* 0x0000003F */
										   MEIXmpStatusIN_COARSE_POSITION |
										   MEIXmpStatusAT_VELOCITY |
										   MEIXmpStatusMOTION_START |
										   MEIXmpStatusDONE),

	MEIXmpMS_OR_MASK	 				= (int)(MEIXmpStatusERROR_MASK |				/* 0x805FEE40 */
										   MEIXmpStatusTRIGGERED_MODIFY |
										   MEIXmpStatusLIMIT |
										   MEIXmpStatusHOST |
										   MEIXmpStatusPAUSE |
										   MEIXmpStatusSTOP |
										   MEIXmpStatusPPI |	
										   MEIXmpStatusFRAME |
										   MEIXmpStatusRESET |
										   MEIXmpStatusOUT_OF_FRAMES),
										
	MEIXmpMS_AND_MASK   				= MEIXmpStatusMOTION,							/* 0x0000003F */

	MEIXmpMSAxisMASK		 			= (int)(MEIXmpAxisSTATUS_LATCH |
										   MEIXmpStatusPAUSE)							/* 0xC05FE232 */
} MEIXmpStatus;

/* Motor Limits */
typedef enum {
	MEIXmpLimitINVALID					= -1,

	MEIXmpLimitHOME,
	MEIXmpLimitNEG_LIMIT,
	MEIXmpLimitPOS_LIMIT,
	MEIXmpLimitAMP_FAULT,
	MEIXmpLimitWARNING,
	MEIXmpLimitSOFT_NEG_LIMIT,
	MEIXmpLimitSOFT_POS_LIMIT,
	MEIXmpLimitERROR_LIMIT,
	MEIXmpLimitENCODER_FAULT,
	MEIXmpLimitDEDICATED_LAST,
	MEIXmpLimitUSER0 = MEIXmpLimitDEDICATED_LAST,
	MEIXmpLimitUSER1,
	MEIXmpLimitUSER2,
	MEIXmpLimitUSER3,
	MEIXmpLimitUSER4,
	MEIXmpLimitUSER5,
	MEIXmpLimitUSER6,
	MEIXmpLimitUSER7,
	MEIXmpLimitUSER8,
	MEIXmpLimitUSER9,
	MEIXmpLimitUSER10,
	MEIXmpLimitUSER11,
	MEIXmpLimitUSER12,
	MEIXmpLimitUSER13,
	MEIXmpLimitUSER14,
	MEIXmpLimitUSER15,

	MEIXmpLimitLAST,
	MEIXmpLimitUSER_COUNT = (MEIXmpLimitLAST - MEIXmpLimitDEDICATED_LAST),
	MEIXmpLimitFIRST					= MEIXmpLimitINVALID + 1,
	MEIXmpLimitTORQUE_LIMIT = MEIXmpLimitLAST,
	MEIXmpLimitPOWER_FAILURE
} MEIXmpLimit;

/* Limit Status */
typedef enum {
	MEIXmpLimitStatusHOME				= (int)(1 <<	MEIXmpLimitHOME),	    		/* 0x00000001 */
	MEIXmpLimitStatusNEG_LIMIT			= (int)(1 <<	MEIXmpLimitNEG_LIMIT),			/* 0x00000002 */
	MEIXmpLimitStatusPOS_LIMIT			= (int)(1 <<	MEIXmpLimitPOS_LIMIT),			/* 0x00000004 */
	MEIXmpLimitStatusAMP_FAULT			= (int)(1 <<	MEIXmpLimitAMP_FAULT),			/* 0x00000008 */ 
	MEIXmpLimitStatusWARNING			= (int)(1 <<	MEIXmpLimitWARNING),			/* 0x00000010 */
	MEIXmpLimitStatusSOFT_NEG_LIMIT		= (int)(1 <<	MEIXmpLimitSOFT_NEG_LIMIT),		/* 0x00000020 */
	MEIXmpLimitStatusSOFT_POS_LIMIT		= (int)(1 <<	MEIXmpLimitSOFT_POS_LIMIT),		/* 0x00000040 */
	MEIXmpLimitStatusERROR_LIMIT		= (int)(1 <<	MEIXmpLimitERROR_LIMIT),		/* 0x00000080 */
	MEIXmpLimitStatusENCODER_FAULT		= (int)(1 <<	MEIXmpLimitENCODER_FAULT),		/* 0x00000100 */
	MEIXmpLimitStatusUSER0				= (int)(1 <<	MEIXmpLimitUSER0),				/* 0x00000200 */
	MEIXmpLimitStatusUSER1				= (int)(1 <<	MEIXmpLimitUSER1),				/* 0x00000400 */
	MEIXmpLimitStatusUSER2				= (int)(1 <<	MEIXmpLimitUSER2),				/* 0x00000800 */
	MEIXmpLimitStatusUSER3				= (int)(1 <<	MEIXmpLimitUSER3),				/* 0x00001000 */
	MEIXmpLimitStatusUSER4				= (int)(1 <<	MEIXmpLimitUSER4),				/* 0x00002000 */
	MEIXmpLimitStatusUSER5				= (int)(1 <<	MEIXmpLimitUSER5),				/* 0x00004000 */
	MEIXmpLimitStatusUSER6				= (int)(1 <<	MEIXmpLimitUSER6),				/* 0x00008000 */
	MEIXmpLimitStatusUSER7				= (int)(1 <<	MEIXmpLimitUSER7),				/* 0x00010000 */
	MEIXmpLimitStatusUSER8				= (int)(1 <<	MEIXmpLimitUSER8),				/* 0x00020000 */
	MEIXmpLimitStatusUSER9				= (int)(1 <<	MEIXmpLimitUSER9),				/* 0x00040000 */
	MEIXmpLimitStatusUSER10				= (int)(1 <<	MEIXmpLimitUSER10),				/* 0x00080000 */
	MEIXmpLimitStatusUSER11				= (int)(1 <<	MEIXmpLimitUSER11),				/* 0x00100000 */
	MEIXmpLimitStatusUSER12				= (int)(1 <<	MEIXmpLimitUSER12),				/* 0x00200000 */
	MEIXmpLimitStatusUSER13				= (int)(1 <<	MEIXmpLimitUSER13),				/* 0x00400000 */
	MEIXmpLimitStatusUSER14				= (int)(1 <<	MEIXmpLimitUSER14),				/* 0x00800000 */
	MEIXmpLimitStatusUSER15				= (int)(1 <<	MEIXmpLimitUSER15)				/* 0x01000000 */
} MEIXmpLimitStatus;

/* SynqNet Events and Status */
typedef enum MEIXmpSynqNetEvent {
	MEIXmpSynqNetEventDEAD = 0,
	MEIXmpSynqNetEventRX_FAILURE = 1,
	MEIXmpSynqNetEventTX_FAILURE = 2,
	MEIXmpSynqNetEventNODE_FAILURE = 3,
	MEIXmpSynqNetEventRECOVERY = 4,

	MEIXmpSynqNetEventNODE_MISMATCH = 24,
	MEIXmpSynqNetEventTOPOLOGY_MISMATCH = 25,
	MEIXmpSynqNetEventCABLE_MISMATCH = 26,
	MEIXmpSynqNetEventTOO_MANY_NODES = 27
} MEIXmpSynqNetEvent;

typedef enum {
	MEIXmpSynqNetStatusNONE = (int)0x00000000,
	MEIXmpSynqNetStatusDEAD = (int)(1 << MEIXmpSynqNetEventDEAD),
	MEIXmpSynqNetStatusRX_FAILURE = (int)(1 << MEIXmpSynqNetEventRX_FAILURE),
	MEIXmpSynqNetStatusTX_FAILURE = (int)(1 << MEIXmpSynqNetEventTX_FAILURE),
	MEIXmpSynqNetStatusNODE_FAILURE = (int)(1 << MEIXmpSynqNetEventNODE_FAILURE),
	MEIXmpSynqNetStatusRECOVERY = (int)(1 << MEIXmpSynqNetEventRECOVERY),

	MEIXmpSynqNetStatusNODE_MISMATCH = (int)(1 << MEIXmpSynqNetEventNODE_MISMATCH),
	MEIXmpSynqNetStatusTOPOLOGY_MISMATCH = (int)(1 << MEIXmpSynqNetEventTOPOLOGY_MISMATCH),
	MEIXmpSynqNetStatusCABLE_MISMATCH = (int)(1 << MEIXmpSynqNetEventCABLE_MISMATCH),
	MEIXmpSynqNetStatusTOO_MANY_NODES = (int)(1 << MEIXmpSynqNetEventTOO_MANY_NODES)
} MEIXmpSynqNetStatus;

/* Commutation Parameters */			
#define MEIXmpCOMM_TABLE_SIZE	  		(1024)	/* should be a power of 2 */
#define MEIXmpCOMM_120DEGREES	  		(MEIXmpCOMM_TABLE_SIZE/3)
#define MEIXmpCOMM_90DEGREES	  		(MEIXmpCOMM_TABLE_SIZE/4)
										
/* Commutation Modes */					
typedef enum {							
	MEIXmpCommModeINVALID				= -1,

	MEIXmpCommModeNONE,
	MEIXmpCommModeCLOSED_LOOP,		
	MEIXmpCommModeOPEN_LOOP,			
	MEIXmpCommModeSIMULATE,

	MEIXmpCommModeLAST,
	MEIXmpCommModeFIRST					= MEIXmpCommModeINVALID + 1
} MEIXmpCommMode;
						
/* Motor Configuration */
typedef enum {
	MEIXmpMotorTypeINVALID		= -1,

	MEIXmpMotorTypeSERVO,
	MEIXmpMotorTypeSTEPPER,

	MEIXmpMotorTypeLAST,
	MEIXmpMotorTypeFIRST		= MEIXmpMotorTypeINVALID + 1
} MEIXmpMotorType;

/* Motor Limit Comparison Types */
typedef enum {
	MEIXmpLimitTypeFALSE				= (int)0x000000000,
	MEIXmpLimitTypeTRUE					= (int)0x000000100,

	/* 32 bit */
	MEIXmpLimitTypeGT					= (int)0x000000002,	   
	MEIXmpLimitTypeGE					= (int)0x000000003,	   
	MEIXmpLimitTypeLT					= (int)0x000000103,	   
	MEIXmpLimitTypeLE					= (int)0x000000102,	   
	MEIXmpLimitTypeEQ					= (int)0x000000001,	   
	MEIXmpLimitTypeBIT_CMP				= MEIXmpLimitTypeEQ,	
	MEIXmpLimitTypeNE					= (int)0x000000101,	   
	MEIXmpLimitTypeABS					= (int)0x000000004,
	MEIXmpLimitTypeABS_GT				= (int)0x000000006,
	MEIXmpLimitTypeABS_LE				= (int)0x000000106,

	/* floating point - 32 bit */
	MEIXmpLimitTypeFGT					= (int)0x000000008,					
	MEIXmpLimitTypeFGE					= (int)0x000000009,					
	MEIXmpLimitTypeFLT					= (int)0x000000109,	   
	MEIXmpLimitTypeFLE					= (int)0x000000108,	   
	MEIXmpLimitTypeFEQ					= MEIXmpLimitTypeEQ,	   
	MEIXmpLimitTypeFNE					= MEIXmpLimitTypeNE,	   
	MEIXmpLimitTypeFABS					= (int)0x000000010,
	MEIXmpLimitTypeFABS_GT				= (int)0x000000018,
	MEIXmpLimitTypeFABS_LE				= (int)0x000000118,

	/* 64 bit */
	MEIXmpLimitTypeLLGT					= (int)0x000000020,
	MEIXmpLimitTypeLLGE					= (int)0x000000021,
	MEIXmpLimitTypeLLLT					= (int)0x000000121,
	MEIXmpLimitTypeLLLE					= (int)0x000000120,
	MEIXmpLimitTypeLLEQ					= (int)0x000000080,
	MEIXmpLimitTypeLLNE					= (int)0x000000180,
	MEIXmpLimitTypeLLABS   				= (int)0x000000040,
	MEIXmpLimitTypeLLABS_GT				= (int)0x000000060,
	MEIXmpLimitTypeLLABS_LE				= (int)0x000000160,

	/* 64 bit double */
	MEIXmpLimitTypeDGT					= (int)0x000002000,
	MEIXmpLimitTypeDGE					= (int)0x000002001,
	MEIXmpLimitTypeDLT					= (int)0x000002101,
	MEIXmpLimitTypeDLE					= (int)0x000002100,
	MEIXmpLimitTypeDEQ					= (int)0x000008000,
	MEIXmpLimitTypeDNE					= (int)0x000008100,
	MEIXmpLimitTypeDABS   				= (int)0x000004000,
	MEIXmpLimitTypeDABS_GT				= (int)0x000006000,
	MEIXmpLimitTypeDABS_LE				= (int)0x000006100
} MEIXmpLimitType;

typedef enum {
	MEIXmpLogicNEVER					= (int)0,
	MEIXmpLogicSINGLE					= (int)0x00000001,
	MEIXmpLogicDOUBLE					= (int)0x00000002,
	MEIXmpLogicTYPE_MASK	  			= (int)0x0000000C,
	MEIXmpLogicOR						= (int)(0x0000004 | MEIXmpLogicDOUBLE),
	MEIXmpLogicAND						= (int)(0x0000008 | MEIXmpLogicDOUBLE),
	MEIXmpLogicOT						= (int)(0x000000C | MEIXmpLogicDOUBLE),
	MEIXmpLogicBITS						= (int)4,
	MEIXmpLogicCUSTOM					= (int)0x80000000,
	MEIXmpLogicModifyStateMASK			= (int)0x60000000,
	MEIXmpLogicLOGIC_MASK				= (int)((1 << MEIXmpLogicBITS) - 1),
	MEIXmpLogicDURATION_MASK  			= (int)~(MEIXmpLogicCUSTOM | MEIXmpLogicModifyStateMASK)
} MEIXmpLogic;

typedef enum {
	MEIXmpLimitDataModifyStateIDLE			= (int)0x00000000,
	MEIXmpLimitDataModifyStateMODIFY		= (int)0x20000000,
	MEIXmpLimitDataModifyStateDONE  		= (int)0x40000000
} MEIXmpLimitDataModifyState;


/* Control I/O Bit Definitions */

typedef enum {
	MEIXmpControlIOBitUSER0_OUT		= 16,
	MEIXmpControlIOBitUSER1_OUT		= 17,
	MEIXmpControlIOBitUSER2_OUT		= 18,
	MEIXmpControlIOBitUSER3_OUT		= 19,
	MEIXmpControlIOBitUSER4_OUT		= 20,
	MEIXmpControlIOBitUSER5_OUT		= 21,
	MEIXmpControlIOBitUSER0_IN		= 24,
	MEIXmpControlIOBitUSER1_IN		= 25,
	MEIXmpControlIOBitUSER2_IN		= 26,
	MEIXmpControlIOBitUSER3_IN		= 27,
	MEIXmpControlIOBitUSER4_IN		= 28,
	MEIXmpControlIOBitUSER5_IN		= 29,
	MEIXmpControlIOBitXESTOP		= 31
} MEIXmpControlIOBit;

typedef enum {
	MEIXmpControlIOMaskUSER0_OUT	= (int)(1 << MEIXmpControlIOBitUSER0_OUT),
	MEIXmpControlIOMaskUSER1_OUT	= (int)(1 << MEIXmpControlIOBitUSER1_OUT),
	MEIXmpControlIOMaskUSER2_OUT	= (int)(1 << MEIXmpControlIOBitUSER2_OUT),
	MEIXmpControlIOMaskUSER3_OUT	= (int)(1 << MEIXmpControlIOBitUSER3_OUT),
	MEIXmpControlIOMaskUSER4_OUT	= (int)(1 << MEIXmpControlIOBitUSER4_OUT),
	MEIXmpControlIOMaskUSER5_OUT	= (int)(1 << MEIXmpControlIOBitUSER5_OUT),
	MEIXmpControlIOMaskUSER0_IN		= (int)(1 << MEIXmpControlIOBitUSER0_IN),
	MEIXmpControlIOMaskUSER1_IN		= (int)(1 << MEIXmpControlIOBitUSER1_IN),
	MEIXmpControlIOMaskUSER2_IN		= (int)(1 << MEIXmpControlIOBitUSER2_IN),
	MEIXmpControlIOMaskUSER3_IN		= (int)(1 << MEIXmpControlIOBitUSER3_IN),
	MEIXmpControlIOMaskUSER4_IN		= (int)(1 << MEIXmpControlIOBitUSER4_IN),
	MEIXmpControlIOMaskUSER5_IN		= (int)(1 << MEIXmpControlIOBitUSER5_IN),
	MEIXmpControlIOMaskXESTOP		= (int)(1 << MEIXmpControlIOBitXESTOP),
	MEIXmpControlIOMaskOUTPUT		= (int)(MEIXmpControlIOMaskUSER0_OUT |
									   MEIXmpControlIOMaskUSER1_OUT |
									   MEIXmpControlIOMaskUSER2_OUT |
									   MEIXmpControlIOMaskUSER3_OUT |
									   MEIXmpControlIOMaskUSER4_OUT |
									   MEIXmpControlIOMaskUSER5_OUT ),
	MEIXmpControlIOMaskINPUT		= (int)(MEIXmpControlIOMaskUSER0_IN |
									   MEIXmpControlIOMaskUSER1_IN |
									   MEIXmpControlIOMaskUSER2_IN |
									   MEIXmpControlIOMaskUSER3_IN |
									   MEIXmpControlIOMaskUSER4_IN |
									   MEIXmpControlIOMaskUSER5_IN |
									   MEIXmpControlIOMaskXESTOP )
} MEIXmpControlIOMask;

/* sqMac Defines */
/* MEIXmpSqMacFlagBit applies to upper 16 bits of word, lower 16 bits are packet type and address */
typedef enum {
	MEIXmpSqMacFlagBitUPSTREAM_FAULT		= 16,
	MEIXmpSqMacFlagBitRECOVERY_ENABLE		= 17,
	MEIXmpSqMacFlagBitLED					= 18,
	MEIXmpSqMacFlagBitIO_ABORT				= 19
} MEIXmpSqMacFlagBit;

typedef enum {
	MEIXmpSqMacFlagMaskUPSTREAM_FAULT		= (int)(1 << MEIXmpSqMacFlagBitUPSTREAM_FAULT),
	MEIXmpSqMacFlagMaskRECOVERY_ENABLE		= (int)(1 << MEIXmpSqMacFlagBitRECOVERY_ENABLE),
	MEIXmpSqMacFlagMaskLED					= (int)(1 << MEIXmpSqMacFlagBitLED),
	MEIXmpSqMacFlagMaskIO_ABORT				= (int)(1 << MEIXmpSqMacFlagBitIO_ABORT)
} MEIXmpSqMacFlagMask;

/* MEIXmpSqMacStatusBit applies to upper 16 bits of word, lower 16 bits are packet type and address */
typedef enum {
	MEIXmpSqMacStatusBitDOWNSTREAM_FAULT	= 16,
	MEIXmpSqMacStatusBitRECOVERY_MODE		= 17,
	MEIXmpSqMacStatusBitPKT_ERROR_NONZERO	= 18,
	MEIXmpSqMacStatusBitNODE_IO_FAULT		= 26,
	MEIXmpSqMacStatusBitANALOG_POWER_FAULT	= 27,
	MEIXmpSqMacStatusBitIO_ABORT			= 28,
	MEIXmpSqMacStatusBitALARM				= 29,
	MEIXmpSqMacStatusBitDISABLE				= 30
} MEIXmpSqMacStatusBit;

typedef enum {
	MEIXmpSqMacStatusMaskDOWNSTREAM_FAULT	= (int)(1 << MEIXmpSqMacStatusBitDOWNSTREAM_FAULT),
	MEIXmpSqMacStatusMaskRECOVERY_MODE		= (int)(1 << MEIXmpSqMacStatusBitRECOVERY_MODE),
	MEIXmpSqMacStatusMaskPKT_ERROR_NONZERO	= (int)(1 << MEIXmpSqMacStatusBitPKT_ERROR_NONZERO),
	MEIXmpSqMacStatusMaskNODE_IO_FAULT		= (int)(1 << MEIXmpSqMacStatusBitNODE_IO_FAULT),
	MEIXmpSqMacStatusMaskANALOG_POWER_FAULT	= (int)(1 << MEIXmpSqMacStatusBitANALOG_POWER_FAULT),
	MEIXmpSqMacStatusMaskIO_ABORT			= (int)(1 << MEIXmpSqMacStatusBitIO_ABORT),
	MEIXmpSqMacStatusMaskALARM				= (int)(1 << MEIXmpSqMacStatusBitALARM),
	MEIXmpSqMacStatusMaskDISABLE			= (int)(1 << MEIXmpSqMacStatusBitDISABLE)
} MEIXmpSqMacStatusMask;



/* Motor Dedicated I/O Bit Definitions */
/* 16 bits */
typedef enum {
	MEIXmpMotorDedicatedInputFlagsFAULT = 0,
	MEIXmpMotorDedicatedInputFlagsBRAKE_ON = 1,
	MEIXmpMotorDedicatedInputFlagsHOME = 2,
	MEIXmpMotorDedicatedInputFlagsPOS_LIMIT = 3,
	MEIXmpMotorDedicatedInputFlagsNEG_LIMIT = 4,
	MEIXmpMotorDedicatedInputFlagsENC_INDEX0 = 5,
	MEIXmpMotorDedicatedInputFlagsENC_FAULT = 6,
	MEIXmpMotorDedicatedInputFlagsCAPTURED = 7,
	MEIXmpMotorDedicatedInputFlagsHALL_A = 8,
	MEIXmpMotorDedicatedInputFlagsHALL_B = 9,
	MEIXmpMotorDedicatedInputFlagsHALL_C = 10,
	MEIXmpMotorDedicatedInputFlagsAMP_ACTIVE = 11,
	MEIXmpMotorDedicatedInputFlagsENC_INDEX1 = 12,
	MEIXmpMotorDedicatedInputFlagsWARNING = 13,
	MEIXmpMotorDedicatedInputFlagsDRIVE_STATUS9 = 14,
	MEIXmpMotorDedicatedInputFlagsDRIVE_STATUS10 = 15,
	MEIXmpMotorDedicatedInputFlagsFEEDBACK_FAULT_PRIMARY = 16,
	MEIXmpMotorDedicatedInputFlagsFEEDBACK_FAULT_SECONDARY = 17
} MEIXmpMotorDedicatedInputFlags;

/* 16 bits */
typedef enum {
	MEIXmpMotorDedicatedOutputFlagsAMP_ENABLE = 0,
	MEIXmpMotorDedicatedOutputFlagsBRAKE_RELEASE = 1
} MEIXmpMotorDedicatedOutputFlags;

typedef enum {
	MEIXmpMotorDedicatedFlagsMaskAMP_FAULT		= (int)(1 << MEIXmpMotorDedicatedInputFlagsFAULT),
	MEIXmpMotorDedicatedFlagsMaskAMP_ENABLE		= (int)(1 << MEIXmpMotorDedicatedOutputFlagsAMP_ENABLE),
	MEIXmpMotorDedicatedFlagsMaskBRAKE_ON		= (int)(1 << MEIXmpMotorDedicatedInputFlagsBRAKE_ON),
	MEIXmpMotorDedicatedFlagsMaskBRAKE_RELEASE	= (int)(1 << MEIXmpMotorDedicatedOutputFlagsBRAKE_RELEASE),
	MEIXmpMotorDedicatedFlagsMaskHOME			= (int)(1 << MEIXmpMotorDedicatedInputFlagsHOME),
	MEIXmpMotorDedicatedFlagsMaskPOS_LIMIT		= (int)(1 << MEIXmpMotorDedicatedInputFlagsPOS_LIMIT),
	MEIXmpMotorDedicatedFlagsMaskNEG_LIMIT		= (int)(1 << MEIXmpMotorDedicatedInputFlagsNEG_LIMIT),
	MEIXmpMotorDedicatedFlagsMaskENC_INDEX0		= (int)(1 << MEIXmpMotorDedicatedInputFlagsENC_INDEX0),
	MEIXmpMotorDedicatedFlagsMaskENC_FAULT		= (int)(1 << MEIXmpMotorDedicatedInputFlagsENC_FAULT),
	MEIXmpMotorDedicatedFlagsMaskCAPTURED		= (int)(1 << MEIXmpMotorDedicatedInputFlagsCAPTURED),
	MEIXmpMotorDedicatedFlagsMaskHALL_A			= (int)(1 << MEIXmpMotorDedicatedInputFlagsHALL_A),
	MEIXmpMotorDedicatedFlagsMaskHALL_B			= (int)(1 << MEIXmpMotorDedicatedInputFlagsHALL_B),
	MEIXmpMotorDedicatedFlagsMaskHALL_C			= (int)(1 << MEIXmpMotorDedicatedInputFlagsHALL_C),
	MEIXmpMotorDedicatedFlagsMaskAMP_ACTIVE		= (int)(1 << MEIXmpMotorDedicatedInputFlagsAMP_ACTIVE),
	MEIXmpMotorDedicatedFlagsMaskENC_INDEX1		= (int)(1 << MEIXmpMotorDedicatedInputFlagsENC_INDEX1),
	MEIXmpMotorDedicatedFlagsMaskWARNING		= (int)(1 << MEIXmpMotorDedicatedInputFlagsWARNING),
	MEIXmpMotorDedicatedFlagsMaskDRIVE_STATUS9	= (int)(1 << MEIXmpMotorDedicatedInputFlagsDRIVE_STATUS9),
	MEIXmpMotorDedicatedFlagsMaskDRIVE_STATUS10	= (int)(1 << MEIXmpMotorDedicatedInputFlagsDRIVE_STATUS10),
	MEIXmpMotorDedicatedFlagsMaskFEEDBACK_FAULT_PRIMARY	= (int)(1 << MEIXmpMotorDedicatedInputFlagsFEEDBACK_FAULT_PRIMARY),
	MEIXmpMotorDedicatedFlagsMaskFEEDBACK_FAULT_SECONDARY	= (int)(1 << MEIXmpMotorDedicatedInputFlagsFEEDBACK_FAULT_SECONDARY)
} MEIXmpMotorDedicatedFlagsMask;

/* Motor Enums */ 
 
typedef enum {
	MEIXmpMotorEnableStateDISABLE = (int)0x00000000,
	MEIXmpMotorEnableStateENABLE = (int)0x00000001,
	MEIXmpMotorEnableStateAUTONOMOUS_DRIVE_ACTION = (int)0x00000010,
	MEIXmpMotorEnableStateAUTONOMOUS_DRIVE_ACTION_FAIL = (int)(MEIXmpMotorEnableStateAUTONOMOUS_DRIVE_ACTION | 0x00000020)
} MEIXmpMotorEnableState;

typedef enum{
	MEIXmpMotorNO_BRAKE = (int)0x00000000,
	MEIXmpMotorHAS_BRAKE = (int)0x00000001,
	MEIXmpMotorVELOCITY_BRAKE = (int)0x00000002
}MEIXmpBrakeMode;

/* Motion Types */
typedef enum {
	MEIXmpMotionTypeINVALID					= -1,

	MEIXmpMotionTypeNONE,

	MEIXmpMotionTypeHOLD,
	MEIXmpMotionTypeOUTPUT,
	MEIXmpMotionTypeJOG,

	MEIXmpMotionTypeVELOCITY,
	MEIXmpMotionTypeVELOCITY_JERK,
	MEIXmpMotionTypeS_CURVE,
	MEIXmpMotionTypeS_CURVE_JERK,

	MEIXmpMotionTypePATH_END				= MEIXmpMotionTypeS_CURVE,
	MEIXmpMotionTypePATH_OPEN,

	MEIXmpMotionTypeLAST,
	MEIXmpMotionTypeFIRST					= MEIXmpMotionTypeINVALID + 1

} MEIXmpMotionType;

/* Frame Types */
typedef enum {
	MEIXmpFrameTypeINVALID					= -1,
	
	MEIXmpFrameTypeMOTION					= (int)0x00008000,
	MEIXmpFrameTypeTIME_ADVANCE				= (int)0x00010000,
	MEIXmpFrameTypeFRAME_ADVANCE			= (int)0x00020000,
	MEIXmpFrameTypeTIME_FRAME_ADVANCE		= (int)(MEIXmpFrameTypeFRAME_ADVANCE | MEIXmpFrameTypeTIME_ADVANCE),
	MEIXmpFrameTypeREVERSE					= (int)0x00040000,
	MEIXmpFrameTypeLINK						= (int)0x00080000,

	MEIXmpFrameTypeNONE						= (int)0x00000000,
	MEIXmpFrameTypeUPDATE_NO_TIME_FRAME_ADVANCE = (int)0x00000001,
	MEIXmpFrameTypeUPDATE					= (int)(MEIXmpFrameTypeUPDATE_NO_TIME_FRAME_ADVANCE | MEIXmpFrameTypeTIME_FRAME_ADVANCE),
	MEIXmpFrameTypeUPDATE_REVERSE			= (int)(MEIXmpFrameTypeUPDATE | MEIXmpFrameTypeREVERSE),
	MEIXmpFrameTypeUPDATE_NO_TIME_FRAME_ADVANCE_REVERSE = (int)(MEIXmpFrameTypeUPDATE_NO_TIME_FRAME_ADVANCE | MEIXmpFrameTypeREVERSE),

	MEIXmpFrameTypeSTART					= (int)0x00000002,
	MEIXmpFrameTypeTARGET_ID				= (int)0x00000004,
	MEIXmpFrameTypeSTART_ID					= (int)(MEIXmpFrameTypeSTART | MEIXmpFrameTypeTARGET_ID),
	MEIXmpFrameTypeSTART_ID_REVERSE			= (int)(MEIXmpFrameTypeSTART | MEIXmpFrameTypeTARGET_ID | MEIXmpFrameTypeREVERSE),
	MEIXmpFrameTypeMODIFY_ID				= (int)(0x0000008 | MEIXmpFrameTypeTARGET_ID),
	MEIXmpFrameTypeMODIFY_ID_REVERSE		= (int)(0x0000008 | MEIXmpFrameTypeTARGET_ID | MEIXmpFrameTypeREVERSE),

	MEIXmpFrameTypeID						= (int)0x00000010,

	MEIXmpFrameTypeHOLD_NO_TIME_FRAME_ADVANCE = (int)0x00000020,
	MEIXmpFrameTypeHOLD						= (int)(MEIXmpFrameTypeHOLD_NO_TIME_FRAME_ADVANCE | MEIXmpFrameTypeTIME_FRAME_ADVANCE),
	MEIXmpFrameTypeOUTPUT					= (int)0x00000040,

	MEIXmpFrameTypeCAM_START				= (int)(0x00000080 | MEIXmpFrameTypeTIME_ADVANCE),
	MEIXmpFrameTypeCAM_END					= (int)0x00000100,

	MEIXmpFrameTypeVELOCITY_BASIC			= (int)0x00000200,
	MEIXmpFrameTypeVELOCITY					= (int)(MEIXmpFrameTypeVELOCITY_BASIC | MEIXmpFrameTypeMOTION),
	MEIXmpFrameTypeVELOCITY_TIME_FRAME_ADVANCE = (int)(MEIXmpFrameTypeVELOCITY | MEIXmpFrameTypeTIME_FRAME_ADVANCE),
	MEIXmpFrameTypeS_CURVE_BASIC			= (int)0x00000400,
	MEIXmpFrameTypeS_CURVE					= (int)(MEIXmpFrameTypeS_CURVE_BASIC | MEIXmpFrameTypeMOTION | MEIXmpFrameTypeTIME_FRAME_ADVANCE),
   	MEIXmpFrameTypePOINT					= (int)(0x00000800 | MEIXmpFrameTypeMOTION | MEIXmpFrameTypeTIME_FRAME_ADVANCE),
	MEIXmpFrameTypePOINT_FF					= (int)(0x00001000 | MEIXmpFrameTypeMOTION | MEIXmpFrameTypeTIME_FRAME_ADVANCE),
	MEIXmpFrameTypeUSER						= (int)(0x00002000 | MEIXmpFrameTypeTIME_ADVANCE),

	MEIXmpFrameTypeTYPE_MASK				= (int)0x000FFFFF,
	MEIXmpFrameTypeCOUNT_MASK				= (int)0xFFF00000,

	MEIXmpFrameTypeLAST,
	MEIXmpFrameTypeFIRST					= MEIXmpFrameTypeINVALID + 1

} MEIXmpFrameType;

typedef enum {
	MEIXmpSettlingModeNONE					= 0,
	MEIXmpSettlingModeVELOCITY,
	MEIXmpSettlingModePOSITION,
	MEIXmpSettlingModeERROR
} MEIXmpSettlingMode;

typedef enum {
	MEIXmpMoveStatusDIRECTION						= (int)0x00000001,
	MEIXmpMoveStatusTARGET							= (int)0x00000002,
	MEIXmpMoveStatusVELOCITY_MOVE					= (int)0x00010000,		/* assumed S_CURVE move if not set */
	MEIXmpMoveStatusPOSITION_BASED					= (int)0x00020000,		/* for camming, replaces time base */
	MEIXmpMoveStatusNO_BACKTRACK					= (int)0x00040000,		/* for camming */
	MEIXmpMoveStatusNO_BACKTRACK_RESUME_IMMEDIATE	= (int)0x00080000,		/* for camming */
	MEIXmpMoveStatusCAM_START_HOLDING				= (int)0x00100000,		/* for camming, set and cleared by firmware */
	MEIXmpMoveStatusFEED_FORWARD					= (int)0x00200000,		/* Expects feed forward terms in S_Curve frames */
	MEIXmpMoveStatusCAM_REVERSE_MASTER				= (int)0x00400000,		/* for camming */
	MEIXmpMoveStatusCAM_HOLD_SYNQ					= (int)0x00800000,		/* for camming, for synqing after a hold (position trigger) frame */
	MEIXmpMoveStatusNEW_TARGET_VELOCITY				= (int)0x01000000,		/* used in id frames to tell background to clear AT_VELOCITY */
	MEIXmpMoveStatusADD_REVERSE_TIME				= (int)0x20000000,		/* set by firmware when fp->t needs to be added at next valid frame */
	MEIXmpMoveStatusMOVE_PENDING					= (int)0x40000000,
	MEIXmpMoveStatusMOVE_IN_PROGRESS				= (int)0x80000000,
	MEIXmpMoveStatusCAM_CLEAR_MASK					= (int)(MEIXmpMoveStatusPOSITION_BASED | MEIXmpMoveStatusNO_BACKTRACK |
														MEIXmpMoveStatusNO_BACKTRACK_RESUME_IMMEDIATE | MEIXmpMoveStatusCAM_START_HOLDING |
														MEIXmpMoveStatusCAM_REVERSE_MASTER | MEIXmpMoveStatusCAM_HOLD_SYNQ),
	MEIXmpMoveStatusCLEAR_MASK						= (int)(MEIXmpMoveStatusMOVE_IN_PROGRESS | MEIXmpMoveStatusMOVE_PENDING | 
														MEIXmpMoveStatusVELOCITY_MOVE | MEIXmpMoveStatusNEW_TARGET_VELOCITY | 
														MEIXmpMoveStatusFEED_FORWARD | MEIXmpMoveStatusCAM_CLEAR_MASK)
} MEIXmpMoveStatus;

#define		MEIXmpMotionTypeMASK			0x000000FF

/* Motion Attributes */

typedef enum {
	/* ADI compiler issues a warning if this is written (1 << 31) */
	MEIXmpMotionAttrAPPEND			= (int)0x80000000,	/* 0x80000000 */
	MEIXmpMotionAttrRELATIVE		= (int)(1 << 30),	/* 0x40000000 */
	MEIXmpMotionAttrSYNC_START 		= (int)(1 << 29),	/* 0x20000000 */
	MEIXmpMotionAttrSYNC_END	  	= (int)(1 << 28),	/* 0x10000000 */
	MEIXmpMotionAttrSYNC_BOTH	  	= (int)(1 << 27),	/* 0x08000000 */
	MEIXmpMotionAttrNO_REVERSAL	  	= (int)(1 << 26),	/* 0x04000000 */
	MEIXmpMotionAttrAUTO_START  	= (int)(1 << 25),	/* 0x02000000 */
	MEIXmpMotionAttrHOLD_BIT		= (int)(1 << 24),	/* 0x01000000 */
	MEIXmpMotionAttrHOLD_LESS		= (int)(1 << 23),	/* 0x00800000 */
	MEIXmpMotionAttrHOLD_GREATER	= (int)(1 << 22),	/* 0x00400000 */
	MEIXmpMotionAttrDELAY			= (int)(1 << 21),	/* 0x00200000 */
	MEIXmpMotionAttrMASK			= (int)~MEIXmpMotionTypeMASK
} MEIXmpMotionAttr;

/* Actions */
typedef enum {
	MEIXmpActionINVALID					= -1,

	MEIXmpActionIDLE,								/*	0	*/
	MEIXmpActionMOVE_IN_PROGRESS,					/*	1	*/
	MEIXmpActionRESUME_IN_PROGRESS,					/*	2	*/
	MEIXmpActionRESET_IN_PROGRESS,					/*	3	*/
	MEIXmpActionLOAD,								/*	4	*/
	MEIXmpActionMODIFY,								/*	5	*/
	MEIXmpActionSTART,								/*	6	*/
	MEIXmpActionSTOP,								/*	7	*/
	MEIXmpActionRESUME,								/*	8	*/
	MEIXmpActionESTOP,								/*	9	*/
	MEIXmpActionESTOP_ABORT,						/*	10	*/
	MEIXmpActionESTOP_CMD_EQ_ACT,					/*	11	*/
	MEIXmpActionESTOP_TRIGGERED_MODIFY,				/*	12	*/
	MEIXmpActionABORT,								/*	13	*/
	MEIXmpActionRESET,								/*	14	*/
	MEIXmpActionMAP,								/*	15	*/
													
	MEIXmpActionLAST,								/*	16	*/
	MEIXmpActionFIRST					= MEIXmpActionINVALID + 1
} MEIXmpAction;

typedef enum {
	MEIXmpActionStatusINVALID					= -1,

	MEIXmpActionStatusOK,
	MEIXmpActionStatusMOVING,
	MEIXmpActionStatusNOT_MOVING,
	MEIXmpActionStatusHOST_STILL_LOADING,
	MEIXmpActionStatusILLEGAL_DELAY,
	MEIXmpActionStatusERROR,
	MEIXmpActionStatusPROFILE_ERROR,
	MEIXmpActionStatusPROFILE_NOT_SUPPORTED,
	MEIXmpActionStatusRESERVED_ERROR0,
	MEIXmpActionStatusRESERVED_ERROR1,
	MEIXmpActionStatusRESERVED_ERROR2,

	MEIXmpActionStatusLAST,
	MEIXmpActionStatusFIRST					= MEIXmpActionStatusINVALID + 1
} MEIXmpActionStatus;


typedef enum {
	MEIXmpCommandTypeNC					= (int)0x00000000,
	MEIXmpCommandTypeBR					= (int)0x00000001,
	MEIXmpCommandTypeAR					= (int)0x00000002,
	MEIXmpCommandTypeLD					= (int)0x00000003,
	MEIXmpCommandTypeCP					= (int)0x00000004,
	MEIXmpCommandTypeUM					= (int)0x00000007,

	MEIXmpCommandTypeMask				= (int)0x000000FF
} MEIXmpCommandType;

typedef enum {
	MEIXmpAlgorithmINVALID				= -1,

	MEIXmpAlgorithmNONE,
	MEIXmpAlgorithmPID,
	MEIXmpAlgorithmPIV,
	MEIXmpAlgorithmPIV1,
	MEIXmpAlgorithmUSER,

	MEIXmpAlgorithmLAST,
	MEIXmpAlgorithmFIRST				= MEIXmpAlgorithmINVALID + 1
} MEIXmpAlgorithm;

typedef enum {
	MEIXmpGainINVALID					= -1,

	MEIXmpGainSTOPPED2					= 0,
	MEIXmpGainSTOPPED1					= 1,
	MEIXmpGainSETTLING					= 2,
	MEIXmpGainMOVING					= 3,
	MEIXmpGainSTOPPED3					= 4,

	MEIXmpGainNOT_MOVING				= 0,
	MEIXmpGainACCEL						= 1,
	MEIXmpGainDECEL						= 2,
	MEIXmpGainCONSTANT_VEL				= 3,

	MEIXmpGainMIN						= 0,
	MEIXmpGainMAX						= 1,
	MEIXmpGainNONE						= 2,
	MEIXmpGainSLOPE						= 3,

	MEIXmpGainLAST						= 5,
	MEIXmpGainFIRST						= MEIXmpGainINVALID + 1
} MEIXmpGain;

typedef enum {
	MEIXmpSwitchTypeINVALID				= -1,

	MEIXmpSwitchTypeNONE,
	MEIXmpSwitchTypeMOTION_ONLY,
	MEIXmpSwitchTypeWINDOW,
	MEIXmpSwitchTypeUSER,

	MEIXmpSwitchTypeLAST,
	MEIXmpSwitchTypeFIRST				= MEIXmpSwitchTypeINVALID + 1
} MEIXmpSwitchType;

typedef enum {
	MEIXmpPPIModeINVALID				= -1,

	MEIXmpPPIModePI,
	MEIXmpPPIModeP,

	MEIXmpPPIModeLAST,
	MEIXmpPPIModeFIRST					= MEIXmpPPIModeINVALID + 1
} MEIXmpPPIMode;

typedef enum {
	MEIXmpIntResetConfigINVALID			= -1,

	MEIXmpIntResetConfigDISABLED		= (int)0x0,
	MEIXmpIntResetConfigENABLED			= (int)0x1,

	MEIXmpIntResetConfigLAST,
	MEIXmpIntResetConfigFIRST			= MEIXmpIntResetConfigINVALID + 1
} MEIXmpIntResetConfig;

typedef enum {
	MEIXmpIntResetStatusINVALID			= -1,

	MEIXmpIntResetStatusWAIT			= (int)0x0,
	MEIXmpIntResetStatusCLEAR			= (int)0x1,
	MEIXmpIntResetStatusDONE			= (int)0x2,

	MEIXmpIntResetStatusLAST,
	MEIXmpIntResetStatusFIRST			= MEIXmpIntResetStatusINVALID + 1
} MEIXmpIntResetStatus;

typedef enum {
	MEIXmpCommandCodeINVALID			= (int)0xFFFFFFFF,	/* -1, for MPI */

		/* Branch Codes */
	MEIXmpCommandCodeUNC				= (int)0x00000000,
	MEIXmpCommandCodeEQ					= (int)0x00000100,
	MEIXmpCommandCodeNE					= (int)0x00000200,
	MEIXmpCommandCodeGE					= (int)0x00000300,
	MEIXmpCommandCodeGT					= (int)0x00000400,
	MEIXmpCommandCodeLE					= (int)0x00000500,
	MEIXmpCommandCodeLT					= (int)0x00000600,
	MEIXmpCommandCodeFGE 				= (int)0x00000700,
	MEIXmpCommandCodeFGT 				= (int)0x00000800,
	MEIXmpCommandCodeFLE 				= (int)0x00000900,
	MEIXmpCommandCodeFLT 				= (int)0x00000A00,

		/* Arith. Operation Codes */
	MEIXmpCommandCodeADD				= (int)0x00000000,
	MEIXmpCommandCodeSUB				= (int)0x00000100,
	MEIXmpCommandCodeMUL				= (int)0x00000200,
	MEIXmpCommandCodeDIV				= (int)0x00000300,
	MEIXmpCommandCodeAND				= (int)0x00000400,
	MEIXmpCommandCodeOR					= (int)0x00000500,
	MEIXmpCommandCodeXOR				= (int)0x00000600,
	MEIXmpCommandCodeFADD				= (int)0x00000700,
	MEIXmpCommandCodeFSUB				= (int)0x00000800,
	MEIXmpCommandCodeFMUL				= (int)0x00000900,
	MEIXmpCommandCodeFDIV				= (int)0x00000A00,
										
	MEIXmpCommandCodeMask				= (int)0x0000FF00
										
} MEIXmpCommandCode;					
										
typedef enum {							
	MEIXmpSignalID_SYSTEM				= (int)0x01000000,
	MEIXmpSignalID_MOTOR				= (int)0x02000000,
	MEIXmpSignalID_AXIS					= (int)0x03000000,
	MEIXmpSignalID_MS					= (int)0x04000000,
	MEIXmpSignalID_PS					= (int)0x05000000,
	MEIXmpSignalID_DR					= (int)0x06000000,
	MEIXmpSignalID_BLOCK				= (int)0x07000000,
	MEIXmpSignalID_SYNQNET				= (int)0x08000000,
	MEIXmpSignalID_USER					= (int)0x09000000,
	MEIXmpSignalID_CAN					= (int)0x0A000000,
	MEIXmpSignalID_MASK					= (int)0xFF000000,
	MEIXmpSignalID_INDEX				= (int)0x00FF0000,
	MEIXmpSignalID_STATUS				= (int)0x0000FFFF
} MEIXmpSignalID;						

typedef enum {							
	MEIXmpCommandControlINT				= (int)0x80000000
} MEIXmpCommandControl;

typedef enum {
	MEIXmpStateIDLE						= 0,
	MEIXmpStatePENDING,
	MEIXmpStateSTARTED,
	MEIXmpStateMOVING,
	MEIXmpStateSTOPPED
} MEIXmpState;

/* enum used to specify signal type generated by firmware */
typedef enum {
	MEIXmpTestSignalNONE				= 0,
	MEIXmpTestSignalEXTERNAL,
	MEIXmpTestSignalRANDOM_NOISE,	
	MEIXmpTestSignalSINE,				/* this also generates a cosine wave on TestSignal.Output2 */
	MEIXmpTestSignalUSER
} MEIXmpTestSignalMode;

/* enum used to specify destination of generated signals */
typedef enum {
	MEIXmpTestSignalDestPLANT			= 0,
	MEIXmpTestSignalDestSIMULATOR		/* used when injecting signals into simulation implemented in post filter */
} MEIXmpTestSignalDest;
	
/* Structs and Unions */

typedef struct {
	MEIXmpFilterForm			Form;
	long						Length;
	long						*Input;
	float						*VInput;
	long						Output;
	long						OutputDelta;
	float						VOutput;
	long						Sum;
	float						VSum;
	long						Oldest;
	long						Coeff[2 * MEIXmpMAX_PreCoeffs];
	long						Data[MEIXmpMAX_PreBuffSize];
	float						VData[MEIXmpMAX_PreBuffSize];
} MEIXmpPreFilter;

typedef struct {
	long						Length;
	float						Coeff[MEIXmpMAX_PostFilterSize];
	float						Data[MEIXmpMAX_PostFilterSize];
} MEIXmpPostFilter;

typedef union {
	long					l;
	float					f;
} MEIXmpGenericValue;

typedef union {
	long	l[2];
} MEIXmpGeneric64;

typedef union {
	MEIXmpGeneric64			g64;
	MEIXmpGenericValue		g32;
} MEIXmpLimitValue;

/* IMPORTANT: Whenever a change is made to the following union, stdmei.h must also be updated. */
typedef union {
	float	f[MEIXmpFilterCoeffSize];
	long	l[MEIXmpFilterCoeffSize];
	struct	{
		float				Kp;
		float				Ki;
		float				Kd;
		float				Kpff;
		float				Kvff;
		float				Kaff;
		float				Kfff;
		float				MovingIMax;
		float				RestIMax;
		long				DRate;
		float				OutputLimit;
		float				OutputLimitHigh;
		float				OutputLimitLow;
		float				OutputOffset;
		float				Ka0;
		float				Ka1;
		float				Ka2;
	} PID;
	struct	{
		float				Kpp;
		float				Kip;
		float				Kpv;
		float				Kpff;		/* Not yet implimented */
		float				Kvff;
		float				Kaff;
		float				Kfff;
		float				MovingIMax;
		float				RestIMax;
		float				Kdv;
		float				OutputLimit;
		float				OutputLimitHigh;
		float				OutputLimitLow;
		float				OutputOffset;
		float				Kiv;
		float				VintMax;
		float				Ka0;
		float				Ka1;
		float				Ka2;
	} PIV;
} MEIXmpFilterCoeff;

typedef union {
	struct	{
		long				BranchIndex;
		MEIXmpGenericValue	*src1;
		MEIXmpGenericValue	*src2;
		MEIXmpGenericValue  constant;
		long				mask;
	} br;
	struct	{
		MEIXmpGenericValue	*dest;
		MEIXmpGenericValue	*src1;
		MEIXmpGenericValue	*src2;
		MEIXmpGenericValue  constant;
	} ar;
	struct	{
		long				count;
		long				*dest;
		long				buff[MEIXmpCommandSize - 4];
	} ld;
	struct	{
		long				count;
		long				*dest;
		long				*src;
	} cp;
	struct	{
		long				UserInfo;
	} um;
} MEIXmpCmdData;

typedef struct {
	MEIXmpCommandCode		Type;
	long					Dwell;
	MEIXmpCmdData			Cmd;
} MEIXmpCommand;

typedef struct {
	long					Info[MEIXmpSignalInfoWords];
	long					*UserData[MEIXmpSignalUserData];
	MEIXmpStatus			Polarity;
	MEIXmpStatus			Mask;
	MEIXmpStatus			ResetMask;
} MEIXmpHostSignal;

typedef struct {
	MEIXmpHostSignal	System;
	MEIXmpHostSignal	Motor[MEIXmpMAX_Motors];
	MEIXmpHostSignal	Axis[MEIXmpMAX_Axes];
	MEIXmpHostSignal	MS[MEIXmpMAX_MSs];
	MEIXmpHostSignal	Block[MEIXmpMaxMotionBlocks];
	MEIXmpHostSignal	SynqNet[MEIXmpMaxSynqNets];
	MEIXmpHostSignal	PS[MEIXmpMAX_PSs];
	MEIXmpHostSignal	DR[MEIXmpMAX_Recorders];
} MEIXmpHostSignalBuffer;

typedef struct {
	long					CreateCount;
	long					Low;
	long					High;
	long					BufferSize;
	long					CurrentCmd;
	long					Control;
	long					Timer;
	MEIXmpCommandControl	Status;
	MEIXmpCommand			*CmdBuff;
	MEIXmpHostSignal		*Signal;
	long					Reserved[6];
} MEIXmpProgramSequencer;

typedef struct {
	float				PosErrorSum;
	float				PosErrorDelta;
	float				PosErrorOld;
	float				OldVelocity;
	float				SmoothedVelocity;
	float				VelError;
	float				VelErrorSum;
	float				PIDOutput;			/* Output after PID, not including any FF terms */
	float				PIVOutput;			/* Output after PIV, If PID alg, equals PIDOuput */
	float				PostFilterOutput;	/* Output after PostFilter, includes Vff term.  If PID alg, equals PID + Vff */
	float				FFOutput;			/* All FF terms except Vff */
	float				SignalIn;			/* in => signal injected into control loop */
	float				SignalOut1;			/* out => signal extracted from control loop */
	float				SignalOut2;
	float				DerivFilter[MEIXmpDFilterSize];
} MEIXmpFilterData;

typedef enum {
	MEIXmpDACInputTypeFLOAT				= 0,
	MEIXmpDACInputTypeLONG,
	MEIXmpDACInputTypeDOUBLE
} MEIXmpDACInputType;

typedef enum {
	MEIXmpDemandChannelSize16 = 0,
	MEIXmpDemandChannelSize32
} MEIXmpDemandChannelSize;

typedef struct {
	MEIXmpDemandChannelSize	Size;
	float					Offset;
	float					Level;
	float					Scale;
	MEIXmpDACInputType		InputType;
	MEIXmpGenericValue		*Input;
	long					*Output;
} MEIXmpDemandChannel;

typedef enum {
	MEIXmpNodeIntegratorDisableNONE = (int)0x00000000,
	MEIXmpNodeIntegratorDisableVLI = (int)0x00000400,	/* bit 10 - if set, disables velocity loop integrator in node */
	MEIXmpNodeIntegratorDisablePLI = (int)0x00000800,	/* bit 11 - if set, disables position loop integrator in node */
} MEIXmpNodeIntegratorDisable;

typedef enum {
	MEIXmpMotorControlModeNULL = (int)0x00000000,
	MEIXmpMotorControlModeBRAKE = (int)0x00000001,
	MEIXmpMotorControlModeAUTONOMOUS_DRIVE_ACTION = (int)0x00000002,
	MEIXmpMotorControlModeTORQUE = (int)0x00000003,
	MEIXmpMotorControlModeVOLTAGE = (int)0x00000004,

	MEIXmpMotorControlModeCURRENT = (int)0x00000006,
	MEIXmpMotorControlModeVELOCITY = (int)0x00000007,
	MEIXmpMotorControlModeCUSTOM = (int)0x00000008,

	MEIXmpMotorControlModeMASK = (int)0x0000000F,				/* bits 0-3 */
	MEIXmpMotorControlModeVLI_DISABLE_MASK = MEIXmpNodeIntegratorDisableVLI,
	MEIXmpMotorControlModePLI_DISABLE_MASK = MEIXmpNodeIntegratorDisablePLI,
	MEIXmpMotorControlModeGAIN_INDEX_MASK = (int)0x0000E000,	/* bits 13-15 */
	MEIXmpMotorControlModeGAIN_INDEX_SHIFT = 13,
} MEIXmpMotorControlMode;

typedef struct {
	MEIXmpGain					*GainIndex;
	MEIXmpNodeIntegratorDisable	*NodeIntegratorDisable;
	MEIXmpMotorControlMode		Mode;
	long						Map;
} MEIXmpMotorControlModeData;

/*
	MEIXmpMotorModeSelect selects which ModeControlData struct is used.
*/
typedef enum {
	MEIXmpMotorModeSelectANALOG = 0,
	MEIXmpMotorModeSelectANALOG_DUAL_DAC = 0,
	MEIXmpMotorModeSelectTORQUE = 0,
	MEIXmpMotorModeSelectCUSTOM = 0,
	MEIXmpMotorModeSelectVELOCITY = 1,
/*	MEIXmpMotorModeSelectPOSITION = 1, */
} MEIXmpMotorModeSelect;

typedef struct {
	MEIXmpMotorModeSelect		ModeSelect;
	MEIXmpMotorControlModeData	ModeControlData[MEIXmpMotorMAX_MODES];
	MEIXmpMotorControlMode		OverrideMode;						/* set by firmware for Autonomous Drive Action - does not contain a map */
	MEIXmpMotorControlMode		*ModePtr;							/* pointer to 16 bit space */
} MEIXmpMotorControl;

typedef enum {
	MEIXmpDACPhaseNORMAL = 0,
	MEIXmpDACPhaseINVERTED = 1
} MEIXmpDACPhase;

typedef struct {
	float					*Ptr;
	float					Coeff;
} MEIXmpCommInput;

typedef struct {
	long					*FeedbackCount;
	long					CommandCount[MEIXmpStepCommandCountMAX];
	long					*Delta;
	long					*Output;
	long					CommandCountDelay;
	long					PupCycle;
	long					Width;
	long					LastPulse;
	long					CorrectionSampleCounter;
} MEIXmpStepControl;

typedef struct {
	MEIXmpCommMode			Mode;
	float					Output[MEIXmpCommDACs];
	MEIXmpCommInput			Input[MEIXmpMotorFilterInputs];
	long					Length;
	float					Scale;
	long					*ClosedLoopPointer;
	long					*OpenLoopPointer;
	float					*SinLookup;
	float					OutputLevel;
	long					Offset;
	float					CommandOutput;
	long					PhaseDelta;
	long					Theta;
} MEIXmpCommutationBlock;

typedef struct {
	MEIXmpLimitType			Type;
	void					*SourceAddress;
	MEIXmpLimitValue 		LimitValue;
	long					Mask;
} MEIXmpLimitCondition;

typedef struct {
	long					AndMask;
	long					OrMask;
	long					*OutputPtr;
	long					Enabled;
} MEIXmpLimitOutput;

typedef enum {
	MEIXmpLimitDataExecutionStateIDLE = 0,
	MEIXmpLimitDataExecutionStateIN_PROCESS = 1,
} MEIXmpLimitDataExecutionState;

typedef struct {
	MEIXmpLogic				Logic;
	/* These variables are used internally.
	They should not be changed by the Host */
	long					State;
	long					Count;
	MEIXmpLimitCondition	Condition[MEIXmpLimitConditions];
	MEIXmpStatus			Status;
	MEIXmpLimitOutput		Output;
} MEIXmpLimitData;

typedef struct MEIXmpFrame {
	MEIXmpFrameType			Type;
	float					t;
	long					Control;
	long					Position;
	float					Velocity;
	float					Accel;
	float					Jerk;
	float					FeedForward;
} MEIXmpFrame;

typedef struct MEIXmpStartFrame {
	MEIXmpFrameType			Type;
	float					t;
	long					Control;
	long					Reserved[4];	/* used for Position, velocity, accel, and jerk if converted to S-Curve type */
	MEIXmpMoveStatus		Status;	/* needs to be in the same location as MEIXmpIDFrame.Status */
} MEIXmpStartFrame;

typedef enum {
	MEIXmpHoldFrameLogicBIT = 0,
	MEIXmpHoldFrameLogicLESS = (int)0x1,
	MEIXmpHoldFrameLogicGREATER = (int)0x2
} MEIXmpHoldFrameLogic;

typedef struct MEIXmpHoldFrame {
	MEIXmpFrameType			Type;
	float					t;
	long					Control;
	long					*Ptr;
	long					Mask;
	long					Pattern;
	long					Logic;
} MEIXmpHoldFrame;

typedef struct MEIXmpOutputFrame {
	MEIXmpFrameType			Type;
	float					t;
	long					Control;
	long					*Ptr;
	long					OffMask;
	long					OnMask;
} MEIXmpOutputFrame;

/* ID frames do not need to have the Control word because they are always 
	executed in one sample along with the next frame in the list */
typedef struct MEIXmpIDFrame {
	MEIXmpFrameType			Type;
	MEIXmpGeneric64			Position;	/* sample counter will be stored in low word of position data when frame is executed */
	long					Velocity;
	long					MoveID;
	long					ElementID;
	float					MoveTime;
	MEIXmpMoveStatus		Status;
} MEIXmpIDFrame;

typedef struct MEIXmpCamStartEndFrame {
	MEIXmpFrameType			Type;
	float					t;
	long					Reserved[5];
	long					Status;
} MEIXmpCamStartEndFrame;

typedef struct MEIXmpPFFrame {
	MEIXmpFrameType			Type;
	float					t;
	long					Position[3];
	float					FeedForward[3];
} MEIXmpPFFrame;
		
typedef struct MEIXmpPFrame {
	MEIXmpFrameType			Type;
	float					t;
	long					Position[6];
} MEIXmpPFrame;

typedef struct MEIXmpLinkFrame {
	MEIXmpFrameType			Type;
	long					ForwardLink;
	long					ReverseLink;
	long					PositionBiasDelta;
} MEIXmpLinkFrame;

typedef struct MEIXmpUserFrame {
	MEIXmpFrameType			Type;
	float					Tm;
	long					TableNumber;
	float					Vmax;
	float					Ta;
	float					Td;
	float					Tc;
	long					Start;
} MEIXmpUserFrame;

typedef struct {
	long					*PositionDelta;	/* position output from frames (TC.PositionDelta) or prefilter */
	float					*Velocity;		/* velocity output from frames (TC.Velocity) or prefilter */
	long					Delay;		/* number of samples it takes for positions to propagate thru prefilter */
} MEIXmpAxisPreFilter;

typedef struct {
	long LastVelocitySign;	/* Last applied velocity sign, 0 = 0 velocity */
	long Count;				/* Current number of samples that command velocity has remained unchanged, clipped by Limit */
	long Limit;				/* Number of samples that command velocity must remain unchanged before compensation is applied */
} MEIXmpAxisBacklashHysteresis;

typedef struct {
	float Value;			/* Current applied compensation value */
	long ValueL;			/* Current applied compensation value stored as a long, needed to calculate the Delta correctly */
	long Delta;				/* Delta of the backlash value from last sample, used to subtract from actual position */
	float Limit;			/* NOTE: this value will be  the limit specified by the user because the algorithm puts the center point at 0 */
	float Rate;				/* Rate in counts/sample applied by firmware */
	MEIXmpAxisBacklashHysteresis Hysteresis;
} MEIXmpAxisBacklash;

typedef struct {
	MEIXmpGeneric64			ActualPosition;
	MEIXmpGeneric64			CommandPosition;
	MEIXmpGeneric64			FinalCommandPosition;	/* Final target for a sequence of moves (may be different than TargetPosition) */
	MEIXmpGeneric64			PositionError;
	MEIXmpGeneric64			TargetPosition;
	MEIXmpGeneric64			PositionBias;
	long					PositionBiasDelta;
	long					UserPositionDelta;	/* used by the mpi to set the command position - cleared by firmware when applied */
	long					PositionDelta;		/* 32 bit position delta from frames - pre gear etc... */
	long					Position;			/* 32 bit position from frames - pre gear erc... */
	float					Velocity;
	float					Accel;
	float					Jerk;
	float					Remainder;
	long					Delta;
	float					Time;
	float					BacktrackTime;
	MEIXmpAxisPreFilter		PreFilter;
	MEIXmpAxisBacklash		Backlash;
	long					FrameIndex;
	long					LoadIndex;
	MEIXmpFrame				*Frame;
	long					BufferSize;
	long					BufferLowLimit;
	long					BufferEmptyLimit;
} MEIXmpTrajectoryCalculator;

typedef struct {
	long					B;
	long					A;
	long					Old;
	long					Remainder;
} MEIXmpRatio;

typedef struct {
	long					*Ptr;
	long					Position;
	long					Delta;
	MEIXmpRatio				Ratio;
} MEIXmpAxisGear;
	
typedef enum {
	MEIXmpAxisCamTypeNONE = (int)0x00000000,
	MEIXmpAxisCamTypeACTIVE = (int)0x00000001,
	MEIXmpAxisCamTypeACTIVE_VELOCITY = (int)0x00000002,

	/* used by the MPI to store info */
	MEIXmpAxisCamTypeMOTOR_FEEDBACK_PRIMARY = (int)0x00000010,
	MEIXmpAxisCamTypeMOTOR_FEEDBACK_SECONDARY = (int)0x00000020,
	MEIXmpAxisCamTypeAXIS_COMMAND_POSITION = (int)0x00000100,
	MEIXmpAxisCamTypeAXIS_ACTUAL_POSITION = (int)0x00000200,
	MEIXmpAxisCamTypeADDRESS = (int)0x00001000,
	MEIXmpAxisCamTypeTYPE_MASK = (int)0x0000FFF0,
	MEIXmpAxisCamTypeMASTER_INDEX_SHIFT = 16,
	MEIXmpAxisCamTypeMASTER_INDEX_MASK = (int)(0xFF<<MEIXmpAxisCamTypeMASTER_INDEX_SHIFT),
	MEIXmpAxisCamTypeCORRECTION_INDEX_SHIFT = 24,
	MEIXmpAxisCamTypeCORRECTION_INDEX_MASK = (int)(0xFF<<MEIXmpAxisCamTypeCORRECTION_INDEX_SHIFT),
} MEIXmpAxisCamType;

typedef struct {
	MEIXmpAxisCamType		Type;
	long					*MasterPositionPtr;
	long					*MasterPositionCorrectionPtr;
	long					MasterPosition;
	float					*MasterVelocityPtr;
	float					*MasterVelocityCorrectionPtr;
	MEIXmpStatus			*MasterStatus;
	long					MasterStatusMask;	/* this is a long because it may be used for either motor or axis/ms status */
} MEIXmpAxisCam;

typedef struct {
	float	t[MEIXmpMaxUserModifies + 1]; /* main frame + modifies */
	MEIXmpUserFrame	frame[MEIXmpMaxUserModifies];
} MEIXmpUserProfile;

typedef	unsigned long	MEIXmpObjectMap;

typedef union {
	MEIXmpObjectMap	Link[2];
	struct {
		MEIXmpObjectMap	Filter;
		MEIXmpObjectMap	Axis;
	} Motor;
	struct {
		MEIXmpObjectMap	Axis;
		MEIXmpObjectMap	Motor;
	} Filter;
	struct {
		MEIXmpObjectMap	Filter;
		MEIXmpObjectMap	Motor;
	} Axis;
} MEIXmpLinkMap;

typedef struct {
	float	MoveTime;
	float	ElapsedTime;
	long	FinalTime;
	long	Overshoot;
	long	Direction;
	long	Delay;
	long	DelayCount;
} MEIXmpMetrics;

typedef struct {
	long					Domain;
	MEIXmpLinkMap			Map;
} MEIXmpLink;

typedef union {
	struct {
		MEIXmpGeneric64	Position;
		float			MaxVelocity;
		float			MaxAccel;
		float			MaxDecel;
		float			JerkPercent;
		float			AccelJerk;
		float			DecelJerk;
		float			EndVelocity;
		float			Delay;
		long			Control;
		long			*InPtr;
		long			InMask;
		long			InPattern;
		float			InputTimeout;
		long			*OutPtr;
		long			OutOffMask;
		long			OutOnMask;
	} POS;
	struct {
		long			ADCChannel;
		float			Center;
		float			Deadband;
		float			M1;
		float			M3;
	} JOG;
} MEIXmpPoint;

typedef struct {
	long					AxisNumber[MEIXmpMAX_COORD_AXES];
} MEIXmpMSLink;

typedef struct {
	float	Vel;
	float	Accel;
} MEIXmpMSFeedRateRamp;

typedef struct {
	float					Current;		/* Current FeedRate value */
	float					CurrentVel;		/* Current FeedRate Velocity */
	float					Target;			/* Current FeedRate will go to Target FeedRate via ResumeRamp */
	float					Pause;			/* Current FeedRate will go to Target FeedRate via PauseRamp */
	MEIXmpMSFeedRateRamp	ResumeRamp;		/* Current FeedRate will go to Target FeedRate if they are different */
	MEIXmpMSFeedRateRamp	PauseRamp;		/* Current FeedRate will go to Pause FeedRate when Stop/Pause occurs */
	MEIXmpMSFeedRateRamp	EStopRamp;		/* Current FeedRate will go to 0 when EStop occurs */
} MEIXmpMSFeedRate;

typedef struct {
	long					Axes;
	MEIXmpMSLink			*Link;
	MEIXmpMotionType		Mode;
	MEIXmpMotionType		TriggeredModifyMode;
	long					TriggeredModifyStart;
	MEIXmpMSFeedRate		FeedRate;
	float					TimeDelta;
	MEIXmpAction			Action;
	MEIXmpActionStatus		ActionStatus;
	long					ActionID;
	MEIXmpHostSignal		*Signal;
	MEIXmpStatus			Status;
	MEIXmpState				State;
	MEIXmpStatus 			StatusMask;
	long					MoveStart;
	long					ModifyFlag;
	float					BlendLimit;
	long			   		Reserved[6]; /* Ensure even cache boundaries */
} MEIXmpMotionSupervisor;

typedef struct {
	long					CreateCount;
	MEIXmpUserlabel			label;
} MEIXmpMotionSupervisorExternal;

typedef enum {
	MEIXmpAxisGantryTypeNONE = 0,
	MEIXmpAxisGantryTypeLINEAR = 1,
	MEIXmpAxisGantryTypeTWIST = 2
} MEIXmpAxisGantryType;

typedef struct {
	MEIXmpLink				*Link;
	MEIXmpMotionSupervisor	*MS;
	long					SubSampleRate;			/* 1 = every sample, 2 = every other sample, 4 = every 4th sample */
	long					*FeedbackDeltaPtr[MEIXmpAxisPosInputs];
	MEIXmpGeneric64			ActPosition;
	MEIXmpGeneric64			CmdPosition;
	MEIXmpGeneric64			Origin;
	float					TargetVelocity;
	long					CompensationDelta;
	float					ActualVelocity;
	float					CommandVelocity;
	float					PositionError;
	float					FeedForward;
	float					FinePosTolerance;
	unsigned long			CoarsePosTolerance;
	float					VelTolerance;
	long					SettlingTime;
	long					SettlingCount;
	MEIXmpStatus			SettlingMask;
	MEIXmpStatus			Status;
	MEIXmpState				State;
	MEIXmpMoveStatus		MoveStatus;
	MEIXmpMetrics			Metric;
	long					ModifyIndex;
	float					ModifyTime;
	MEIXmpTrajectoryCalculator	TC;
	MEIXmpHostSignal		*Signal;
	MEIXmpAxisGear			Gear;
	MEIXmpAxisCam			Cam;
	MEIXmpAxisGantryType	GantryType;
	long					MoveIDBackground;		/* background copy of foreground MoveID */
	long					MoveID;
	long					ElementID;
	MEIXmpUserProfile		UserProfile;
	long					Reserved[1];
} MEIXmpAxis;

typedef struct {
	MEIXmpGeneric64				*InputPosition;
	MEIXmpGeneric64				MinPosition;
	long						DeltaPosition;
	long						CompPoints;
} MEIXmpCompensatorControl;

typedef struct {
	long						Dimension;
	long						*OutputDelta;
	long						CompensatorValue;
	MEIXmpCompensatorControl	Control[MEIXmpMAXCompDimensions];
	long						*CompTable;
	long						CompTableSize;	/* for MPI */
} MEIXmpCompensator;

typedef struct {
	MEIXmpUserlabel			label;
} MEIXmpAxisExternal;

typedef struct {
	MEIXmpAxis				*Ptr;
	float					Coeff;
} MEIXmpAxisInput;

typedef struct {
	MEIXmpUserlabel			label;
	MEIXmpPostFilter		PostFilter;
	MEIXmpGain				*AssociatedGainIndex;	/* normally points to own filter's GainIndex */
	long					GainDelay;
	long					GainDelayCount;
	long					GainWindow;
	MEIXmpSwitchType		PPISwitchType;
	long					PPIDelay;
	long					PPIDelayCount;
	long					PPIWindow;
	MEIXmpIntResetConfig	ResetIntegratorConfig;
	long					ResetIntegratorDelay;
	MEIXmpIntResetStatus	ResetIntegratorStatus;
	long					ResetIntegratorDelayCount;
} MEIXmpFilterExternal;

typedef struct {
	MEIXmpFilterExternal		*External;
	MEIXmpAlgorithm				Algorithm;
	MEIXmpAxisInput				Axis[MEIXmpFilterAxisInputs];
	float						PositionError;
	long						*VelPtr;
	float						ControlOutput;
	MEIXmpFilterData			Data;
	MEIXmpSwitchType			GainSwitchType;
	MEIXmpPPIMode				PPIMode;
	MEIXmpGain					GainIndex;
	MEIXmpNodeIntegratorDisable	NodeIntegratorDisable;
	MEIXmpFilterForm			PostFilterForm;
	MEIXmpFilterCoeff			*Coeff[MEIXmpMaxGainTables];
	long						Reserved[1];
} MEIXmpFilter;

typedef struct {
	MEIXmpFilter		Filter[MEIXmpMAX_Filters];
	MEIXmpFilterCoeff	Coeff0[MEIXmpMAX_Filters];
	MEIXmpFilterCoeff	Coeff1[MEIXmpMAX_Filters];
	MEIXmpFilterCoeff	Coeff2[MEIXmpMAX_Filters];
	MEIXmpFilterCoeff	Coeff3[MEIXmpMAX_Filters];
	MEIXmpFilterCoeff	Coeff4[MEIXmpMAX_Filters];
} MEIXmpStandardAlgorithm;


typedef struct {
  MEIXmpStandardAlgorithm	Standard;
} MEIXmpControlLaw;

typedef struct {
	MEIXmpLink	Link;
  	long		Block;
  	long		MotorIndex;
} MEIXmpMotorLink;

typedef struct {
	long	*Ptr;
	long	Config;
	long	IO;
} MEIXmpIO;

typedef struct {
	long	InputMask;
	long	OutputMask;
} MEIXmpIOMask;

typedef struct {
	long				*Ptr;
	MEIXmpIOMask		IOMask[MEIXmpMotorStatusOutputs];
} MEIXmpStatusOutput;

typedef enum {
	MEIXmpEncoderSourceMapNONE = 0,		/* Do not remap pointer */
	MEIXmpEncoderSourceMapSTANDARD = 1,	/* map to standard feedback */
	MEIXmpEncoderSourceMapLOOPBACK = 2	/* map to step loopback */
} MEIXmpEncoderSourceMap;


/* Encoder Configuration */
typedef enum {
	MEIXmpMotorEncoderConfigTypeMASK				= (int)0x0000FFFF,
	MEIXmpMotorEncoderConfigTypeQUAD_AB				= (int)0x00000000,
	MEIXmpMotorEncoderConfigTypeDRIVE				= (int)0x00000001,
	MEIXmpMotorEncoderConfigTypeSSI					= (int)0x00000002,
	MEIXmpMotorEncoderConfigProcessMASK				= (int)0xFFFF0000,
	MEIXmpMotorEncoderConfigProcessModulo			= (int)0x00000000,
	MEIXmpMotorEncoderConfigProcessReverseModulo	= (int)0x80000000,
} MEIXmpMotorEncoderConfig;

typedef struct {
	MEIXmpMotorEncoderConfig	Config;
	long						*Ptr;
	MEIXmpRatio					Ratio;
	unsigned long				Modulo;
	unsigned long				OldValue;
	MEIXmpGeneric64				Value;
	long						Delta;
} MEIXmpMotorIOEncoder;

typedef struct {
	MEIXmpEncoderSourceMap	SourceMap;
	long					*DefaultPtr;	/* placeholder for MPI */
} MEIXmpMotorIOEncoderExternal;

typedef struct {
	long					CaptureUsedMask;
	long					*Command;
	long					*Status;
	long					*CaptureData;
	long					*CompareData;
} MEIXmpMotorCaptureCompare;

typedef struct {
	MEIXmpIO				DedicatedIn;					/* Dedicated */
	MEIXmpIO				GeneralIn; 						/* General Purpose / User */
	MEIXmpIO				DedicatedOut;					/* Dedicated */
	MEIXmpIO				GeneralOut;						/* General Purpose / User */
	MEIXmpMotorControl		Control;
	MEIXmpDemandChannel		DemandChannel[MEIXmpMAX_Demands_Per_Motor];
	long					EncoderCount;
	MEIXmpMotorIOEncoder	Encoder[MEIXmpMotorEncoders];
	long					MotorOutput;
	long					HostOutput;
} MEIXmpMotorIO;

typedef struct {
	MEIXmpMotorIOEncoderExternal	Encoder[MEIXmpMotorEncoders];
	MEIXmpStatusOutput				StatusOutput;
	MEIXmpDACPhase					Phase;
	long							*Monitor;
} MEIXmpMotorIOExternal;

typedef struct {
	MEIXmpIO			Input[MEIXmpMAXControlIOWords];
	MEIXmpIO			Output[MEIXmpMAXControlIOWords];
	MEIXmpIOMask		Mask[MEIXmpMAXControlIOWords];
	long				HostOutput[MEIXmpMAXControlIOWords];
	long				ControlOutput[MEIXmpMAXControlIOWords];
} MEIXmpControlIO;

typedef struct {
	MEIXmpLimitData				Limit[MEIXmpLimitLAST];
} MEIXmpMotorLimit;

typedef struct {
	MEIXmpLimitData				Limit[MEIXmpLimitDEDICATED_LAST];
} MEIXmpMotorLimitDedicated;

typedef struct {
	MEIXmpLimitData				Limit[MEIXmpLimitUSER_COUNT];
} MEIXmpMotorLimitUser;

typedef struct {
	MEIXmpBrakeMode	BrakeMode;
	long			BrakeEnableDelay;
	long			BrakeEnableDelayCount;
	long			BrakeDisableDelay;
	long			BrakeDisableDelayCount;
} MEIXmpMotorBrake;

typedef struct {
	MEIXmpMotorEnableState		EnableState;
	long						EnableDelay;
	long						AbortDelay;
	long						AbortDelayCount;
	MEIXmpMotorBrake			Brake;
} MEIXmpMotorEnable;

typedef struct {
	long							Index;
	long							SubSampleRate;			/* 1 = every sample, 2 = every other sample, 4 = every 4th sample */
	MEIXmpMotorLink					*Link;
	MEIXmpMotorType					Type;
	MEIXmpStatus					Status;
	MEIXmpStatus					DisableAction;	/* Either MEIXmpStatusNONE or MEIXmpStatusDISABLED (default) */
	MEIXmpHostSignal				*Signal;			/* Pointer to external memory buffer holding Signal info and pointers */
	MEIXmpMotorIO					IO;
	MEIXmpMotorEnable				Enable;
	MEIXmpCommutationBlock			Commutation;
	MEIXmpStatus					UserBlockFaultAction;
	MEIXmpStatus					SynqNetNodeFailAction;
	long							Reserved[5];
} MEIXmpMotor;

typedef struct {
	MEIXmpUserlabel					label;
	MEIXmpMotorIOExternal			IO;
	MEIXmpMotorCaptureCompare		CaptureCompare;
	MEIXmpServiceCommand			*ConfigCommands;	/* Pointer to SynqNetServiceCommands for FPGA */
	MEIXmpStepControl				StepControl;
} MEIXmpMotorExternal;

typedef enum {
	MEIXmpCaptureTypeNONE = (int)0x00000000,
	MEIXmpCaptureTypeNORMAL = (int)0x00000001,
	MEIXmpCaptureTypeTIME_BASED = (int)0x00000002,
	MEIXmpCaptureTypeHOMING = (int)0x00000004,
	MEIXmpCaptureTypeNORMAL_HOMING = (int)(MEIXmpCaptureTypeNORMAL | MEIXmpCaptureTypeHOMING),
	MEIXmpCaptureTypeTIME_BASED_HOMING = (int)(MEIXmpCaptureTypeTIME_BASED | MEIXmpCaptureTypeHOMING)
} MEIXmpCaptureType;

typedef enum {
	MEIXmpCaptureHandshakeStateDISABLED = (int)0x00000000,	/* No Action taken by firmware */
	MEIXmpCaptureHandshakeStateDISABLE = (int)0x00000001,	/* MPI initiates this state, firmware clears capture arm and goes to DISABLED */
	MEIXmpCaptureHandshakeStateIDLE = (int)0x00000002,		/* MPI initiates this state, firmware arms captures and advances */
	MEIXmpCaptureHandshakeStateARMED = (int)0x00000003,		/* Firware waits for trigger.  Advances when seen */
	MEIXmpCaptureHandshakeStateTRIGGERED = (int)0x00000004,	/* Firmware calculates result, clears handshake, and advances */
	MEIXmpCaptureHandshakeStateHOMING = (int)0x00000005,		/* Firmware waits for Home bit in motor Status */
	MEIXmpCaptureHandshakeStateCLEAR = (int)0x00000006,		/* Firmware waits for FPGA to clear.  Advances when seen */
	MEIXmpCaptureHandshakeStateDONE = (int)0x00000007		/* No Action taken by firmware, tirgger is complete */
} MEIXmpCaptureHandshakeState;

typedef struct {
	MEIXmpCaptureType			Type;
	MEIXmpCaptureHandshakeState State;
	long						*Command;				/* Pointer to capture command word */
	long						*Status;				/* Pointer to capture status word */
	long						CommandMask;			/* Indicates which capture within capture and status words for command */
	long						StatusMask;				/* Indicates which capture within capture and status words for status */
	long						Sources;				/* bits 0-7: Trigger Motor, 8-15: Trigger Node, 16-19: Trigger Encoder, 20-23: Trigger Capture, 24-31: Data Motor */
} MEIXmpCaptureControl;

typedef struct {
	long						*FeedbackLatchTime;		/* pointer to this sample's Feedback time */
	long						SampleTime;				/* Time in native (to node) ticks for one sample */
	long						TimeCaptureDelta;		/* Time in native (to node) ticks when capture occurred relative to FeedbackLatchTime from 2 sample ago
															TimeCaptureDelta + FeedbackLatchTime is relative to SampleCounter - 2 */
	long						SampleCounter;			/* SampleCounter value when capture is processed */
	MEIXmpGeneric64				*Feedback;				/* pointer to this sample's Feedback Data (usually position) */
	MEIXmpGeneric64				OldFeedback;			/* last sample's Feedback Data */
	long						*Captured;				/* Position or time */
	MEIXmpGeneric64				Latched;				/* calculated latched feedback data (usually position) */
} MEIXmpCaptureData;

typedef struct {
	MEIXmpCaptureControl		Control;
	MEIXmpCaptureData			Data;
} MEIXmpCapture;


/* use to generate signals to stimulate systems during analysis */
typedef struct {
	MEIXmpTestSignalMode	Mode;
	MEIXmpTestSignalDest	Destination;
	long					longData[2];
	float					floatData[2];
	float					Output1;
	float					Output2;
	long					Reserved[7];
}MEIXmpSignalGenerator;

typedef enum {
	MEIXmpRecorderTriggerTypeNONE,
	MEIXmpRecorderTriggerTypeEQ,
	MEIXmpRecorderTriggerTypeGREATER_THAN_OR_EQ,
	MEIXmpRecorderTriggerTypeLESS_THAN_OR_EQ,
	MEIXmpRecorderTriggerTypeNOT_EQ,
	MEIXmpRecorderTriggerTypeREPEAT = 0x80000000,
	MEIXmpRecorderTriggerTypeMATCH = MEIXmpRecorderTriggerTypeEQ,
	MEIXmpRecorderTriggerTypeCHANGE = (MEIXmpRecorderTriggerTypeNOT_EQ | MEIXmpRecorderTriggerTypeREPEAT)
} MEIXmpRecorderTriggerType;

typedef struct	MEIXmpRecorderTrigger {
	MEIXmpRecorderTriggerType	type;
	unsigned long			*ptr;
	unsigned long			mask;
	unsigned long			pattern;
	unsigned long			count;
} MEIXmpRecorderTrigger;

typedef struct	MEIXmpRecorderExternal {
	MEIXmpRecorderTrigger	trigger[MEIXmpMaxRecorderTriggers];
	long					*RecAddress[MEIXmpMaxRecSize];
} MEIXmpRecorderExternal;


typedef struct {
	long					*RecorderBuffer;
	long					RecSize;
	long					Period;
	long					BufferLimit;
	long					RecsOut;
	long					RecsIn;
	long					RecOut;
	long					RecIn;
	long					Sample;
	long					Count;
	long					Enable;
	long					Full;
	long					HighCount;
	long					WrapEnable;
	MEIXmpStatus			Status;
	MEIXmpHostSignal		*Signal;
} MEIXmpDataRecorder;

typedef struct {
	long					MaxMessages;
	long					HostMsgREQ;
	long					HostMsgACK;
	long					MsgIn;
} MEIXmpHostMessageControl;

typedef struct {
	MEIXmpHostSignal		*Signal;
	MEIXmpSignalID			ID;
	long					EventMask;
	long					UserData[MEIXmpSignalUserData];
} MEIXmpMessage;

typedef struct {
	MEIXmpHostMessageControl Control;
	MEIXmpMessage			*Message;
} MEIXmpHostMessage;

typedef struct MEIXmpDomainMap {
	MEIXmpObjectMap		Motor;
	MEIXmpObjectMap		Filter;
	MEIXmpObjectMap		Axis;
} MEIXmpDomainMap;

typedef struct MEIXmpDomain {
	MEIXmpStatus		Status;
	MEIXmpStatus		NewStatus;
} MEIXmpDomain;

typedef struct {
	MEIXmpDomainMap		DomainMap[MEIXmpMAX_Domains];
	MEIXmpMotorLink		MotorLink[MEIXmpMAX_Motors];
	MEIXmpLink			FilterLink[MEIXmpMAX_Filters];
	MEIXmpLink			AxisLink[MEIXmpMAX_Axes];
	MEIXmpMSLink		MSLink[MEIXmpMAX_MSs];
} MEIXmpLinkBuffer;

typedef struct {
	MEIXmpCommand		Command[MEIXmpCmdBuffSize];
	long				Map[(MEIXmpCmdBuffSize + 31)/32];		/* round up */
} MEIXmpCommandBuffer;

typedef struct {
	long				Data[MEIXmpUserDataSize];
	long				Map[(MEIXmpUserDataSize + 31)/32];		/* round up */
} MEIXmpUserBuffer;

typedef struct {
	long			Control;
	long			Input;
	long			RawData;
} MEIXmpADC;

typedef struct {
	long					Enable;
	long					MotorNumber;
	long					LimitNumber;
	long					BufferIndex;
	long					BufferMax;
	long					Mode;
	long					Offset;
	long					CycleLength;
	long					Data[MEIXmpLimitBufferMax];
} MEIXmpLimitBuffer;

typedef union {
	MEIXmpLimitBuffer	LimitBuffer[MEIXmpMAX_Motors];
} MEIXmpCustomBuffer;

typedef enum {
	MEIXmpMotionBlockTypeNONE = 0,
	MEIXmpMotionBlockTypeANALOG = 1,
	MEIXmpMotionBlockTypeSTEP = 2,
	MEIXmpMotionBlockTypeIO = 3
} MEIXmpMotionBlockType;

typedef enum {
	MEIXmpNetworkTypeINVALID	= -1,

	MEIXmpNetworkTypeNONE = 0,	/* For local memory mapped data */
  	MEIXmpNetworkTypeSYNQNET,

  	MEIXmpNetworkTypeLAST,
  	MEIXmpNetworkTypeFIRST =  MEIXmpNetworkTypeINVALID + 1
} MEIXmpNetworkType;

typedef enum MEIXmpBlockEvent {
	MEIXmpBlockEventNODE_IO_FAULT = 0,
	MEIXmpBlockEventANALOG_POWER_FAULT = 1,
	MEIXmpBlockEventIO_ABORT = 2,
	MEIXmpBlockEventALARM = 3,
	MEIXmpBlockEventDISABLE = 4,
	MEIXmpBlockEventUSER_FAULT = 5,
	MEIXmpBlockEventNODE_FAILURE = 6
} MEIXmpBlockEvent;

typedef enum MEIXmpBlockStatus {
	MEIXmpBlockStatusNONE = 0,
	MEIXmpBlockStatusNODE_IO_FAULT = (int)(1 << MEIXmpBlockEventNODE_IO_FAULT),
	MEIXmpBlockStatusANALOG_POWER_FAULT = (int)(1 << MEIXmpBlockEventANALOG_POWER_FAULT),
	MEIXmpBlockStatusIO_ABORT = (int)(1 << MEIXmpBlockEventIO_ABORT),
	MEIXmpBlockStatusALARM = (int)(1 << MEIXmpBlockEventALARM),
	MEIXmpBlockStatusDISABLE = (int)(1 << MEIXmpBlockEventDISABLE),
	MEIXmpBlockStatusUSER_FAULT = (int)(1 << MEIXmpBlockEventUSER_FAULT),
	MEIXmpBlockStatusNODE_FAILURE = (int)(1 << MEIXmpBlockEventNODE_FAILURE)
} MEIXmpBlockStatus;

typedef struct MEIXmpBlockNetwork {
	MEIXmpNetworkType	Type;			
	unsigned long		Number;			/* network number	  */
	unsigned long		BlockAddress;	/* address on network */
	long				AsynqDelayOut;
	long				AsynqDelayIn;
} MEIXmpBlockNetwork;

typedef struct {
	long			DeviceID;
	long			Version;
	long			ProductID;
	long			ProductOption;
	long			BootID;
	long			SegmentChecksum;
	long			ResourceIndex;	/* Used by MPI Only */
} MEIXmpBlockID;

typedef struct {
	long			DeviceID;
	long			ProductID;
	long			ProductOption;
	long			SegmentChecksum;
} MEIXmpBlockIDMisMatch;

typedef struct {
	MEIXmpBlockID			ID;
	MEIXmpBlockIDMisMatch	IDMisMatch;
	long					MotorCount;
	long					MotorOffset;
	long					DriveCount;
	MEIXmpObjectMap			SecondaryEncoderMap;
} MEIXmpBlockResources;

typedef struct {
	long						Count;
	MEIXmpServiceCommandGeneral	*Cmd;	/* Pointer to SynqNetServiceCommands for initializaton */
	MEIXmpServiceStatus			*Status;
} MEIXmpBlockConfigAsynq;

typedef struct {
	long						*Ptr;
	long						Mask;
	long						Polarity;
	MEIXmpSqMacFlagMask			Command;
} MEIXmpBlockUserFault;

typedef enum {
	MEIXmpBlockSynqInitCommandPLLPeriod = (int)0x00000001,
	MEIXmpBlockSynqInitCommandPLLReset = (int)0x00000002,
	MEIXmpBlockSynqInitCommandPLLBoot = (int)0x00000004,
	MEIXmpBlockSynqInitCommandPLLClockToDriveConfig = (int)0x00000008,
	MEIXmpBlockSynqInitCommandSerialClockConfig = (int)0x00000010,
	MEIXmpBlockSynqInitCommandSerialPortConfig = (int)0x00000020,
	MEIXmpBlockSynqInitCommandSerialTxMessageConfig = (int)0x00000040,
	MEIXmpBlockSynqInitCommandSerialRxMessageConfig = (int)0x00000080,
	MEIXmpBlockSynqInitCommandSynqPeriod = (int)0x00000100,
	MEIXmpBlockSynqInitCommandDriveUpdatePeriod = (int)0x00000200,
	MEIXmpBlockSynqInitCommandDriveInitPolling = (int)0x00000400,
	MEIXmpBlockSynqInitCommandNOP = (int)0x00000800,
	MEIXmpBlockSynqInitCommandSerialClockInvertSetBeforeDPReset = (int) 0x00001000,  
	MEIXmpBlockSynqInitCommandSerialClockInvertClearAfterDPReset = (int) 0x00002000
} MEIXmpBlockSynqInitCommand;

typedef struct {
	MEIXmpBlockSynqInitCommand		Command;					/* Mask indicating which of the following commands to send to node/drive */
	long							PLLPeriod;					/* F1000 */				/* set in node to start cyclic operation */
	long							PLLReset;					/* F1004 - reset value */
	long							PLLResetDelay;				/* mS */
	long							PLLBoot;					/* F1004 - boot value */
	long							PLLBootDelay;				/* mS */
	long							PLLClockToDriveConfig;		/* F1008 */				/* set in node */
	long							SerialClockConfig;			/* F2000 */				/* set in node */
	long							SerialPortConfig;			/* F2004 */				/* set in node */
	long							SerialTxMessageConfig[8];	/* F2040 - F205C */		/* set in node - used for all drive on node */
	long							SerialRxMessageConfig[8];	/* F2080 - F209C */		/* set in node - used for all drives on node */
	long							SynqPeriod;					/* direct command */	/* send to each drive on the node */
	long							DriveUpdatePeriod;			/* direct command */	/* send to each drive on the node */
	long							Reserved;					/* Used by MPI Only, not processed by firmware */
} MEIXmpBlockSynqInit;

typedef enum MEIXmpBlockIOSegmentLengths {
    MEIXmpBlockIOSegmentLengthsDIGITAL_IN_MASK	= (int)0x000000FF,
    MEIXmpBlockIOSegmentLengthsDIGITAL_OUT_MASK	= (int)0x0000FF00,
    MEIXmpBlockIOSegmentLengthsANALOG_IN_MASK	= (int)0x00FF0000,
	MEIXmpBlockIOSegmentLengthsANALOG_OUT_MASK	= (int)0xFF000000,

    MEIXmpBlockIOSegmentLengthsDIGITAL_IN_SHIFT	= (int)0,
    MEIXmpBlockIOSegmentLengthsDIGITAL_OUT_SHIFT= (int)8,
    MEIXmpBlockIOSegmentLengthsANALOG_IN_SHIFT	= (int)16,
	MEIXmpBlockIOSegmentLengthsANALOG_OUT_SHIFT	= (int)24
} MEIXmpBlockIOSegmentLengths;

typedef enum MEIXmpBlockIOSegmentCounts {
    MEIXmpBlockIOSegmentCountsDIGITAL_IN_MASK	= (int)0x000000FF,
    MEIXmpBlockIOSegmentCountsDIGITAL_OUT_MASK	= (int)0x0000FF00,
    MEIXmpBlockIOSegmentCountsANALOG_IN_MASK	= (int)0x00FF0000,
	MEIXmpBlockIOSegmentCountsANALOG_OUT_MASK	= (int)0xFF000000,

    MEIXmpBlockIOSegmentCountsDIGITAL_IN_SHIFT	= (int)0,
    MEIXmpBlockIOSegmentCountsDIGITAL_OUT_SHIFT	= (int)8,
    MEIXmpBlockIOSegmentCountsANALOG_IN_SHIFT	= (int)16,
	MEIXmpBlockIOSegmentCountsANALOG_OUT_SHIFT	= (int)24
} MEIXmpBlockIOSegmentCounts;

typedef struct {
	MEIXmpBlockIOSegmentCounts	Counts;
	MEIXmpBlockIOSegmentLengths	Lengths;
} MEIXmpBlockIOSegment;

#define MEIXmpBlockIOSegmentMAX 32

typedef enum MEIXmpBlockIOSize {
    MEIXmpBlockIOSizeLENGTH_MASK	= (int)0x000001FF,
    MEIXmpBlockIOSizeCOUNT_MASK		= (int)0x0FFF0000,

    MEIXmpBlockIOSizeLENGTH_SHIFT = (int)0,
    MEIXmpBlockIOSizeCOUNT_SHIFT  = (int)16
} MEIXmpBlockIOSize;

typedef struct {
	long					MaxWait;
	long					LastSampleCounter;
	long					*DigitalInPtr;
	long					*DigitalOutPtr;
	long					*AnalogInPtr;
	long					*AnalogOutPtr;
	long					SegmentCount;
	MEIXmpBlockIOSize		DigitalInSize;
	MEIXmpBlockIOSize		DigitalOutSize;
	MEIXmpBlockIOSize		AnalogInSize;
	MEIXmpBlockIOSize		AnalogOutSize;
	MEIXmpBlockIOSegment	Segment[MEIXmpBlockIOSegmentMAX];
} MEIXmpBlockIO;

typedef struct {
	MEIXmpUserlabel				label;
	MEIXmpMotionBlockType		Type;
 	MEIXmpBlockNetwork			Network;
	MEIXmpBlockResources		Resources;
	float						ControlLatencyMin;
	float						ControlLatencyMax;
	MEIXmpBlockConfigAsynq		ConfigAsynq;
	long						*SynqNetStatus;
	long						*SynqNetCommand;
	MEIXmpBlockStatus			Status;
	MEIXmpHostSignal			*Signal;
	MEIXmpBlockUserFault		UserFault;
	MEIXmpSynqNetServiceControl	SynqNetServiceCtrl;
	MEIXmpServiceCommandGeneral	SynqNetServiceCommand;
	MEIXmpServiceStatus			SynqNetServiceStatus;
	void						*TxBuff;
	void						*RxBuff;
	long						*FeedbackTime;
	MEIXmpBlockSynqInit			SynqInit;
	MEIXmpIO					AuxIN;
	MEIXmpIO					AuxOUT;
	MEIXmpBlockIO				IO;
	long						Reserved[6];
} MEIXmpBlock;


typedef enum MEIXmpSynqNetInternalState {
	MEIXmpSynqNetInternalStateINVALID = -1,

	MEIXmpSynqNetInternalStateBOOT,
	MEIXmpSynqNetInternalStateSHUTDOWN,			/* Network error occured OR User halts Network */
	MEIXmpSynqNetInternalStateVALIDATE,
	MEIXmpSynqNetInternalStateRESET_REQ,
	MEIXmpSynqNetInternalStateRESET_ACK,
	MEIXmpSynqNetInternalStateVERIFY,
	MEIXmpSynqNetInternalStateVERIFY_BLANK,		/* Network Info not yet stored to flash */
	MEIXmpSynqNetInternalStateVERIFY_FAIL_FLASH,	/* Network does not match the Network Info in flash */
	MEIXmpSynqNetInternalStateVERIFY_FAIL_FLASH_TOPOLOGY,	/* Network does not match the Network Info in flash - Topology is different */
	MEIXmpSynqNetInternalStateVERIFY_FAIL_FLASH_CABLE,	/* Network does not match the Network Info in flash - cable lengths are different */
	MEIXmpSynqNetInternalStateVERIFY_FAIL_WORKING,		/* Network does not match the Network Info in working memory */
	MEIXmpSynqNetInternalStateCONFIG,			/* Send configurations in flash to nodes */
	MEIXmpSynqNetInternalStateCYCLIC_FLASH,		/* Network configured with Network Info in flash */
	MEIXmpSynqNetInternalStateCYCLIC_DEFAULT,	/* Network configured by MPI with defaults - flash is blank */
	MEIXmpSynqNetInternalStateCYCLIC_DEFAULT_BAD_FLASH,	/* Network configured by MPI with defaults - flash contains Bad Network Info */

	MEIXmpSynqNetInternalStateLAST,
	MEIXmpSynqNetInternalStateFIRST = MEIXmpSynqNetInternalStateINVALID + 1
} MEIXmpSynqNetInternalState;

/* for use with MPI SynqNet States */
typedef enum MEIXmpSynqNetState {
	MEIXmpSynqNetStateINVALID = -1,

	MEIXmpSynqNetStateNONE,		/* needed for synqnet stateRequest */
	MEIXmpSynqNetStateBOOT,
	MEIXmpSynqNetStateSHUTDOWN,
	MEIXmpSynqNetStateDISCOVERY,
	MEIXmpSynqNetStateASYNQ,
	MEIXmpSynqNetStateSYNQ_NO_ERROR_CHECKING,
	MEIXmpSynqNetStateSYNQ,
	MEIXmpSynqNetStateSYNQ_RECOVERY_DISABLED,
	MEIXmpSynqNetStateSYNQ_RECOVERY_ENABLED,
	MEIXmpSynqNetStateSYNQ_RECOVERING,

	MEIXmpSynqNetStateLAST,
	MEIXmpSynqNetStateFIRST = MEIXmpSynqNetStateINVALID + 1
} MEIXmpSynqNetState;

typedef enum MEIXmpSynqNetRecoveryMode {
	MEIXmpSynqNetRecoveryModeNONE = 0,
	MEIXmpSynqNetRecoveryModeSINGLE_SHOT,
	MEIXmpSynqNetRecoveryModeAUTO_ENABLE
} MEIXmpSynqNetRecoveryMode;

typedef enum MEIXmpSynqNetTestMode {
	MEIXmpSynqNetTestModeOFF = 0,
	MEIXmpSynqNetTestModeSTEP,
	MEIXmpSynqNetTestModeRAMP,
	MEIXmpSynqNetTestModeRANDOM
} MEIXmpSynqNetTestMode;

typedef struct MEIXmpSynqNetTest {
	MEIXmpSynqNetTestMode	Mode;
	long					Min;
	long					Delta;
	long					Period;
	float					Rate;	/* 1/Period */
	long					Count;
} MEIXmpSynqNetTest;

typedef enum MEIXmpSynqNetTopology {
	MEIXmpSynqNetTopologyNONE = 0,	/* no nodes found */
	MEIXmpSynqNetTopologySTRING = 1,
	MEIXmpSynqNetTopologyRING = 2,
} MEIXmpSynqNetTopology;

typedef struct MEIXmpSynqNetTopologyInfo {
	MEIXmpSynqNetTopology			Topology;
	long							BlockCount;
	long							OutPortBlockCount;
	long							InPortBlockCount;
	long							OutPortTerminated;		/* For String Topology */
	long							InPortTerminated;		/* For String Topology */
} MEIXmpSynqNetTopologyInfo;

typedef struct MEIXmpSynqNetTopologyInfoMisMatch {
	MEIXmpSynqNetTopology			Topology;
	long							BlockCount;
	long							OutPortBlockCount;
	long							InPortBlockCount;
} MEIXmpSynqNetTopologyInfoMisMatch;

typedef struct {
	long Min;
	long Max;
	long Nominal;
	long Measured;
} MEIXmpSynqNetCableLength;	/* lengths are in timer counts for propagation delay */

typedef struct {
	MEIXmpSynqNetCableLength	Cable[MEIXmpMaxSynqNetBlocks+1];
} MEIXmpSynqNetCableLengthTable;

typedef struct MEIXmpSynqNet {
	MEIXmpSynqNetTopologyInfo			TopologyInfo;
	MEIXmpSynqNetTopologyInfoMisMatch	TopologyInfoMisMatch;
	MEIXmpSynqNetState					State;
	MEIXmpSynqNetState					StateRequest;	/* set by host to request firmware to change synqNet state - cleared by firmware */
	MEIXmpSynqNetInternalState			InternalState;
	MEIXmpSynqNetRecoveryMode			RecoveryMode;	/* Applies to Ring Only */
	MEIXmpSynqNetStatus					Status;
	long								*SynqTxData;
	long								*SynqRxData;
	long								*RinconDMATx;
	long								*RinconDMARx;
	long								RinconDMA_Tx_Timer;
	long								RinconDMA_Rx_Timer;
	long								RinconDMA_Continuous_Timer;
	long								RinconMII_Tx_Timer;
	long								RinconRx_Copy_Timer;
	long								RinconTx_Packet_Gap;
	long								FailedBlockMask;
	long								ShutdownBlockMask;		/* set by MPI only */
	long								RxErrorCount;
	long								InitializationCount;	/* bumped everytime a synqnet init occurs, not set to 0 on reset */
	MEIXmpSynqNetCableLengthTable		CableLengthTable;
	long								RinconFAULT_Limit[MEIXmpMaxSynqNetBlocks];
	long								RinconFAIL_Limit[MEIXmpMaxSynqNetBlocks];
	MEIXmpSynqNetTest					Test;
	MEIXmpHostSignal 					*Signal;
	long								Reserved;
} MEIXmpSynqNet;

#define MEIXmpBlockConfigCount				(3)	/* reflects the number of structures/commands in MEIXmpBlockConfig */

typedef struct
{	MEIXmpServiceCommandGeneral			PacketErrorThreshold;
	MEIXmpServiceCommandGeneral			IOAbortConfig;
	MEIXmpServiceCommandGeneral			NodeAlarmConfig;
} MEIXmpBlockConfig;

typedef struct
{	long Address;
	long Configuration;
	long Status;
} MEIXmpServiceCommandMotorConfigFeedback;

typedef struct
{	long Flags;					/* 0x7FF bits are the SubCount, 0xF800 bits are the AddressIncrement */
	MEIXmpServiceCommandMotorConfigFeedback Command;
} MEIXmpMotorConfigFeedback;

typedef struct
{	long Address;
	long Configuration;
} MEIXmpServiceCommandMotorConfigFeedbackSample;

typedef struct
{	long Flags;					/* 0x7FF bits are the SubCount, 0xF800 bits are the AddressIncrement */
	MEIXmpServiceCommandMotorConfigFeedbackSample Command;
} MEIXmpMotorConfigFeedbackSample;

typedef struct
{	long Address;
	long Status;
	long Configuration;
	long BaudRate;
	long Period;
	long Offset;
	long InputSelect;
} MEIXmpServiceCommandMotorConfigFeedbackSSI;

typedef struct
{	long Flags;					/* 0x7FF bits are the SubCount, 0xF800 bits are the AddressIncrement */
	MEIXmpServiceCommandMotorConfigFeedbackSSI Command;
} MEIXmpMotorConfigFeedbackSSI;

typedef struct
{	long Address;
	long Configuration;
} MEIXmpServiceCommandMotorConfigDac7849;

typedef struct
{	long Flags;					/* 0x7FF bits are the SubCount, 0xF800 bits are the AddressIncrement */
	MEIXmpServiceCommandMotorConfigDac7849 Command;
} MEIXmpMotorConfigDac7849;

typedef struct
{	long Address;
	long Data;
} MEIXmpServiceCommandMotorConfigOneOverT;

typedef struct
{	long Flags;					/* 0x7FF bits are the SubCount, 0xF800 bits are the AddressIncrement */
	MEIXmpServiceCommandMotorConfigOneOverT Command;
} MEIXmpMotorConfigOneOverT;

typedef struct
{	long Address;
	long Data;
} MEIXmpServiceCommandMotorConfigOneOverN;

typedef struct
{	long Flags;					/* 0x7FF bits are the SubCount, 0xF800 bits are the AddressIncrement */
	MEIXmpServiceCommandMotorConfigOneOverN Command;
} MEIXmpMotorConfigOneOverN;

typedef struct
{	long BufferMemAddress;				/* Start of data in "Buffer" memory */
	long BufferMemConstant0;			/* = 1: Fixed value: NOT Configurable */
	long MaxPulseUnits;					/* Changes with SampleRate Only */
	long AdjustPeriod;					/* Changes with SampleRate Only */
} MEIXmpServiceCommandMotorConfigPulse0;
	
typedef struct
{	long Flags;					/* 0x7FF bits are the SubCount, 0xF800 bits are the AddressIncrement */
	MEIXmpServiceCommandMotorConfigPulse0 Command;
} MEIXmpMotorConfigPulse0;

typedef struct
{	long Address;						/* Last address so that Configuration is the last word written */
	long OutputA;
	long OutputB;
	long Threashold;					/* Based on SampleRate */
	long AccumulatorConstant0;			/* = (int)0xFFFF: Fixed value: NOT Configurable */
	long AccumulatorConstant1;			/* = (int)0xFFFE: Fixed value: NOT Configurable */
} MEIXmpServiceCommandMotorConfigPulse1;

typedef struct
{	long Flags;					/* 0x7FF bits are the SubCount, 0xF800 bits are the AddressIncrement */
	MEIXmpServiceCommandMotorConfigPulse1 Command;
} MEIXmpMotorConfigPulse1;

typedef struct
{	long Address;						/* Last address so that Configuration is the last word written */
	long Configuration;
} MEIXmpServiceCommandMotorConfigPulse2;

typedef struct
{	long Flags;					/* 0x7FF bits are the SubCount, 0xF800 bits are the AddressIncrement */
	MEIXmpServiceCommandMotorConfigPulse2 Command;
} MEIXmpMotorConfigPulse2;

typedef struct
{	long Address;
	long FaultStatus;					/* Read Only */
	long FaultMask;
	long Configuration;
} MEIXmpServiceCommandMotorConfigDedicatedIO;

typedef struct
{	long Flags;					/* 0x7FF bits are the SubCount, 0xF800 bits are the AddressIncrement */
	MEIXmpServiceCommandMotorConfigDedicatedIO Command;
} MEIXmpMotorConfigDedicatedIO;

typedef struct
{	long Address;
	long PinBlockConfig[MEIXmpFPGA_MAXPinBlocks];
} MEIXmpServiceCommandMotorConfigConfigurableIO;

typedef struct
{	long Flags;					/* 0x7FF bits are the SubCount, 0xF800 bits are the AddressIncrement */
	MEIXmpServiceCommandMotorConfigConfigurableIO Command;
} MEIXmpMotorConfigConfigurableIO;

typedef struct
{	long Address;
	long TriggerPattern;
	long TriggerMask;
	long TriggerControl;
} MEIXmpServiceCommandMotorConfigCapture;

typedef struct
{	long Flags;					/* 0x7FF bits are the SubCount, 0xF800 bits are the AddressIncrement */
	MEIXmpServiceCommandMotorConfigCapture Command;
} MEIXmpMotorConfigCapture;

typedef struct
{	long Address;
	long Data;
} MEIXmpServiceCommandMotorConfigCompare;

typedef struct
{	long Flags;					/* 0x7FF bits are the SubCount, 0xF800 bits are the AddressIncrement */
	MEIXmpServiceCommandMotorConfigCompare Command;
} MEIXmpMotorConfigCompare;

typedef struct
{	long Address;
	long Gain[MEIXmpFPGA_MAXADCs];
	long Configuration;
} MEIXmpServiceCommandMotorConfigADC;

typedef struct
{	long Flags;					/* 0x7FF bits are the SubCount, 0xF800 bits are the AddressIncrement */
	MEIXmpServiceCommandMotorConfigADC Command;
} MEIXmpMotorConfigADC;

#define MEIXmpMotorConfigCount			(15)	/* reflects the number of structures/commands (really Addresses) in MEIXmpMotorConfig */

typedef struct {
	MEIXmpMotorConfigFeedback			Feedback[MEIXmpMotorEncoders];
	MEIXmpMotorConfigFeedbackSample		FeedbackSample[MEIXmpMotorEncoders];
	MEIXmpMotorConfigFeedbackSSI		FeedbackSSI[MEIXmpMotorEncoders];
	MEIXmpMotorConfigDac7849			Dac7849;
	MEIXmpMotorConfigOneOverT			OneOverT;
	MEIXmpMotorConfigOneOverN			OneOverN;
	MEIXmpMotorConfigPulse0				Pulse0;
	MEIXmpMotorConfigPulse1				Pulse1;
	MEIXmpMotorConfigPulse2				Pulse2;	/* THIS MUST BE THE LAST PulseConfig because it sets the configuration word in the node's fpga */
	MEIXmpMotorConfigDedicatedIO		DedicatedIO;
	MEIXmpMotorConfigConfigurableIO		ConfigurableIO;
	MEIXmpMotorConfigADC				ADC;
} MEIXmpMotorConfig;

typedef struct {
	long					RegisterSets;
	long					*Status;
	long					Size;		/* (RegisterSets * depth of one RegisterSet) / 2 - data is 16 bit, but packed in 32 bit */
	long					*Data;
} MEIXmpProbe;

typedef struct {
	long	status;
	long	command;
	long	version;
	union	{
		long	option;		/* read-only */
		long	configFPGA;	/* write-only */
	} as;
	long	statusFPGA;
	long	adcConfig;
	long	reserved;
	long	diag;	/* BOB-REG */
} MEIXmpPld;

typedef struct {
	long	Version;										/* XMP:0x00550000 ZMP:0x7C000000 */
	long	DMA_Timer_Control;								/* XMP:0x00550001 ZMP:0x7C000004 */
	long	DMA_Tx_Timer;									/* XMP:0x00550002 ZMP:0x7C000008 */
	long	DMA_Rx_Timer;									/* XMP:0x00550003 ZMP:0x7C00000C */
	long	DMA_Continuous_Timer;							/* XMP:0x00550004 ZMP:0x7C000010 */
	long	MII_Tx_Timer;									/* XMP:0x00550005 ZMP:0x7C000014 */
	long	IO_Control;										/* XMP:0x00550006 ZMP:0x7C000018 */
	long	Rx_Copy_Timer;									/* XMP:0x00550007 ZMP:0x7C00001C */
	long	DMA_Tx_Control;									/* XMP:0x00550008 ZMP:0x7C000020 */
	long	*DMA_Tx_Chain_Ptr;								/* XMP:0x00550009 ZMP:0x7C000024 */
	long	Propagation_Delay;								/* XMP:0x0055000A ZMP:0x7C000028 */
	long	Test_Packet_Status;								/* XMP:0x0055000B ZMP:0x7C00002C */
	long	DMA_Rx_Control;									/* XMP:0x0055000C ZMP:0x7C000030 */
	long	*DMA_Rx_Chain_Ptr;								/* XMP:0x0055000D ZMP:0x7C000034 */
	long	BobBus;					/* For RinconZ - ZMP */	/* XMP:0x0055000E ZMP:0x7C000038 */
	long	Error_Inject;									/* XMP:0x0055000F ZMP:0x7C00003C */
	long	RxErr_Flags;									/* XMP:0x00550010 ZMP:0x7C000040 */
	long	OutPort_CRC_Counter;							/* XMP:0x00550011 ZMP:0x7C000044 */
	long	InPort_CRC_Counter;								/* XMP:0x00550012 ZMP:0x7C000048 */
	long	Tx_Packet_Gap;									/* XMP:0x00550013 ZMP:0x7C00004C */
	long	Network_State;									/* XMP:0x00550014 ZMP:0x7C000050 */
	long	Copy_CB_Ptr;			/* For RinconZ - ZMP */	/* XMP:0x00550015 ZMP:0x7C000054 */
	long	Reserved_0;										/* XMP:0x00550006 ZMP:0x7C000058 */
	long	Reserved_1;										/* XMP:0x00550007 ZMP:0x7C00005C */
	long	Restart_Request_Status;							/* XMP:0x00550018 ZMP:0x7C000060 */
	long	Reset_Complete_Status;							/* XMP:0x00550019 ZMP:0x7C000064 */
	long	Propagation_Control;							/* XMP:0x0055001A ZMP:0x7C000068 */
} MEIXmpRinconRegs;

/* ISquaredC stuff for ZMP */
typedef struct MEIXmpISquaredCRegs {
	long I2CADR;				/* Slave address of MC8254 if not the master */
	long I2CFDR;				/* Frequency divider reg */
	long I2CCR;					/* Control reg --- master/slave, tx/rx, etc... */
	long I2CSR;					/* Status reg */
	long I2CDR;					/* Data reg --- for tx and rx and address of slave with direction bit */
} MEIXmpISquaredCRegs;

typedef enum {
	MEIXmpISquaredCI2CCR_MEN = 0x80 << 24,		/* R/W 1 = module enabled */
	MEIXmpISquaredCI2CCR_MIEN = 0x40 << 24,		/* R/W 1 = module interrupt enabled */
	MEIXmpISquaredCI2CCR_MSTA = 0x20 << 24,		/* R/W 1 = master mode --- cleared (slave mode) when arbitration is lost */
	MEIXmpISquaredCI2CCR_MTX = 0x10 << 24,		/* R/W 1 = Tx mode, 0 = Rx mode */
	MEIXmpISquaredCI2CCR_TXAK = 0x08 << 24,		/* R/W 1 = no acknowledge, 0 = acknowledge --- state of SDA line on 9th clock */
	MEIXmpISquaredCI2CCR_RSTA = 0x04 << 24,		/* W   1 = Repeat START, 0 = no repeat START */
	MEIXmpISquaredCI2CCR_PCII = 0x02 << 24,		/* R/W 1 = all interrupts go to PCI Bus if MIEN and MIF are set, 0 goes to local processor */
	MEIXmpISquaredCI2CCR_BCST = 0x01 << 24		/* R/W 1 = acknowledge broadcast address (0), 0 = do not acknowledge broadcast address */
} MEIXmpISquaredCI2CCR;

typedef enum {
	MEIXmpISquaredCI2CSR_MCF = 0x80 << 24,		/* R   1 = transfer complete, 0 = transfer in progress */
	MEIXmpISquaredCI2CSR_MAAS = 0x40 << 24,		/* R   1 = controller is addressed as a slave from external master, 0 = not */
	MEIXmpISquaredCI2CSR_MBB = 0x20 << 24,		/* R   1 = I2C bus is busy, 0 = not */
	MEIXmpISquaredCI2CSR_MAL = 0x10 << 24,		/* R/W 1 = arbitration lost, 0 = not ---- only cleared by software */
	MEIXmpISquaredCI2CSR_BCA = 0x08 << 24,		/* R   1 = broadcast address has been accepted if I2CCR[BCST] bit is set */
	MEIXmpISquaredCI2CSR_SRW = 0x04 << 24,		/* R   1 = master read from slave, 0 = master write to slave --- state of R/W command in master's addressing of slave byte */
	MEIXmpISquaredCI2CSR_MIF = 0x02 << 24,		/* R/W 1 = interrupt pending, 0 = not */
	MEIXmpISquaredCI2CSR_RXAK = 0x01 << 24		/* R   1 = no acknowledge received, 0 - acknowledge received */
} MEIXmpISquaredCI2CSR;

typedef enum {
	MEIXmpISquaredCCommandNONE = 0,
	MEIXmpISquaredCCommandINIT = 1,
	MEIXmpISquaredCCommandWRITE = 2,
	MEIXmpISquaredCCommandREAD = 3,
	MEIXmpISquaredCCommandLAST = MEIXmpISquaredCCommandREAD
} MEIXmpISquaredCCommand;

typedef enum {
	MEIXmpISquaredCStateDONE = 0,
	MEIXmpISquaredCStateINIT = 1,
	MEIXmpISquaredCStateSTART = 2,
	MEIXmpISquaredCStateADDRESS = 3,
	MEIXmpISquaredCStateDATA_WRITE = 4,
	MEIXmpISquaredCStateDATA_READ_STOP = 5,
	MEIXmpISquaredCStateDATA_READ_RESTART = 6,
	MEIXmpISquaredCStateDATA_READ = 7,
	MEIXmpISquaredCStateSTOP = 8
} MEIXmpISquaredCState;

typedef struct MEIXmpISquaredC {
	long					SlaveAddress;
	long					Address;
	long					Data;
	MEIXmpISquaredCCommand	Command;
	MEIXmpISquaredCState	State;
	long					DelayCount;
} MEIXmpISquaredC;

typedef struct {
	struct {
		long Version;
	} Rincon;
	struct {
		long Version;
		long Option;
	} PLD;
} MEIXmpHWVersion;

/* SystemData{} */
typedef struct {
	long					*Ptr;
	long					Size;		/* number of words */
} MEIXmpSynqNetMechaWareBuffer;

typedef struct {
	MEIXmpServiceCommandGeneral	*Ptr;	/* Pointer to SynqNetServiceCommands for initialization, 
											this buffer should also include space for status */
	long						Size;	/* number of words */
} MEIXmpSynqNetConfigBufferASYNQ;

typedef struct {
	MEIXmpServiceCommandGeneral	*Ptr;	/* Pointer to SynqNetServiceCommands for initialization, 
											this buffer should also include space for status */
	long					Size;		/* number of words */
} MEIXmpSynqNetPacketBuffer;

typedef struct {
	MEIXmpFrame				*Ptr;
	long					Size;		/* number of words */
} MEIXmpFrameBuffer;

typedef struct {
	long					*Ptr;
	long					Size;		/* number of words */
} MEIXmpDataRecorderBuffer;

typedef struct {
	long					data;
} MEIXmpCompensationTableData;

typedef struct {
	MEIXmpCompensationTableData	*Ptr;
	long						Size;
} MEIXmpCompensationTableBuffer;

typedef struct MEIXmpNullData {
	long					Input[2];		/* big enough for 64 bit feedback */
	long					Output[2];		/* big enough to deal with step outputs (MEIXmpSynqNetMotor) */
} MEIXmpNullData;

typedef struct {						/* Structures in allocated external memory */
	MEIXmpSynqNetConfigBufferASYNQ	SynqNetConfigBufferASYNQ;
	MEIXmpSynqNetPacketBuffer		SynqNetPacketBuffer;
	MEIXmpSynqNetMechaWareBuffer	MechaWareBuffer;
	MEIXmpFrameBuffer				FrameBuffer[MEIXmpMAX_Axes];
	MEIXmpDataRecorderBuffer		DataRecorderBuffer[MEIXmpMAX_Recorders];
	MEIXmpCompensationTableBuffer	CompensationTableBuffer[MEIXmpMAX_Compensators];
	long							*DynamicMemStartInt;
	long							*DynamicMemStartExt;
} MEIXmpExtAlloc;

typedef enum {
	MEIXmpFeatureBitSTEPPER						= 0,
	MEIXmpFeatureBitCOMMUTATION					= 1,
	MEIXmpFeatureBitCOMPENSATION				= 2,
	MEIXmpFeatureBitGANTRY						= 3,
	MEIXmpFeatureBitENCODER_MODULO				= 4,
	MEIXmpFeatureBitENCODER_REVERSE_MODULO		= 5,
	MEIXmpFeatureBitENCODER_RATIO				= 6,
	MEIXmpFeatureBitELECTRONIC_GEAR				= 7,
	MEIXmpFeatureBitSYNQNET_TEST				= 8,
	MEIXmpFeatureBitPROGRAM_SEQUENCER			= 9,
	MEIXmpFeatureBitMW							= 10,
	MEIXmpFeatureBitCAM							= 11,
	MEIXmpFeatureBitSUBSAMPLE_GENERAL			= 12,
	MEIXmpFeatureBitSUBSAMPLE_CUSTOM41			= 13,
	MEIXmpFeatureBitSUBSAMPLE_CUSTOM40			= 14,
	MEIXmpFeatureBitBACKWARD_MOTION				= 15,
	MEIXmpFeatureBitMETRICS						= 16,
	MEIXmpFeatureBitTRIGGERED_MODIFY			= 17,
	MEIXmpFeatureBitJERK_TRAJECTORY_CALC		= 18,
	MEIXmpFeatureBitPRE_FILTER					= 19,
	MEIXmpFeatureBitPOST_FILTER					= 20,
	MEIXmpFeatureBitUSER_PROFILE				= 21,
	MEIXmpFeatureBitJERK_PERCENT_CALC			= 22
}MEIXmpFeatureBit;

typedef struct {
	long					ID;			/* Must remain at 0x28002 or NULL firmware will have a problem */
	long					Option;		/* Must remain at 0x28003 or NULL firmware will have a problem */
	long					BranchID;
	long					MechaWareVersion;
	long					ZMPBoot0Version;	/* Upper 16 bits = version, lower 16 bits = revision */
	long					ZMPZBootVersion;	/* Upper 16 bits = version, lower 16 bits = revision */
	long					CanInterfaceVersion;
	long					UserVersion;
	long					FeatureMask[MEIXmpFeatureMaskSize];
	long					FDK_Version;
} MEIXmpSoftware;

typedef struct {
	MEIXmpObjectMap	MotorMap;
	MEIXmpObjectMap	BlockMap;
	MEIXmpObjectMap	SecondaryEncoderMap;
} MEIXmpFlashObjectMap;

typedef struct  {
	long					Motors;
	long					Filters;
	long					Axes;
	long					MSs;
	long					PSs;
	long					PreFilters;
	long					Compensators;
	long					Recorders;
	long					Captures;
} MEIXmpEnabledCounts;

typedef struct {
	long					Period;			/* Set by MPI, 0 = disabled, 1 = every sample, 2 = every other sample, etc... */
	long					HostProcessFlag;/* Set by host when processing data, cleared by host when done */
	long					Flag;			/* Set by firmware, read by MPI: 1 = Heartbeat, 0 = not a heartbeat */
	long					HostProcessTime;/* Calculated by firmware for Host */
	long					Count;			/* Set by firmware */
} MEIXmpSyncInterrupt;

/* System Events and Status */
typedef enum MEIXmpSystemEvent {
	MEIXmpSystemEventHOST_PROCESS_TIME_EXCEEDED = 0,
	MEIXmpSystemEventFAN = 16
} MEIXmpSystemEvent;

typedef enum {
	MEIXmpSystemStatusHOST_PROCESS_TIME_EXCEEDED = (1 << MEIXmpSystemEventHOST_PROCESS_TIME_EXCEEDED),		/* 0x00001 */
	MEIXmpSystemStatusFAN = (1 << MEIXmpSystemEventFAN),													/* 0x10000 */

	MEIXmpSystemStatusFOREGROUND = (MEIXmpSystemStatusHOST_PROCESS_TIME_EXCEEDED),
	MEIXmpSystemStatusBACKGROUND = (MEIXmpSystemStatusFAN)
} MEIXmpSystemStatus;

typedef enum {
	MEIXmpSystemDataCopy64StateREADY = 0,
	MEIXmpSystemDataCopy64StateDONE = 1,
	MEIXmpSystemDataCopy64StateARMED = 2,
} MEIXmpSystemDataCopy64State;

typedef struct {
	MEIXmpSystemDataCopy64State	State;
	long						*Src;
	long						*Dst;
	long						Data[2];
} MEIXmpSystemDataCopy64;

typedef struct {
	long						Signature;	/* Must remain at 0x28000 or NULL firmware will have a problem */
	long						Disable;
	MEIXmpSoftware				Software;
	MEIXmpEnabledCounts			Enabled;
	long						SamplePeriod;
	long						SampleCounter;
	long						CountDelta;
	long						BackgroundCycle;
	long						MaxForegroundTime;
	long						MaxBackgroundTime;
	MEIXmpSystemStatus			ForegroundStatus;
	MEIXmpSystemStatus			ForegroundResetMask;
	MEIXmpSystemStatus			Status;
	MEIXmpHostSignal			*Signal;
	MEIXmpSyncInterrupt			SyncInterrupt;
	long						HostGate;
	long						Gate;
	MEIXmpControlIO				IO;
	MEIXmpSystemDataCopy64		Copy64;
	long						Reserved[4]; /* Ensure even cache boundaries */
} MEIXmpSystemData;

typedef enum {
	MEIXmpProcessorUNKNOWN = 0,
	MEIXmpProcessorSHARC,
	MEIXmpProcessorMPC8245
} MEIXmpProcessor;

typedef union {
	struct	{
		MEIXmpProcessor	Processor;
		long			ProcessorRevision;
		long			ProcessorSpeed;			/* MHz */
		long			InternalBusSpeed;		/* MHz */
		long			PciSpeed;				/* MHz */
		long			SramSize;				/* Bytes */
	} Zmp;
	struct	{
		MEIXmpProcessor	Processor;
	} Xmp;
} MEIXmpBoardInfo;

typedef struct {
	MEIXmpHWVersion			HWVersion;
	MEIXmpBoardInfo			BoardInfo;
	MEIXmpUserlabel			label;
	long					TxTime;						/* % of SamplePeriod */
	long					MinLatencyLimit;			/* uSec */
	long					FlashEnable;
	long					RecoderInUseMask;
	long					FPGAPreDownloadStatus;
	unsigned long 			FPGAPostDownloadStatus;
	MEIXmpFlashObjectMap	FlashObjectMap;				/* used by MPI */
	MEIXmpExtAlloc			ExtAlloc;
} MEIXmpSystemDataExternal;


typedef struct {
	long							ExtMemSize;
	long							Reserved[7]; /* Ensure even cache boundaries */
	long							LimitTable[MEIXmpLimitLookupSize];
	long							DedicatedLimitCount[MEIXmpMAX_Motors];
	MEIXmpMotorLimitDedicated		DedicatedLimit[MEIXmpMAX_Motors];
	long							UserLimitCount[MEIXmpMAX_Motors];
	MEIXmpMotorLimitUser			UserLimit[MEIXmpMAX_Motors];                                                       
	MEIXmpDomain					Domain[MEIXmpMAX_Domains];                                                          
	MEIXmpLinkBuffer				LinkBuffer;                                                                         
	MEIXmpPoint						PointBuffer[MEIXmpMAX_Axes];
	MEIXmpPoint						TriggeredModifyPointBuffer[MEIXmpMAX_Axes];
	MEIXmpHostSignalBuffer			HostSignalBuffer;                                                                   
	MEIXmpMessage					HostMessageBuffer[MEIXmpMAX_MESSAGES];                                              
	MEIXmpSystemDataExternal		SystemData;
	MEIXmpMotorExternal				Motor[MEIXmpMAX_Motors];
	MEIXmpFilterExternal			Filter[MEIXmpMAX_Filters];
	MEIXmpAxisExternal				Axis[MEIXmpMAX_Axes];
	MEIXmpMotionSupervisorExternal	MS[MEIXmpMAX_MSs];
	MEIXmpCommandBuffer				CommandBuffer;                                                                      
	float							CommutationTable[MEIXmpCOMM_TABLE_SIZE];                                            
	MEIXmpUserBuffer				UserBuffer;                                                                         
	MEIXmpPreFilter					PreFilter[MEIXmpMAX_PreFilters];                                                    
	MEIXmpCustomBuffer				CustomBuffer;                                                                       
	MEIXmpProbe						Probe[MEIXmpMAX_Probes];                                                            
	MEIXmpBlockConfig				BlockConfig[MEIXmpMaxMotionBlocks];                                                 
	MEIXmpMotorConfig				MotorConfig[MEIXmpMAX_Motors];                                                      
	MEIXmpBlock						Block[MEIXmpMaxMotionBlocks];
	MEIXmpRecorderExternal			Recorder[MEIXmpMAX_Recorders];
	MEIXmpSynqNet					SynqNet;		/* May need to be dynamically allocated in future */                
	MEIXmpISquaredC					ISquaredC;
	MEIXmpFrame						NullFrame;
	long							VolatileBuffer[MEIXmpVolatileBufferSize];	/* for user - basically scratch pad memory that gets reset at powerup/reset - could be stored in flash */
} MEIXmpBufferData;

typedef struct {
	long						*RinconSynqDataInternal;	/* variable size */
	long						RinconSynqDataInternalValid;	/* if valid, do not remap */
	long						*RinconSynqDataExternal;	/* variable size */
	long						RinconSynqDataSize;
	float						s1;
	MEIXmpBufferData			*BufferData;
	struct MEIXmpRinconAsynq	*RinconAsynqData;			/* fixed size */
	struct MEIXmpSynqNetCopy	*SynqNetCopy;				/* fixed size */
	long						*RinconDMA;					/* variable size */
	long						RinconDMASize;
	MEIXmpPld					*PLD;
	MEIXmpRinconRegs			*Rincon;
	long						*RinconUpstreamFaultThreashold;
	long						*RinconUpstreamFailThreashold;
	long						*RinconUpstreamErrorCounter;
	long						*RinconUpstreamErrorRateCounter;
	long						Reserved[64];
} MEIXmpInternalData;

typedef struct {
	MEIXmpSystemData			SystemData;                            
	MEIXmpMotor					Motor[MEIXmpMAX_Motors];               
	MEIXmpControlLaw			ControlLaw;
	MEIXmpAxis					Axis[MEIXmpMAX_Axes];                  
	MEIXmpProgramSequencer		PS[MEIXmpMAX_PSs];                     
	MEIXmpMotionSupervisor		MS[MEIXmpMAX_MSs];                     
	MEIXmpHostMessage			HostMessage;                           
	MEIXmpDataRecorder			Recorder[MEIXmpMAX_Recorders];         
	MEIXmpCompensator			Compensator[MEIXmpMAX_Compensators];   
	MEIXmpSignalGenerator		TestSignal;                            
	MEIXmpCapture				Capture[MEIXmpMaxCaptures];            
	MEIXmpInternalData			Internal;                              
	MEIXmpNullData				Null;                                  
} MEIXmpData;

#if defined(__cplusplus)
}
#endif

#endif /* __MEI_XMP__ */
